// Generated by gencpp from file foxglove_msgs/Grid.msg
// DO NOT EDIT!


#ifndef FOXGLOVE_MSGS_MESSAGE_GRID_H
#define FOXGLOVE_MSGS_MESSAGE_GRID_H


#include <string>
#include <vector>
#include <memory>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <geometry_msgs/Pose.h>
#include <foxglove_msgs/Vector2.h>
#include <foxglove_msgs/PackedElementField.h>

namespace foxglove_msgs
{
template <class ContainerAllocator>
struct Grid_
{
  typedef Grid_<ContainerAllocator> Type;

  Grid_()
    : timestamp()
    , frame_id()
    , pose()
    , column_count(0)
    , cell_size()
    , row_stride(0)
    , cell_stride(0)
    , fields()
    , data()  {
    }
  Grid_(const ContainerAllocator& _alloc)
    : timestamp()
    , frame_id(_alloc)
    , pose(_alloc)
    , column_count(0)
    , cell_size(_alloc)
    , row_stride(0)
    , cell_stride(0)
    , fields(_alloc)
    , data(_alloc)  {
  (void)_alloc;
    }



   typedef ros::Time _timestamp_type;
  _timestamp_type timestamp;

   typedef std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> _frame_id_type;
  _frame_id_type frame_id;

   typedef  ::geometry_msgs::Pose_<ContainerAllocator>  _pose_type;
  _pose_type pose;

   typedef uint32_t _column_count_type;
  _column_count_type column_count;

   typedef  ::foxglove_msgs::Vector2_<ContainerAllocator>  _cell_size_type;
  _cell_size_type cell_size;

   typedef uint32_t _row_stride_type;
  _row_stride_type row_stride;

   typedef uint32_t _cell_stride_type;
  _cell_stride_type cell_stride;

   typedef std::vector< ::foxglove_msgs::PackedElementField_<ContainerAllocator> , typename std::allocator_traits<ContainerAllocator>::template rebind_alloc< ::foxglove_msgs::PackedElementField_<ContainerAllocator> >> _fields_type;
  _fields_type fields;

   typedef std::vector<uint8_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<uint8_t>> _data_type;
  _data_type data;





  typedef boost::shared_ptr< ::foxglove_msgs::Grid_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::foxglove_msgs::Grid_<ContainerAllocator> const> ConstPtr;

}; // struct Grid_

typedef ::foxglove_msgs::Grid_<std::allocator<void> > Grid;

typedef boost::shared_ptr< ::foxglove_msgs::Grid > GridPtr;
typedef boost::shared_ptr< ::foxglove_msgs::Grid const> GridConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::foxglove_msgs::Grid_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::foxglove_msgs::Grid_<ContainerAllocator> >::stream(s, "", v);
return s;
}


template<typename ContainerAllocator1, typename ContainerAllocator2>
bool operator==(const ::foxglove_msgs::Grid_<ContainerAllocator1> & lhs, const ::foxglove_msgs::Grid_<ContainerAllocator2> & rhs)
{
  return lhs.timestamp == rhs.timestamp &&
    lhs.frame_id == rhs.frame_id &&
    lhs.pose == rhs.pose &&
    lhs.column_count == rhs.column_count &&
    lhs.cell_size == rhs.cell_size &&
    lhs.row_stride == rhs.row_stride &&
    lhs.cell_stride == rhs.cell_stride &&
    lhs.fields == rhs.fields &&
    lhs.data == rhs.data;
}

template<typename ContainerAllocator1, typename ContainerAllocator2>
bool operator!=(const ::foxglove_msgs::Grid_<ContainerAllocator1> & lhs, const ::foxglove_msgs::Grid_<ContainerAllocator2> & rhs)
{
  return !(lhs == rhs);
}


} // namespace foxglove_msgs

namespace ros
{
namespace message_traits
{





template <class ContainerAllocator>
struct IsFixedSize< ::foxglove_msgs::Grid_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::foxglove_msgs::Grid_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::foxglove_msgs::Grid_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::foxglove_msgs::Grid_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::foxglove_msgs::Grid_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::foxglove_msgs::Grid_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::foxglove_msgs::Grid_<ContainerAllocator> >
{
  static const char* value()
  {
    return "ff812efab6fae28f163999277c175522";
  }

  static const char* value(const ::foxglove_msgs::Grid_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xff812efab6fae28fULL;
  static const uint64_t static_value2 = 0x163999277c175522ULL;
};

template<class ContainerAllocator>
struct DataType< ::foxglove_msgs::Grid_<ContainerAllocator> >
{
  static const char* value()
  {
    return "foxglove_msgs/Grid";
  }

  static const char* value(const ::foxglove_msgs::Grid_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::foxglove_msgs::Grid_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# foxglove_msgs/Grid\n"
"# A 2D grid of data\n"
"\n"
"# Generated by https://github.com/foxglove/schemas\n"
"\n"
"# Timestamp of grid\n"
"time timestamp\n"
"\n"
"# Frame of reference\n"
"string frame_id\n"
"\n"
"# Origin of grid's corner relative to frame of reference; grid is positioned in the x-y plane relative to this origin\n"
"geometry_msgs/Pose pose\n"
"\n"
"# Number of grid columns\n"
"uint32 column_count\n"
"\n"
"# Size of single grid cell along x and y axes, relative to `pose`\n"
"foxglove_msgs/Vector2 cell_size\n"
"\n"
"# Number of bytes between rows in `data`\n"
"uint32 row_stride\n"
"\n"
"# Number of bytes between cells within a row in `data`\n"
"uint32 cell_stride\n"
"\n"
"# Fields in `data`\n"
"foxglove_msgs/PackedElementField[] fields\n"
"\n"
"# Grid cell data, interpreted using `fields`, in row-major (y-major) order\n"
"uint8[] data\n"
"\n"
"================================================================================\n"
"MSG: geometry_msgs/Pose\n"
"# A representation of pose in free space, composed of position and orientation. \n"
"Point position\n"
"Quaternion orientation\n"
"\n"
"================================================================================\n"
"MSG: geometry_msgs/Point\n"
"# This contains the position of a point in free space\n"
"float64 x\n"
"float64 y\n"
"float64 z\n"
"\n"
"================================================================================\n"
"MSG: geometry_msgs/Quaternion\n"
"# This represents an orientation in free space in quaternion form.\n"
"\n"
"float64 x\n"
"float64 y\n"
"float64 z\n"
"float64 w\n"
"\n"
"================================================================================\n"
"MSG: foxglove_msgs/Vector2\n"
"# foxglove_msgs/Vector2\n"
"# A vector in 2D space that represents a direction only\n"
"\n"
"# Generated by https://github.com/foxglove/schemas\n"
"\n"
"# x coordinate length\n"
"float64 x\n"
"\n"
"# y coordinate length\n"
"float64 y\n"
"\n"
"================================================================================\n"
"MSG: foxglove_msgs/PackedElementField\n"
"# foxglove_msgs/PackedElementField\n"
"# A field present within each element in a byte array of packed elements.\n"
"\n"
"# Generated by https://github.com/foxglove/schemas\n"
"\n"
"# Name of the field\n"
"string name\n"
"\n"
"# Byte offset from start of data buffer\n"
"uint32 offset\n"
"\n"
"uint8 UNKNOWN=0\n"
"uint8 UINT8=1\n"
"uint8 INT8=2\n"
"uint8 UINT16=3\n"
"uint8 INT16=4\n"
"uint8 UINT32=5\n"
"uint8 INT32=6\n"
"uint8 FLOAT32=7\n"
"uint8 FLOAT64=8\n"
"\n"
"# Type of data in the field. Integers are stored using little-endian byte order.\n"
"uint8 type\n"
;
  }

  static const char* value(const ::foxglove_msgs::Grid_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::foxglove_msgs::Grid_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.timestamp);
      stream.next(m.frame_id);
      stream.next(m.pose);
      stream.next(m.column_count);
      stream.next(m.cell_size);
      stream.next(m.row_stride);
      stream.next(m.cell_stride);
      stream.next(m.fields);
      stream.next(m.data);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER
  }; // struct Grid_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::foxglove_msgs::Grid_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::foxglove_msgs::Grid_<ContainerAllocator>& v)
  {
    s << indent << "timestamp: ";
    Printer<ros::Time>::stream(s, indent + "  ", v.timestamp);
    s << indent << "frame_id: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>>::stream(s, indent + "  ", v.frame_id);
    s << indent << "pose: ";
    s << std::endl;
    Printer< ::geometry_msgs::Pose_<ContainerAllocator> >::stream(s, indent + "  ", v.pose);
    s << indent << "column_count: ";
    Printer<uint32_t>::stream(s, indent + "  ", v.column_count);
    s << indent << "cell_size: ";
    s << std::endl;
    Printer< ::foxglove_msgs::Vector2_<ContainerAllocator> >::stream(s, indent + "  ", v.cell_size);
    s << indent << "row_stride: ";
    Printer<uint32_t>::stream(s, indent + "  ", v.row_stride);
    s << indent << "cell_stride: ";
    Printer<uint32_t>::stream(s, indent + "  ", v.cell_stride);
    s << indent << "fields[]" << std::endl;
    for (size_t i = 0; i < v.fields.size(); ++i)
    {
      s << indent << "  fields[" << i << "]: ";
      s << std::endl;
      s << indent;
      Printer< ::foxglove_msgs::PackedElementField_<ContainerAllocator> >::stream(s, indent + "    ", v.fields[i]);
    }
    s << indent << "data[]" << std::endl;
    for (size_t i = 0; i < v.data.size(); ++i)
    {
      s << indent << "  data[" << i << "]: ";
      Printer<uint8_t>::stream(s, indent + "  ", v.data[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // FOXGLOVE_MSGS_MESSAGE_GRID_H
