// Generated by gencpp from file foxglove_msgs/LaserScan.msg
// DO NOT EDIT!


#ifndef FOXGLOVE_MSGS_MESSAGE_LASERSCAN_H
#define FOXGLOVE_MSGS_MESSAGE_LASERSCAN_H


#include <string>
#include <vector>
#include <memory>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <geometry_msgs/Pose.h>

namespace foxglove_msgs
{
template <class ContainerAllocator>
struct LaserScan_
{
  typedef LaserScan_<ContainerAllocator> Type;

  LaserScan_()
    : timestamp()
    , frame_id()
    , pose()
    , start_angle(0.0)
    , end_angle(0.0)
    , ranges()
    , intensities()  {
    }
  LaserScan_(const ContainerAllocator& _alloc)
    : timestamp()
    , frame_id(_alloc)
    , pose(_alloc)
    , start_angle(0.0)
    , end_angle(0.0)
    , ranges(_alloc)
    , intensities(_alloc)  {
  (void)_alloc;
    }



   typedef ros::Time _timestamp_type;
  _timestamp_type timestamp;

   typedef std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> _frame_id_type;
  _frame_id_type frame_id;

   typedef  ::geometry_msgs::Pose_<ContainerAllocator>  _pose_type;
  _pose_type pose;

   typedef double _start_angle_type;
  _start_angle_type start_angle;

   typedef double _end_angle_type;
  _end_angle_type end_angle;

   typedef std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>> _ranges_type;
  _ranges_type ranges;

   typedef std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>> _intensities_type;
  _intensities_type intensities;





  typedef boost::shared_ptr< ::foxglove_msgs::LaserScan_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::foxglove_msgs::LaserScan_<ContainerAllocator> const> ConstPtr;

}; // struct LaserScan_

typedef ::foxglove_msgs::LaserScan_<std::allocator<void> > LaserScan;

typedef boost::shared_ptr< ::foxglove_msgs::LaserScan > LaserScanPtr;
typedef boost::shared_ptr< ::foxglove_msgs::LaserScan const> LaserScanConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::foxglove_msgs::LaserScan_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::foxglove_msgs::LaserScan_<ContainerAllocator> >::stream(s, "", v);
return s;
}


template<typename ContainerAllocator1, typename ContainerAllocator2>
bool operator==(const ::foxglove_msgs::LaserScan_<ContainerAllocator1> & lhs, const ::foxglove_msgs::LaserScan_<ContainerAllocator2> & rhs)
{
  return lhs.timestamp == rhs.timestamp &&
    lhs.frame_id == rhs.frame_id &&
    lhs.pose == rhs.pose &&
    lhs.start_angle == rhs.start_angle &&
    lhs.end_angle == rhs.end_angle &&
    lhs.ranges == rhs.ranges &&
    lhs.intensities == rhs.intensities;
}

template<typename ContainerAllocator1, typename ContainerAllocator2>
bool operator!=(const ::foxglove_msgs::LaserScan_<ContainerAllocator1> & lhs, const ::foxglove_msgs::LaserScan_<ContainerAllocator2> & rhs)
{
  return !(lhs == rhs);
}


} // namespace foxglove_msgs

namespace ros
{
namespace message_traits
{





template <class ContainerAllocator>
struct IsFixedSize< ::foxglove_msgs::LaserScan_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::foxglove_msgs::LaserScan_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::foxglove_msgs::LaserScan_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::foxglove_msgs::LaserScan_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::foxglove_msgs::LaserScan_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::foxglove_msgs::LaserScan_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::foxglove_msgs::LaserScan_<ContainerAllocator> >
{
  static const char* value()
  {
    return "38d9665acff9bd72043c5a392c9213a4";
  }

  static const char* value(const ::foxglove_msgs::LaserScan_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x38d9665acff9bd72ULL;
  static const uint64_t static_value2 = 0x043c5a392c9213a4ULL;
};

template<class ContainerAllocator>
struct DataType< ::foxglove_msgs::LaserScan_<ContainerAllocator> >
{
  static const char* value()
  {
    return "foxglove_msgs/LaserScan";
  }

  static const char* value(const ::foxglove_msgs::LaserScan_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::foxglove_msgs::LaserScan_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# foxglove_msgs/LaserScan\n"
"# A single scan from a planar laser range-finder\n"
"\n"
"# Generated by https://github.com/foxglove/schemas\n"
"\n"
"# Timestamp of scan\n"
"time timestamp\n"
"\n"
"# Frame of reference\n"
"string frame_id\n"
"\n"
"# Origin of scan relative to frame of reference; points are positioned in the x-y plane relative to this origin; angles are interpreted as counterclockwise rotations around the z axis with 0 rad being in the +x direction\n"
"geometry_msgs/Pose pose\n"
"\n"
"# Bearing of first point, in radians\n"
"float64 start_angle\n"
"\n"
"# Bearing of last point, in radians\n"
"float64 end_angle\n"
"\n"
"# Distance of detections from origin; assumed to be at equally-spaced angles between `start_angle` and `end_angle`\n"
"float64[] ranges\n"
"\n"
"# Intensity of detections\n"
"float64[] intensities\n"
"\n"
"================================================================================\n"
"MSG: geometry_msgs/Pose\n"
"# A representation of pose in free space, composed of position and orientation. \n"
"Point position\n"
"Quaternion orientation\n"
"\n"
"================================================================================\n"
"MSG: geometry_msgs/Point\n"
"# This contains the position of a point in free space\n"
"float64 x\n"
"float64 y\n"
"float64 z\n"
"\n"
"================================================================================\n"
"MSG: geometry_msgs/Quaternion\n"
"# This represents an orientation in free space in quaternion form.\n"
"\n"
"float64 x\n"
"float64 y\n"
"float64 z\n"
"float64 w\n"
;
  }

  static const char* value(const ::foxglove_msgs::LaserScan_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::foxglove_msgs::LaserScan_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.timestamp);
      stream.next(m.frame_id);
      stream.next(m.pose);
      stream.next(m.start_angle);
      stream.next(m.end_angle);
      stream.next(m.ranges);
      stream.next(m.intensities);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER
  }; // struct LaserScan_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::foxglove_msgs::LaserScan_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::foxglove_msgs::LaserScan_<ContainerAllocator>& v)
  {
    s << indent << "timestamp: ";
    Printer<ros::Time>::stream(s, indent + "  ", v.timestamp);
    s << indent << "frame_id: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>>::stream(s, indent + "  ", v.frame_id);
    s << indent << "pose: ";
    s << std::endl;
    Printer< ::geometry_msgs::Pose_<ContainerAllocator> >::stream(s, indent + "  ", v.pose);
    s << indent << "start_angle: ";
    Printer<double>::stream(s, indent + "  ", v.start_angle);
    s << indent << "end_angle: ";
    Printer<double>::stream(s, indent + "  ", v.end_angle);
    s << indent << "ranges[]" << std::endl;
    for (size_t i = 0; i < v.ranges.size(); ++i)
    {
      s << indent << "  ranges[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.ranges[i]);
    }
    s << indent << "intensities[]" << std::endl;
    for (size_t i = 0; i < v.intensities.size(); ++i)
    {
      s << indent << "  intensities[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.intensities[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // FOXGLOVE_MSGS_MESSAGE_LASERSCAN_H
