// Generated by gencpp from file foxglove_msgs/PointCloud.msg
// DO NOT EDIT!


#ifndef FOXGLOVE_MSGS_MESSAGE_POINTCLOUD_H
#define FOXGLOVE_MSGS_MESSAGE_POINTCLOUD_H


#include <string>
#include <vector>
#include <memory>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <geometry_msgs/Pose.h>
#include <foxglove_msgs/PackedElementField.h>

namespace foxglove_msgs
{
template <class ContainerAllocator>
struct PointCloud_
{
  typedef PointCloud_<ContainerAllocator> Type;

  PointCloud_()
    : timestamp()
    , frame_id()
    , pose()
    , point_stride(0)
    , fields()
    , data()  {
    }
  PointCloud_(const ContainerAllocator& _alloc)
    : timestamp()
    , frame_id(_alloc)
    , pose(_alloc)
    , point_stride(0)
    , fields(_alloc)
    , data(_alloc)  {
  (void)_alloc;
    }



   typedef ros::Time _timestamp_type;
  _timestamp_type timestamp;

   typedef std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> _frame_id_type;
  _frame_id_type frame_id;

   typedef  ::geometry_msgs::Pose_<ContainerAllocator>  _pose_type;
  _pose_type pose;

   typedef uint32_t _point_stride_type;
  _point_stride_type point_stride;

   typedef std::vector< ::foxglove_msgs::PackedElementField_<ContainerAllocator> , typename std::allocator_traits<ContainerAllocator>::template rebind_alloc< ::foxglove_msgs::PackedElementField_<ContainerAllocator> >> _fields_type;
  _fields_type fields;

   typedef std::vector<uint8_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<uint8_t>> _data_type;
  _data_type data;





  typedef boost::shared_ptr< ::foxglove_msgs::PointCloud_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::foxglove_msgs::PointCloud_<ContainerAllocator> const> ConstPtr;

}; // struct PointCloud_

typedef ::foxglove_msgs::PointCloud_<std::allocator<void> > PointCloud;

typedef boost::shared_ptr< ::foxglove_msgs::PointCloud > PointCloudPtr;
typedef boost::shared_ptr< ::foxglove_msgs::PointCloud const> PointCloudConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::foxglove_msgs::PointCloud_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::foxglove_msgs::PointCloud_<ContainerAllocator> >::stream(s, "", v);
return s;
}


template<typename ContainerAllocator1, typename ContainerAllocator2>
bool operator==(const ::foxglove_msgs::PointCloud_<ContainerAllocator1> & lhs, const ::foxglove_msgs::PointCloud_<ContainerAllocator2> & rhs)
{
  return lhs.timestamp == rhs.timestamp &&
    lhs.frame_id == rhs.frame_id &&
    lhs.pose == rhs.pose &&
    lhs.point_stride == rhs.point_stride &&
    lhs.fields == rhs.fields &&
    lhs.data == rhs.data;
}

template<typename ContainerAllocator1, typename ContainerAllocator2>
bool operator!=(const ::foxglove_msgs::PointCloud_<ContainerAllocator1> & lhs, const ::foxglove_msgs::PointCloud_<ContainerAllocator2> & rhs)
{
  return !(lhs == rhs);
}


} // namespace foxglove_msgs

namespace ros
{
namespace message_traits
{





template <class ContainerAllocator>
struct IsFixedSize< ::foxglove_msgs::PointCloud_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::foxglove_msgs::PointCloud_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::foxglove_msgs::PointCloud_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::foxglove_msgs::PointCloud_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::foxglove_msgs::PointCloud_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::foxglove_msgs::PointCloud_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::foxglove_msgs::PointCloud_<ContainerAllocator> >
{
  static const char* value()
  {
    return "46355bb42c332657eb232925c4a8f134";
  }

  static const char* value(const ::foxglove_msgs::PointCloud_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x46355bb42c332657ULL;
  static const uint64_t static_value2 = 0xeb232925c4a8f134ULL;
};

template<class ContainerAllocator>
struct DataType< ::foxglove_msgs::PointCloud_<ContainerAllocator> >
{
  static const char* value()
  {
    return "foxglove_msgs/PointCloud";
  }

  static const char* value(const ::foxglove_msgs::PointCloud_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::foxglove_msgs::PointCloud_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# foxglove_msgs/PointCloud\n"
"# A collection of N-dimensional points, which may contain additional fields with information like normals, intensity, etc.\n"
"\n"
"# Generated by https://github.com/foxglove/schemas\n"
"\n"
"# Timestamp of point cloud\n"
"time timestamp\n"
"\n"
"# Frame of reference\n"
"string frame_id\n"
"\n"
"# The origin of the point cloud relative to the frame of reference\n"
"geometry_msgs/Pose pose\n"
"\n"
"# Number of bytes between points in the `data`\n"
"uint32 point_stride\n"
"\n"
"# Fields in the `data`\n"
"foxglove_msgs/PackedElementField[] fields\n"
"\n"
"# Point data, interpreted using `fields`\n"
"uint8[] data\n"
"\n"
"================================================================================\n"
"MSG: geometry_msgs/Pose\n"
"# A representation of pose in free space, composed of position and orientation. \n"
"Point position\n"
"Quaternion orientation\n"
"\n"
"================================================================================\n"
"MSG: geometry_msgs/Point\n"
"# This contains the position of a point in free space\n"
"float64 x\n"
"float64 y\n"
"float64 z\n"
"\n"
"================================================================================\n"
"MSG: geometry_msgs/Quaternion\n"
"# This represents an orientation in free space in quaternion form.\n"
"\n"
"float64 x\n"
"float64 y\n"
"float64 z\n"
"float64 w\n"
"\n"
"================================================================================\n"
"MSG: foxglove_msgs/PackedElementField\n"
"# foxglove_msgs/PackedElementField\n"
"# A field present within each element in a byte array of packed elements.\n"
"\n"
"# Generated by https://github.com/foxglove/schemas\n"
"\n"
"# Name of the field\n"
"string name\n"
"\n"
"# Byte offset from start of data buffer\n"
"uint32 offset\n"
"\n"
"uint8 UNKNOWN=0\n"
"uint8 UINT8=1\n"
"uint8 INT8=2\n"
"uint8 UINT16=3\n"
"uint8 INT16=4\n"
"uint8 UINT32=5\n"
"uint8 INT32=6\n"
"uint8 FLOAT32=7\n"
"uint8 FLOAT64=8\n"
"\n"
"# Type of data in the field. Integers are stored using little-endian byte order.\n"
"uint8 type\n"
;
  }

  static const char* value(const ::foxglove_msgs::PointCloud_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::foxglove_msgs::PointCloud_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.timestamp);
      stream.next(m.frame_id);
      stream.next(m.pose);
      stream.next(m.point_stride);
      stream.next(m.fields);
      stream.next(m.data);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER
  }; // struct PointCloud_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::foxglove_msgs::PointCloud_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::foxglove_msgs::PointCloud_<ContainerAllocator>& v)
  {
    s << indent << "timestamp: ";
    Printer<ros::Time>::stream(s, indent + "  ", v.timestamp);
    s << indent << "frame_id: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>>::stream(s, indent + "  ", v.frame_id);
    s << indent << "pose: ";
    s << std::endl;
    Printer< ::geometry_msgs::Pose_<ContainerAllocator> >::stream(s, indent + "  ", v.pose);
    s << indent << "point_stride: ";
    Printer<uint32_t>::stream(s, indent + "  ", v.point_stride);
    s << indent << "fields[]" << std::endl;
    for (size_t i = 0; i < v.fields.size(); ++i)
    {
      s << indent << "  fields[" << i << "]: ";
      s << std::endl;
      s << indent;
      Printer< ::foxglove_msgs::PackedElementField_<ContainerAllocator> >::stream(s, indent + "    ", v.fields[i]);
    }
    s << indent << "data[]" << std::endl;
    for (size_t i = 0; i < v.data.size(); ++i)
    {
      s << indent << "  data[" << i << "]: ";
      Printer<uint8_t>::stream(s, indent + "  ", v.data[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // FOXGLOVE_MSGS_MESSAGE_POINTCLOUD_H
