# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from foxglove_msgs/ArrowMarker.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import foxglove_msgs.msg
import geometry_msgs.msg

class ArrowMarker(genpy.Message):
  _md5sum = "c36d6b56f540801b30bba0c2c010f78e"
  _type = "foxglove_msgs/ArrowMarker"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# foxglove_msgs/ArrowMarker
# A marker representing an arrow

# Generated by https://github.com/foxglove/schemas

# Position of the arrow's tail and orientation of the arrow. Identity orientation means the arrow points in the +x direction.
geometry_msgs/Pose pose

# Length of the arrow
float64 length

# Diameter of the arrow shaft
float64 shaft_diameter

# Diameter of the arrow head
float64 head_diameter

# Length of the arrow head
float64 head_length

# Color of the arrow
foxglove_msgs/Color color

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of position and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: foxglove_msgs/Color
# foxglove_msgs/Color
# A color in RGBA format

# Generated by https://github.com/foxglove/schemas

# Red value between 0 and 1
float64 r

# Green value between 0 and 1
float64 g

# Blue value between 0 and 1
float64 b

# Alpha value between 0 and 1
float64 a
"""
  __slots__ = ['pose','length','shaft_diameter','head_diameter','head_length','color']
  _slot_types = ['geometry_msgs/Pose','float64','float64','float64','float64','foxglove_msgs/Color']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       pose,length,shaft_diameter,head_diameter,head_length,color

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ArrowMarker, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.pose is None:
        self.pose = geometry_msgs.msg.Pose()
      if self.length is None:
        self.length = 0.
      if self.shaft_diameter is None:
        self.shaft_diameter = 0.
      if self.head_diameter is None:
        self.head_diameter = 0.
      if self.head_length is None:
        self.head_length = 0.
      if self.color is None:
        self.color = foxglove_msgs.msg.Color()
    else:
      self.pose = geometry_msgs.msg.Pose()
      self.length = 0.
      self.shaft_diameter = 0.
      self.head_diameter = 0.
      self.head_length = 0.
      self.color = foxglove_msgs.msg.Color()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_15d().pack(_x.pose.position.x, _x.pose.position.y, _x.pose.position.z, _x.pose.orientation.x, _x.pose.orientation.y, _x.pose.orientation.z, _x.pose.orientation.w, _x.length, _x.shaft_diameter, _x.head_diameter, _x.head_length, _x.color.r, _x.color.g, _x.color.b, _x.color.a))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.pose is None:
        self.pose = geometry_msgs.msg.Pose()
      if self.color is None:
        self.color = foxglove_msgs.msg.Color()
      end = 0
      _x = self
      start = end
      end += 120
      (_x.pose.position.x, _x.pose.position.y, _x.pose.position.z, _x.pose.orientation.x, _x.pose.orientation.y, _x.pose.orientation.z, _x.pose.orientation.w, _x.length, _x.shaft_diameter, _x.head_diameter, _x.head_length, _x.color.r, _x.color.g, _x.color.b, _x.color.a,) = _get_struct_15d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_15d().pack(_x.pose.position.x, _x.pose.position.y, _x.pose.position.z, _x.pose.orientation.x, _x.pose.orientation.y, _x.pose.orientation.z, _x.pose.orientation.w, _x.length, _x.shaft_diameter, _x.head_diameter, _x.head_length, _x.color.r, _x.color.g, _x.color.b, _x.color.a))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.pose is None:
        self.pose = geometry_msgs.msg.Pose()
      if self.color is None:
        self.color = foxglove_msgs.msg.Color()
      end = 0
      _x = self
      start = end
      end += 120
      (_x.pose.position.x, _x.pose.position.y, _x.pose.position.z, _x.pose.orientation.x, _x.pose.orientation.y, _x.pose.orientation.z, _x.pose.orientation.w, _x.length, _x.shaft_diameter, _x.head_diameter, _x.head_length, _x.color.r, _x.color.g, _x.color.b, _x.color.a,) = _get_struct_15d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_15d = None
def _get_struct_15d():
    global _struct_15d
    if _struct_15d is None:
        _struct_15d = struct.Struct("<15d")
    return _struct_15d
