# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from foxglove_msgs/ConeAttributes.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import foxglove_msgs.msg
import geometry_msgs.msg

class ConeAttributes(genpy.Message):
  _md5sum = "95a94410f04d20228465a960c3c3f66f"
  _type = "foxglove_msgs/ConeAttributes"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# foxglove_msgs/ConeAttributes
# Data specifying the visual appearance of a possibly truncated, possibly elliptic cone or cylinder

# Generated by https://github.com/foxglove/schemas

# Position of the center of the cone and orientation of the cone. The flat face(s) are perpendicular to the z-axis.
geometry_msgs/Pose pose

# Size of the cone's bounding box
geometry_msgs/Vector3 size

# 0-1, size of the cone's bottom face (min z) relative to the bottom of the bounding box
float64 bottom_scale

# 0-1, size of the cone's top face (max z) relative to the top of the bounding box
float64 top_scale

# Color of the cone
foxglove_msgs/Color color

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of position and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 
# It is only meant to represent a direction. Therefore, it does not
# make sense to apply a translation to it (e.g., when applying a 
# generic rigid transformation to a Vector3, tf2 will only apply the
# rotation). If you want your data to be translatable too, use the
# geometry_msgs/Point message instead.

float64 x
float64 y
float64 z
================================================================================
MSG: foxglove_msgs/Color
# foxglove_msgs/Color
# A color in RGBA format

# Generated by https://github.com/foxglove/schemas

# Red value between 0 and 1
float64 r

# Green value between 0 and 1
float64 g

# Blue value between 0 and 1
float64 b

# Alpha value between 0 and 1
float64 a
"""
  __slots__ = ['pose','size','bottom_scale','top_scale','color']
  _slot_types = ['geometry_msgs/Pose','geometry_msgs/Vector3','float64','float64','foxglove_msgs/Color']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       pose,size,bottom_scale,top_scale,color

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ConeAttributes, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.pose is None:
        self.pose = geometry_msgs.msg.Pose()
      if self.size is None:
        self.size = geometry_msgs.msg.Vector3()
      if self.bottom_scale is None:
        self.bottom_scale = 0.
      if self.top_scale is None:
        self.top_scale = 0.
      if self.color is None:
        self.color = foxglove_msgs.msg.Color()
    else:
      self.pose = geometry_msgs.msg.Pose()
      self.size = geometry_msgs.msg.Vector3()
      self.bottom_scale = 0.
      self.top_scale = 0.
      self.color = foxglove_msgs.msg.Color()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_16d().pack(_x.pose.position.x, _x.pose.position.y, _x.pose.position.z, _x.pose.orientation.x, _x.pose.orientation.y, _x.pose.orientation.z, _x.pose.orientation.w, _x.size.x, _x.size.y, _x.size.z, _x.bottom_scale, _x.top_scale, _x.color.r, _x.color.g, _x.color.b, _x.color.a))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.pose is None:
        self.pose = geometry_msgs.msg.Pose()
      if self.size is None:
        self.size = geometry_msgs.msg.Vector3()
      if self.color is None:
        self.color = foxglove_msgs.msg.Color()
      end = 0
      _x = self
      start = end
      end += 128
      (_x.pose.position.x, _x.pose.position.y, _x.pose.position.z, _x.pose.orientation.x, _x.pose.orientation.y, _x.pose.orientation.z, _x.pose.orientation.w, _x.size.x, _x.size.y, _x.size.z, _x.bottom_scale, _x.top_scale, _x.color.r, _x.color.g, _x.color.b, _x.color.a,) = _get_struct_16d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_16d().pack(_x.pose.position.x, _x.pose.position.y, _x.pose.position.z, _x.pose.orientation.x, _x.pose.orientation.y, _x.pose.orientation.z, _x.pose.orientation.w, _x.size.x, _x.size.y, _x.size.z, _x.bottom_scale, _x.top_scale, _x.color.r, _x.color.g, _x.color.b, _x.color.a))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.pose is None:
        self.pose = geometry_msgs.msg.Pose()
      if self.size is None:
        self.size = geometry_msgs.msg.Vector3()
      if self.color is None:
        self.color = foxglove_msgs.msg.Color()
      end = 0
      _x = self
      start = end
      end += 128
      (_x.pose.position.x, _x.pose.position.y, _x.pose.position.z, _x.pose.orientation.x, _x.pose.orientation.y, _x.pose.orientation.z, _x.pose.orientation.w, _x.size.x, _x.size.y, _x.size.z, _x.bottom_scale, _x.top_scale, _x.color.r, _x.color.g, _x.color.b, _x.color.a,) = _get_struct_16d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_16d = None
def _get_struct_16d():
    global _struct_16d
    if _struct_16d is None:
        _struct_16d = struct.Struct("<16d")
    return _struct_16d
