# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from foxglove_msgs/Grid.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import foxglove_msgs.msg
import genpy
import geometry_msgs.msg

class Grid(genpy.Message):
  _md5sum = "ff812efab6fae28f163999277c175522"
  _type = "foxglove_msgs/Grid"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# foxglove_msgs/Grid
# A 2D grid of data

# Generated by https://github.com/foxglove/schemas

# Timestamp of grid
time timestamp

# Frame of reference
string frame_id

# Origin of grid's corner relative to frame of reference; grid is positioned in the x-y plane relative to this origin
geometry_msgs/Pose pose

# Number of grid columns
uint32 column_count

# Size of single grid cell along x and y axes, relative to `pose`
foxglove_msgs/Vector2 cell_size

# Number of bytes between rows in `data`
uint32 row_stride

# Number of bytes between cells within a row in `data`
uint32 cell_stride

# Fields in `data`
foxglove_msgs/PackedElementField[] fields

# Grid cell data, interpreted using `fields`, in row-major (y-major) order
uint8[] data

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of position and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: foxglove_msgs/Vector2
# foxglove_msgs/Vector2
# A vector in 2D space that represents a direction only

# Generated by https://github.com/foxglove/schemas

# x coordinate length
float64 x

# y coordinate length
float64 y

================================================================================
MSG: foxglove_msgs/PackedElementField
# foxglove_msgs/PackedElementField
# A field present within each element in a byte array of packed elements.

# Generated by https://github.com/foxglove/schemas

# Name of the field
string name

# Byte offset from start of data buffer
uint32 offset

uint8 UNKNOWN=0
uint8 UINT8=1
uint8 INT8=2
uint8 UINT16=3
uint8 INT16=4
uint8 UINT32=5
uint8 INT32=6
uint8 FLOAT32=7
uint8 FLOAT64=8

# Type of data in the field. Integers are stored using little-endian byte order.
uint8 type
"""
  __slots__ = ['timestamp','frame_id','pose','column_count','cell_size','row_stride','cell_stride','fields','data']
  _slot_types = ['time','string','geometry_msgs/Pose','uint32','foxglove_msgs/Vector2','uint32','uint32','foxglove_msgs/PackedElementField[]','uint8[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp,frame_id,pose,column_count,cell_size,row_stride,cell_stride,fields,data

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(Grid, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.timestamp is None:
        self.timestamp = genpy.Time()
      if self.frame_id is None:
        self.frame_id = ''
      if self.pose is None:
        self.pose = geometry_msgs.msg.Pose()
      if self.column_count is None:
        self.column_count = 0
      if self.cell_size is None:
        self.cell_size = foxglove_msgs.msg.Vector2()
      if self.row_stride is None:
        self.row_stride = 0
      if self.cell_stride is None:
        self.cell_stride = 0
      if self.fields is None:
        self.fields = []
      if self.data is None:
        self.data = b''
    else:
      self.timestamp = genpy.Time()
      self.frame_id = ''
      self.pose = geometry_msgs.msg.Pose()
      self.column_count = 0
      self.cell_size = foxglove_msgs.msg.Vector2()
      self.row_stride = 0
      self.cell_stride = 0
      self.fields = []
      self.data = b''

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2I().pack(_x.timestamp.secs, _x.timestamp.nsecs))
      _x = self.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_7dI2d2I().pack(_x.pose.position.x, _x.pose.position.y, _x.pose.position.z, _x.pose.orientation.x, _x.pose.orientation.y, _x.pose.orientation.z, _x.pose.orientation.w, _x.column_count, _x.cell_size.x, _x.cell_size.y, _x.row_stride, _x.cell_stride))
      length = len(self.fields)
      buff.write(_struct_I.pack(length))
      for val1 in self.fields:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1
        buff.write(_get_struct_IB().pack(_x.offset, _x.type))
      _x = self.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.timestamp is None:
        self.timestamp = genpy.Time()
      if self.pose is None:
        self.pose = geometry_msgs.msg.Pose()
      if self.cell_size is None:
        self.cell_size = foxglove_msgs.msg.Vector2()
      if self.fields is None:
        self.fields = None
      end = 0
      _x = self
      start = end
      end += 8
      (_x.timestamp.secs, _x.timestamp.nsecs,) = _get_struct_2I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.frame_id = str[start:end]
      _x = self
      start = end
      end += 84
      (_x.pose.position.x, _x.pose.position.y, _x.pose.position.z, _x.pose.orientation.x, _x.pose.orientation.y, _x.pose.orientation.z, _x.pose.orientation.w, _x.column_count, _x.cell_size.x, _x.cell_size.y, _x.row_stride, _x.cell_stride,) = _get_struct_7dI2d2I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.fields = []
      for i in range(0, length):
        val1 = foxglove_msgs.msg.PackedElementField()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.name = str[start:end]
        _x = val1
        start = end
        end += 5
        (_x.offset, _x.type,) = _get_struct_IB().unpack(str[start:end])
        self.fields.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.data = str[start:end]
      self.timestamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2I().pack(_x.timestamp.secs, _x.timestamp.nsecs))
      _x = self.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_7dI2d2I().pack(_x.pose.position.x, _x.pose.position.y, _x.pose.position.z, _x.pose.orientation.x, _x.pose.orientation.y, _x.pose.orientation.z, _x.pose.orientation.w, _x.column_count, _x.cell_size.x, _x.cell_size.y, _x.row_stride, _x.cell_stride))
      length = len(self.fields)
      buff.write(_struct_I.pack(length))
      for val1 in self.fields:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1
        buff.write(_get_struct_IB().pack(_x.offset, _x.type))
      _x = self.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.timestamp is None:
        self.timestamp = genpy.Time()
      if self.pose is None:
        self.pose = geometry_msgs.msg.Pose()
      if self.cell_size is None:
        self.cell_size = foxglove_msgs.msg.Vector2()
      if self.fields is None:
        self.fields = None
      end = 0
      _x = self
      start = end
      end += 8
      (_x.timestamp.secs, _x.timestamp.nsecs,) = _get_struct_2I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.frame_id = str[start:end]
      _x = self
      start = end
      end += 84
      (_x.pose.position.x, _x.pose.position.y, _x.pose.position.z, _x.pose.orientation.x, _x.pose.orientation.y, _x.pose.orientation.z, _x.pose.orientation.w, _x.column_count, _x.cell_size.x, _x.cell_size.y, _x.row_stride, _x.cell_stride,) = _get_struct_7dI2d2I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.fields = []
      for i in range(0, length):
        val1 = foxglove_msgs.msg.PackedElementField()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.name = str[start:end]
        _x = val1
        start = end
        end += 5
        (_x.offset, _x.type,) = _get_struct_IB().unpack(str[start:end])
        self.fields.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.data = str[start:end]
      self.timestamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2I = None
def _get_struct_2I():
    global _struct_2I
    if _struct_2I is None:
        _struct_2I = struct.Struct("<2I")
    return _struct_2I
_struct_7dI2d2I = None
def _get_struct_7dI2d2I():
    global _struct_7dI2d2I
    if _struct_7dI2d2I is None:
        _struct_7dI2d2I = struct.Struct("<7dI2d2I")
    return _struct_7dI2d2I
_struct_IB = None
def _get_struct_IB():
    global _struct_IB
    if _struct_IB is None:
        _struct_IB = struct.Struct("<IB")
    return _struct_IB
