# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from foxglove_msgs/LocationFix.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class LocationFix(genpy.Message):
  _md5sum = "31fcca89d2b882730971fd270ace27d9"
  _type = "foxglove_msgs/LocationFix"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# foxglove_msgs/LocationFix
# A navigation satellite fix for any Global Navigation Satellite System

# Generated by https://github.com/foxglove/schemas

# Latitude in degrees
float64 latitude

# Longitude in degrees
float64 longitude

# Altitude in meters
float64 altitude

# Position covariance (m^2) defined relative to a tangential plane through the reported position. The components are East, North, and Up (ENU), in row-major order.
float64[9] position_covariance

uint8 UNKNOWN=0
uint8 APPROXIMATED=1
uint8 DIAGONAL_KNOWN=2
uint8 KNOWN=3

# If `position_covariance` is available, `position_covariance_type` must be set to indicate the type of covariance.
uint8 position_covariance_type
"""
  # Pseudo-constants
  UNKNOWN = 0
  APPROXIMATED = 1
  DIAGONAL_KNOWN = 2
  KNOWN = 3

  __slots__ = ['latitude','longitude','altitude','position_covariance','position_covariance_type']
  _slot_types = ['float64','float64','float64','float64[9]','uint8']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       latitude,longitude,altitude,position_covariance,position_covariance_type

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(LocationFix, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.latitude is None:
        self.latitude = 0.
      if self.longitude is None:
        self.longitude = 0.
      if self.altitude is None:
        self.altitude = 0.
      if self.position_covariance is None:
        self.position_covariance = [0.] * 9
      if self.position_covariance_type is None:
        self.position_covariance_type = 0
    else:
      self.latitude = 0.
      self.longitude = 0.
      self.altitude = 0.
      self.position_covariance = [0.] * 9
      self.position_covariance_type = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3d().pack(_x.latitude, _x.longitude, _x.altitude))
      buff.write(_get_struct_9d().pack(*self.position_covariance))
      _x = self.position_covariance_type
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 24
      (_x.latitude, _x.longitude, _x.altitude,) = _get_struct_3d().unpack(str[start:end])
      start = end
      end += 72
      self.position_covariance = _get_struct_9d().unpack(str[start:end])
      start = end
      end += 1
      (self.position_covariance_type,) = _get_struct_B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3d().pack(_x.latitude, _x.longitude, _x.altitude))
      buff.write(self.position_covariance.tostring())
      _x = self.position_covariance_type
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 24
      (_x.latitude, _x.longitude, _x.altitude,) = _get_struct_3d().unpack(str[start:end])
      start = end
      end += 72
      self.position_covariance = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=9)
      start = end
      end += 1
      (self.position_covariance_type,) = _get_struct_B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3d = None
def _get_struct_3d():
    global _struct_3d
    if _struct_3d is None:
        _struct_3d = struct.Struct("<3d")
    return _struct_3d
_struct_9d = None
def _get_struct_9d():
    global _struct_9d
    if _struct_9d is None:
        _struct_9d = struct.Struct("<9d")
    return _struct_9d
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
