# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from foxglove_msgs/Markers.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import foxglove_msgs.msg
import genpy
import geometry_msgs.msg

class Markers(genpy.Message):
  _md5sum = "7adad93502db1b37c29f6a3eafcc7dda"
  _type = "foxglove_msgs/Markers"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# foxglove_msgs/Markers
# A list of any number or type of markers

# Generated by https://github.com/foxglove/schemas

# Marker deletion actions
foxglove_msgs/MarkerDeletion[] deletions

# Arrow markers
foxglove_msgs/ArrowMarker[] arrows

# Cube list markers
foxglove_msgs/CubeListMarker[] cubes

# Sphere list markers
foxglove_msgs/SphereListMarker[] spheres

# Cone list markers
foxglove_msgs/ConeListMarker[] cones

# Line markers
foxglove_msgs/LineMarker[] lines

# Triangle list markers
foxglove_msgs/TriangleListMarker[] triangles

# Text markers
foxglove_msgs/TextMarker[] texts

# Model markers
foxglove_msgs/ModelMarker[] models

================================================================================
MSG: foxglove_msgs/MarkerDeletion
# foxglove_msgs/MarkerDeletion
# Command to remove previously published markers

# Generated by https://github.com/foxglove/schemas

# Timestamp of the marker. Only matching markers earlier than this timestamp will be deleted.
time timestamp

uint8 MATCHING_ID=0
uint8 ALL=1

# Type of deletion action to perform
uint8 type

# Numeric identifier which must match if `kind` is `MATCHING_ID`.
string id

================================================================================
MSG: foxglove_msgs/ArrowMarker
# foxglove_msgs/ArrowMarker
# A marker representing an arrow

# Generated by https://github.com/foxglove/schemas

# Position of the arrow's tail and orientation of the arrow. Identity orientation means the arrow points in the +x direction.
geometry_msgs/Pose pose

# Length of the arrow
float64 length

# Diameter of the arrow shaft
float64 shaft_diameter

# Diameter of the arrow head
float64 head_diameter

# Length of the arrow head
float64 head_length

# Color of the arrow
foxglove_msgs/Color color

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of position and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: foxglove_msgs/Color
# foxglove_msgs/Color
# A color in RGBA format

# Generated by https://github.com/foxglove/schemas

# Red value between 0 and 1
float64 r

# Green value between 0 and 1
float64 g

# Blue value between 0 and 1
float64 b

# Alpha value between 0 and 1
float64 a

================================================================================
MSG: foxglove_msgs/CubeListMarker
# foxglove_msgs/CubeListMarker
# A marker representing a list of cubes or rectangular prisms

# Generated by https://github.com/foxglove/schemas

# Timestamp of the marker
time timestamp

# Frame of reference
string frame_id

# Identifier for the marker. A marker will replace any prior marker on the same topic with the same `id`.
string id

# Length of time (relative to `timestamp`) after which the marker should be automatically removed. Zero value indicates the marker should remain visible until it is replaced or deleted.
duration lifetime

# Whether the marker should keep its location in the fixed frame (false) or follow the frame specified in `frame_id` as it moves relative to the fixed frame (true)
bool frame_locked

# Additional user-provided metadata associated with the marker. Keys must be unique.
foxglove_msgs/KeyValuePair[] metadata

# Attributes of each cube
foxglove_msgs/CubeAttributes[] attributes

================================================================================
MSG: foxglove_msgs/KeyValuePair
# foxglove_msgs/KeyValuePair
# A key with its associated value

# Generated by https://github.com/foxglove/schemas

# Key
string key

# Value
string value

================================================================================
MSG: foxglove_msgs/CubeAttributes
# foxglove_msgs/CubeAttributes
# Data specifying the visual appearance of a cube or rectangular prism

# Generated by https://github.com/foxglove/schemas

# Position of the center of the cube and orientation of the cube
geometry_msgs/Pose pose

# Size of the cube along each axis
geometry_msgs/Vector3 size

# Color of the arrow
foxglove_msgs/Color color

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 
# It is only meant to represent a direction. Therefore, it does not
# make sense to apply a translation to it (e.g., when applying a 
# generic rigid transformation to a Vector3, tf2 will only apply the
# rotation). If you want your data to be translatable too, use the
# geometry_msgs/Point message instead.

float64 x
float64 y
float64 z
================================================================================
MSG: foxglove_msgs/SphereListMarker
# foxglove_msgs/SphereListMarker
# A marker representing a list of spheres or ellipsoids

# Generated by https://github.com/foxglove/schemas

# Timestamp of the marker
time timestamp

# Frame of reference
string frame_id

# Identifier for the marker. A marker will replace any prior marker on the same topic with the same `id`.
string id

# Length of time (relative to `timestamp`) after which the marker should be automatically removed. Zero value indicates the marker should remain visible until it is replaced or deleted.
duration lifetime

# Whether the marker should keep its location in the fixed frame (false) or follow the frame specified in `frame_id` as it moves relative to the fixed frame (true)
bool frame_locked

# Additional user-provided metadata associated with the marker. Keys must be unique.
foxglove_msgs/KeyValuePair[] metadata

# Attributes of each sphere
foxglove_msgs/SphereAttributes[] attributes

================================================================================
MSG: foxglove_msgs/SphereAttributes
# foxglove_msgs/SphereAttributes
# Data specifying the visual appearance of a sphere or ellipsoid

# Generated by https://github.com/foxglove/schemas

# Position of the center of the sphere and orientation of the sphere
geometry_msgs/Pose pose

# Size (diameter) of the sphere along each axis
geometry_msgs/Vector3 size

# Color of the sphere
foxglove_msgs/Color color

================================================================================
MSG: foxglove_msgs/ConeListMarker
# foxglove_msgs/ConeListMarker
# A marker representing a list of possibly truncated, possibly elliptic cones or cylinders

# Generated by https://github.com/foxglove/schemas

# Timestamp of the marker
time timestamp

# Frame of reference
string frame_id

# Identifier for the marker. A marker will replace any prior marker on the same topic with the same `id`.
string id

# Length of time (relative to `timestamp`) after which the marker should be automatically removed. Zero value indicates the marker should remain visible until it is replaced or deleted.
duration lifetime

# Whether the marker should keep its location in the fixed frame (false) or follow the frame specified in `frame_id` as it moves relative to the fixed frame (true)
bool frame_locked

# Additional user-provided metadata associated with the marker. Keys must be unique.
foxglove_msgs/KeyValuePair[] metadata

# Attributes of each cone
foxglove_msgs/ConeAttributes[] attributes

================================================================================
MSG: foxglove_msgs/ConeAttributes
# foxglove_msgs/ConeAttributes
# Data specifying the visual appearance of a possibly truncated, possibly elliptic cone or cylinder

# Generated by https://github.com/foxglove/schemas

# Position of the center of the cone and orientation of the cone. The flat face(s) are perpendicular to the z-axis.
geometry_msgs/Pose pose

# Size of the cone's bounding box
geometry_msgs/Vector3 size

# 0-1, size of the cone's bottom face (min z) relative to the bottom of the bounding box
float64 bottom_scale

# 0-1, size of the cone's top face (max z) relative to the top of the bounding box
float64 top_scale

# Color of the cone
foxglove_msgs/Color color

================================================================================
MSG: foxglove_msgs/LineMarker
# foxglove_msgs/LineMarker
# A marker representing a series of points connected by lines

# Generated by https://github.com/foxglove/schemas

# 0-1, 1-2, ..., (n-1)-n
uint8 LINE_STRIP=0

# 0-1, 1-2, ..., (n-1)-n, n-0
uint8 LINE_LOOP=1

# 0-1, 2-3, 4-5, ...
uint8 LINE_LIST=2

# Drawing primitive to use for lines
uint8 type

# Origin of lines relative to reference frame
geometry_msgs/Pose pose

# Line thickness
float64 thickness

# Indicates whether `thickness` is a fixed size in screen pixels (true), or specified in world coordinates and scales with distance from the camera (false)
bool scale_invariant

# Points along the line
geometry_msgs/Point[] points

# Solid color to use for the whole line. One of `color` or `colors` must be provided.
foxglove_msgs/Color color

# Per-point colors (if specified, must have the same length as `points`). One of `color` or `colors` must be provided.
foxglove_msgs/Color[] colors

# Indices into the `points` and `colors` attribute arrays, which can be used to avoid duplicating attribute data.
# 
# If omitted or empty, indexing will not be used. This default behavior is equivalent to specifying [0, 1, ..., N-1] for the indices (where N is the number of `points` provided).
uint32[] indices

================================================================================
MSG: foxglove_msgs/TriangleListMarker
# foxglove_msgs/TriangleListMarker
# A marker representing a set of triangles or a surface tiled by triangles

# Generated by https://github.com/foxglove/schemas

# Origin of triangles relative to reference frame
geometry_msgs/Pose pose

# Vertices to use for triangles, interpreted as a list of triples (0-1-2, 3-4-5, ...)
geometry_msgs/Point[] points

# Solid color to use for the whole shape. One of `color` or `colors` must be provided.
foxglove_msgs/Color color

# Per-vertex colors (if specified, must have the same length as `points`). One of `color` or `colors` must be provided.
foxglove_msgs/Color[] colors

# Indices into the `points` and `colors` attribute arrays, which can be used to avoid duplicating attribute data.
# 
# If omitted or empty, indexing will not be used. This default behavior is equivalent to specifying [0, 1, ..., N-1] for the indices (where N is the number of `points` provided).
uint32[] indices

================================================================================
MSG: foxglove_msgs/TextMarker
# foxglove_msgs/TextMarker
# A marker representing a text label

# Generated by https://github.com/foxglove/schemas

# Position of the center of the text box and orientation of the text. Identity orientation means the text is oriented in the xy-plane and flows from -x to +x.
geometry_msgs/Pose pose

# Whether the text should respect `pose.orientation` (false) or always face the camera (true)
bool billboard

# Font size (height of one line of text)
float64 font_size

# Indicates whether `font_size` is a fixed size in screen pixels (true), or specified in world coordinates and scales with distance from the camera (false)
bool scale_invariant

# Color of the text
foxglove_msgs/Color color

# Text
string text

================================================================================
MSG: foxglove_msgs/ModelMarker
# foxglove_msgs/ModelMarker
# A marker representing a 3D model

# Generated by https://github.com/foxglove/schemas

# Origin of model relative to reference frame
geometry_msgs/Pose pose

# Scale factor to apply to the model along each axis
geometry_msgs/Vector3 scale

# Solid color to use for the whole model. If `use_embedded_materials` is true, this color is blended on top of the embedded material color.
foxglove_msgs/Color color

# Whether to use materials embedded in the model, or only the `color`
bool use_embedded_materials

# URL pointing to model file. Either `url` or `mime_type` and `data` should be provided.
string url

# MIME type of embedded model (e.g. `model/gltf-binary`). Either `url` or `mime_type` and `data` should be provided.
string mime_type

# Embedded model. Either `url` or `mime_type` and `data` should be provided.
uint8[] data
"""
  __slots__ = ['deletions','arrows','cubes','spheres','cones','lines','triangles','texts','models']
  _slot_types = ['foxglove_msgs/MarkerDeletion[]','foxglove_msgs/ArrowMarker[]','foxglove_msgs/CubeListMarker[]','foxglove_msgs/SphereListMarker[]','foxglove_msgs/ConeListMarker[]','foxglove_msgs/LineMarker[]','foxglove_msgs/TriangleListMarker[]','foxglove_msgs/TextMarker[]','foxglove_msgs/ModelMarker[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       deletions,arrows,cubes,spheres,cones,lines,triangles,texts,models

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(Markers, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.deletions is None:
        self.deletions = []
      if self.arrows is None:
        self.arrows = []
      if self.cubes is None:
        self.cubes = []
      if self.spheres is None:
        self.spheres = []
      if self.cones is None:
        self.cones = []
      if self.lines is None:
        self.lines = []
      if self.triangles is None:
        self.triangles = []
      if self.texts is None:
        self.texts = []
      if self.models is None:
        self.models = []
    else:
      self.deletions = []
      self.arrows = []
      self.cubes = []
      self.spheres = []
      self.cones = []
      self.lines = []
      self.triangles = []
      self.texts = []
      self.models = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      length = len(self.deletions)
      buff.write(_struct_I.pack(length))
      for val1 in self.deletions:
        _v1 = val1.timestamp
        _x = _v1
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _x = val1.type
        buff.write(_get_struct_B().pack(_x))
        _x = val1.id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.arrows)
      buff.write(_struct_I.pack(length))
      for val1 in self.arrows:
        _v2 = val1.pose
        _v3 = _v2.position
        _x = _v3
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v4 = _v2.orientation
        _x = _v4
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1
        buff.write(_get_struct_4d().pack(_x.length, _x.shaft_diameter, _x.head_diameter, _x.head_length))
        _v5 = val1.color
        _x = _v5
        buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
      length = len(self.cubes)
      buff.write(_struct_I.pack(length))
      for val1 in self.cubes:
        _v6 = val1.timestamp
        _x = _v6
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _x = val1.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v7 = val1.lifetime
        _x = _v7
        buff.write(_get_struct_2i().pack(_x.secs, _x.nsecs))
        _x = val1.frame_locked
        buff.write(_get_struct_B().pack(_x))
        length = len(val1.metadata)
        buff.write(_struct_I.pack(length))
        for val2 in val1.metadata:
          _x = val2.key
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = val2.value
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        length = len(val1.attributes)
        buff.write(_struct_I.pack(length))
        for val2 in val1.attributes:
          _v8 = val2.pose
          _v9 = _v8.position
          _x = _v9
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
          _v10 = _v8.orientation
          _x = _v10
          buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
          _v11 = val2.size
          _x = _v11
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
          _v12 = val2.color
          _x = _v12
          buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
      length = len(self.spheres)
      buff.write(_struct_I.pack(length))
      for val1 in self.spheres:
        _v13 = val1.timestamp
        _x = _v13
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _x = val1.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v14 = val1.lifetime
        _x = _v14
        buff.write(_get_struct_2i().pack(_x.secs, _x.nsecs))
        _x = val1.frame_locked
        buff.write(_get_struct_B().pack(_x))
        length = len(val1.metadata)
        buff.write(_struct_I.pack(length))
        for val2 in val1.metadata:
          _x = val2.key
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = val2.value
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        length = len(val1.attributes)
        buff.write(_struct_I.pack(length))
        for val2 in val1.attributes:
          _v15 = val2.pose
          _v16 = _v15.position
          _x = _v16
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
          _v17 = _v15.orientation
          _x = _v17
          buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
          _v18 = val2.size
          _x = _v18
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
          _v19 = val2.color
          _x = _v19
          buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
      length = len(self.cones)
      buff.write(_struct_I.pack(length))
      for val1 in self.cones:
        _v20 = val1.timestamp
        _x = _v20
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _x = val1.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v21 = val1.lifetime
        _x = _v21
        buff.write(_get_struct_2i().pack(_x.secs, _x.nsecs))
        _x = val1.frame_locked
        buff.write(_get_struct_B().pack(_x))
        length = len(val1.metadata)
        buff.write(_struct_I.pack(length))
        for val2 in val1.metadata:
          _x = val2.key
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = val2.value
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        length = len(val1.attributes)
        buff.write(_struct_I.pack(length))
        for val2 in val1.attributes:
          _v22 = val2.pose
          _v23 = _v22.position
          _x = _v23
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
          _v24 = _v22.orientation
          _x = _v24
          buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
          _v25 = val2.size
          _x = _v25
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
          _x = val2
          buff.write(_get_struct_2d().pack(_x.bottom_scale, _x.top_scale))
          _v26 = val2.color
          _x = _v26
          buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
      length = len(self.lines)
      buff.write(_struct_I.pack(length))
      for val1 in self.lines:
        _x = val1.type
        buff.write(_get_struct_B().pack(_x))
        _v27 = val1.pose
        _v28 = _v27.position
        _x = _v28
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v29 = _v27.orientation
        _x = _v29
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1
        buff.write(_get_struct_dB().pack(_x.thickness, _x.scale_invariant))
        length = len(val1.points)
        buff.write(_struct_I.pack(length))
        for val2 in val1.points:
          _x = val2
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v30 = val1.color
        _x = _v30
        buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
        length = len(val1.colors)
        buff.write(_struct_I.pack(length))
        for val2 in val1.colors:
          _x = val2
          buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
        length = len(val1.indices)
        buff.write(_struct_I.pack(length))
        pattern = '<%sI'%length
        buff.write(struct.Struct(pattern).pack(*val1.indices))
      length = len(self.triangles)
      buff.write(_struct_I.pack(length))
      for val1 in self.triangles:
        _v31 = val1.pose
        _v32 = _v31.position
        _x = _v32
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v33 = _v31.orientation
        _x = _v33
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
        length = len(val1.points)
        buff.write(_struct_I.pack(length))
        for val2 in val1.points:
          _x = val2
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v34 = val1.color
        _x = _v34
        buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
        length = len(val1.colors)
        buff.write(_struct_I.pack(length))
        for val2 in val1.colors:
          _x = val2
          buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
        length = len(val1.indices)
        buff.write(_struct_I.pack(length))
        pattern = '<%sI'%length
        buff.write(struct.Struct(pattern).pack(*val1.indices))
      length = len(self.texts)
      buff.write(_struct_I.pack(length))
      for val1 in self.texts:
        _v35 = val1.pose
        _v36 = _v35.position
        _x = _v36
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v37 = _v35.orientation
        _x = _v37
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1
        buff.write(_get_struct_BdB().pack(_x.billboard, _x.font_size, _x.scale_invariant))
        _v38 = val1.color
        _x = _v38
        buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
        _x = val1.text
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.models)
      buff.write(_struct_I.pack(length))
      for val1 in self.models:
        _v39 = val1.pose
        _v40 = _v39.position
        _x = _v40
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v41 = _v39.orientation
        _x = _v41
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
        _v42 = val1.scale
        _x = _v42
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v43 = val1.color
        _x = _v43
        buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
        _x = val1.use_embedded_materials
        buff.write(_get_struct_B().pack(_x))
        _x = val1.url
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.mime_type
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.data
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
        else:
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.deletions is None:
        self.deletions = None
      if self.arrows is None:
        self.arrows = None
      if self.cubes is None:
        self.cubes = None
      if self.spheres is None:
        self.spheres = None
      if self.cones is None:
        self.cones = None
      if self.lines is None:
        self.lines = None
      if self.triangles is None:
        self.triangles = None
      if self.texts is None:
        self.texts = None
      if self.models is None:
        self.models = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.deletions = []
      for i in range(0, length):
        val1 = foxglove_msgs.msg.MarkerDeletion()
        _v44 = val1.timestamp
        _x = _v44
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        start = end
        end += 1
        (val1.type,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.id = str[start:end]
        self.deletions.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.arrows = []
      for i in range(0, length):
        val1 = foxglove_msgs.msg.ArrowMarker()
        _v45 = val1.pose
        _v46 = _v45.position
        _x = _v46
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v47 = _v45.orientation
        _x = _v47
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        _x = val1
        start = end
        end += 32
        (_x.length, _x.shaft_diameter, _x.head_diameter, _x.head_length,) = _get_struct_4d().unpack(str[start:end])
        _v48 = val1.color
        _x = _v48
        start = end
        end += 32
        (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
        self.arrows.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.cubes = []
      for i in range(0, length):
        val1 = foxglove_msgs.msg.CubeListMarker()
        _v49 = val1.timestamp
        _x = _v49
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.frame_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.frame_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.id = str[start:end]
        _v50 = val1.lifetime
        _x = _v50
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2i().unpack(str[start:end])
        start = end
        end += 1
        (val1.frame_locked,) = _get_struct_B().unpack(str[start:end])
        val1.frame_locked = bool(val1.frame_locked)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.metadata = []
        for i in range(0, length):
          val2 = foxglove_msgs.msg.KeyValuePair()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.key = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2.key = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.value = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2.value = str[start:end]
          val1.metadata.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.attributes = []
        for i in range(0, length):
          val2 = foxglove_msgs.msg.CubeAttributes()
          _v51 = val2.pose
          _v52 = _v51.position
          _x = _v52
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          _v53 = _v51.orientation
          _x = _v53
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
          _v54 = val2.size
          _x = _v54
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          _v55 = val2.color
          _x = _v55
          start = end
          end += 32
          (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
          val1.attributes.append(val2)
        self.cubes.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.spheres = []
      for i in range(0, length):
        val1 = foxglove_msgs.msg.SphereListMarker()
        _v56 = val1.timestamp
        _x = _v56
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.frame_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.frame_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.id = str[start:end]
        _v57 = val1.lifetime
        _x = _v57
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2i().unpack(str[start:end])
        start = end
        end += 1
        (val1.frame_locked,) = _get_struct_B().unpack(str[start:end])
        val1.frame_locked = bool(val1.frame_locked)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.metadata = []
        for i in range(0, length):
          val2 = foxglove_msgs.msg.KeyValuePair()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.key = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2.key = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.value = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2.value = str[start:end]
          val1.metadata.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.attributes = []
        for i in range(0, length):
          val2 = foxglove_msgs.msg.SphereAttributes()
          _v58 = val2.pose
          _v59 = _v58.position
          _x = _v59
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          _v60 = _v58.orientation
          _x = _v60
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
          _v61 = val2.size
          _x = _v61
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          _v62 = val2.color
          _x = _v62
          start = end
          end += 32
          (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
          val1.attributes.append(val2)
        self.spheres.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.cones = []
      for i in range(0, length):
        val1 = foxglove_msgs.msg.ConeListMarker()
        _v63 = val1.timestamp
        _x = _v63
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.frame_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.frame_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.id = str[start:end]
        _v64 = val1.lifetime
        _x = _v64
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2i().unpack(str[start:end])
        start = end
        end += 1
        (val1.frame_locked,) = _get_struct_B().unpack(str[start:end])
        val1.frame_locked = bool(val1.frame_locked)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.metadata = []
        for i in range(0, length):
          val2 = foxglove_msgs.msg.KeyValuePair()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.key = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2.key = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.value = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2.value = str[start:end]
          val1.metadata.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.attributes = []
        for i in range(0, length):
          val2 = foxglove_msgs.msg.ConeAttributes()
          _v65 = val2.pose
          _v66 = _v65.position
          _x = _v66
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          _v67 = _v65.orientation
          _x = _v67
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
          _v68 = val2.size
          _x = _v68
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          _x = val2
          start = end
          end += 16
          (_x.bottom_scale, _x.top_scale,) = _get_struct_2d().unpack(str[start:end])
          _v69 = val2.color
          _x = _v69
          start = end
          end += 32
          (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
          val1.attributes.append(val2)
        self.cones.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.lines = []
      for i in range(0, length):
        val1 = foxglove_msgs.msg.LineMarker()
        start = end
        end += 1
        (val1.type,) = _get_struct_B().unpack(str[start:end])
        _v70 = val1.pose
        _v71 = _v70.position
        _x = _v71
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v72 = _v70.orientation
        _x = _v72
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        _x = val1
        start = end
        end += 9
        (_x.thickness, _x.scale_invariant,) = _get_struct_dB().unpack(str[start:end])
        val1.scale_invariant = bool(val1.scale_invariant)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.points = []
        for i in range(0, length):
          val2 = geometry_msgs.msg.Point()
          _x = val2
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          val1.points.append(val2)
        _v73 = val1.color
        _x = _v73
        start = end
        end += 32
        (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.colors = []
        for i in range(0, length):
          val2 = foxglove_msgs.msg.Color()
          _x = val2
          start = end
          end += 32
          (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
          val1.colors.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sI'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.indices = s.unpack(str[start:end])
        self.lines.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.triangles = []
      for i in range(0, length):
        val1 = foxglove_msgs.msg.TriangleListMarker()
        _v74 = val1.pose
        _v75 = _v74.position
        _x = _v75
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v76 = _v74.orientation
        _x = _v76
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.points = []
        for i in range(0, length):
          val2 = geometry_msgs.msg.Point()
          _x = val2
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          val1.points.append(val2)
        _v77 = val1.color
        _x = _v77
        start = end
        end += 32
        (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.colors = []
        for i in range(0, length):
          val2 = foxglove_msgs.msg.Color()
          _x = val2
          start = end
          end += 32
          (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
          val1.colors.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sI'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.indices = s.unpack(str[start:end])
        self.triangles.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.texts = []
      for i in range(0, length):
        val1 = foxglove_msgs.msg.TextMarker()
        _v78 = val1.pose
        _v79 = _v78.position
        _x = _v79
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v80 = _v78.orientation
        _x = _v80
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        _x = val1
        start = end
        end += 10
        (_x.billboard, _x.font_size, _x.scale_invariant,) = _get_struct_BdB().unpack(str[start:end])
        val1.billboard = bool(val1.billboard)
        val1.scale_invariant = bool(val1.scale_invariant)
        _v81 = val1.color
        _x = _v81
        start = end
        end += 32
        (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.text = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.text = str[start:end]
        self.texts.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.models = []
      for i in range(0, length):
        val1 = foxglove_msgs.msg.ModelMarker()
        _v82 = val1.pose
        _v83 = _v82.position
        _x = _v83
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v84 = _v82.orientation
        _x = _v84
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        _v85 = val1.scale
        _x = _v85
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v86 = val1.color
        _x = _v86
        start = end
        end += 32
        (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
        start = end
        end += 1
        (val1.use_embedded_materials,) = _get_struct_B().unpack(str[start:end])
        val1.use_embedded_materials = bool(val1.use_embedded_materials)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.url = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.url = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.mime_type = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.mime_type = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.data = str[start:end]
        self.models.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      length = len(self.deletions)
      buff.write(_struct_I.pack(length))
      for val1 in self.deletions:
        _v87 = val1.timestamp
        _x = _v87
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _x = val1.type
        buff.write(_get_struct_B().pack(_x))
        _x = val1.id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.arrows)
      buff.write(_struct_I.pack(length))
      for val1 in self.arrows:
        _v88 = val1.pose
        _v89 = _v88.position
        _x = _v89
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v90 = _v88.orientation
        _x = _v90
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1
        buff.write(_get_struct_4d().pack(_x.length, _x.shaft_diameter, _x.head_diameter, _x.head_length))
        _v91 = val1.color
        _x = _v91
        buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
      length = len(self.cubes)
      buff.write(_struct_I.pack(length))
      for val1 in self.cubes:
        _v92 = val1.timestamp
        _x = _v92
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _x = val1.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v93 = val1.lifetime
        _x = _v93
        buff.write(_get_struct_2i().pack(_x.secs, _x.nsecs))
        _x = val1.frame_locked
        buff.write(_get_struct_B().pack(_x))
        length = len(val1.metadata)
        buff.write(_struct_I.pack(length))
        for val2 in val1.metadata:
          _x = val2.key
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = val2.value
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        length = len(val1.attributes)
        buff.write(_struct_I.pack(length))
        for val2 in val1.attributes:
          _v94 = val2.pose
          _v95 = _v94.position
          _x = _v95
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
          _v96 = _v94.orientation
          _x = _v96
          buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
          _v97 = val2.size
          _x = _v97
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
          _v98 = val2.color
          _x = _v98
          buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
      length = len(self.spheres)
      buff.write(_struct_I.pack(length))
      for val1 in self.spheres:
        _v99 = val1.timestamp
        _x = _v99
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _x = val1.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v100 = val1.lifetime
        _x = _v100
        buff.write(_get_struct_2i().pack(_x.secs, _x.nsecs))
        _x = val1.frame_locked
        buff.write(_get_struct_B().pack(_x))
        length = len(val1.metadata)
        buff.write(_struct_I.pack(length))
        for val2 in val1.metadata:
          _x = val2.key
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = val2.value
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        length = len(val1.attributes)
        buff.write(_struct_I.pack(length))
        for val2 in val1.attributes:
          _v101 = val2.pose
          _v102 = _v101.position
          _x = _v102
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
          _v103 = _v101.orientation
          _x = _v103
          buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
          _v104 = val2.size
          _x = _v104
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
          _v105 = val2.color
          _x = _v105
          buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
      length = len(self.cones)
      buff.write(_struct_I.pack(length))
      for val1 in self.cones:
        _v106 = val1.timestamp
        _x = _v106
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _x = val1.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v107 = val1.lifetime
        _x = _v107
        buff.write(_get_struct_2i().pack(_x.secs, _x.nsecs))
        _x = val1.frame_locked
        buff.write(_get_struct_B().pack(_x))
        length = len(val1.metadata)
        buff.write(_struct_I.pack(length))
        for val2 in val1.metadata:
          _x = val2.key
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = val2.value
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        length = len(val1.attributes)
        buff.write(_struct_I.pack(length))
        for val2 in val1.attributes:
          _v108 = val2.pose
          _v109 = _v108.position
          _x = _v109
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
          _v110 = _v108.orientation
          _x = _v110
          buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
          _v111 = val2.size
          _x = _v111
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
          _x = val2
          buff.write(_get_struct_2d().pack(_x.bottom_scale, _x.top_scale))
          _v112 = val2.color
          _x = _v112
          buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
      length = len(self.lines)
      buff.write(_struct_I.pack(length))
      for val1 in self.lines:
        _x = val1.type
        buff.write(_get_struct_B().pack(_x))
        _v113 = val1.pose
        _v114 = _v113.position
        _x = _v114
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v115 = _v113.orientation
        _x = _v115
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1
        buff.write(_get_struct_dB().pack(_x.thickness, _x.scale_invariant))
        length = len(val1.points)
        buff.write(_struct_I.pack(length))
        for val2 in val1.points:
          _x = val2
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v116 = val1.color
        _x = _v116
        buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
        length = len(val1.colors)
        buff.write(_struct_I.pack(length))
        for val2 in val1.colors:
          _x = val2
          buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
        length = len(val1.indices)
        buff.write(_struct_I.pack(length))
        pattern = '<%sI'%length
        buff.write(val1.indices.tostring())
      length = len(self.triangles)
      buff.write(_struct_I.pack(length))
      for val1 in self.triangles:
        _v117 = val1.pose
        _v118 = _v117.position
        _x = _v118
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v119 = _v117.orientation
        _x = _v119
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
        length = len(val1.points)
        buff.write(_struct_I.pack(length))
        for val2 in val1.points:
          _x = val2
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v120 = val1.color
        _x = _v120
        buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
        length = len(val1.colors)
        buff.write(_struct_I.pack(length))
        for val2 in val1.colors:
          _x = val2
          buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
        length = len(val1.indices)
        buff.write(_struct_I.pack(length))
        pattern = '<%sI'%length
        buff.write(val1.indices.tostring())
      length = len(self.texts)
      buff.write(_struct_I.pack(length))
      for val1 in self.texts:
        _v121 = val1.pose
        _v122 = _v121.position
        _x = _v122
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v123 = _v121.orientation
        _x = _v123
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1
        buff.write(_get_struct_BdB().pack(_x.billboard, _x.font_size, _x.scale_invariant))
        _v124 = val1.color
        _x = _v124
        buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
        _x = val1.text
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.models)
      buff.write(_struct_I.pack(length))
      for val1 in self.models:
        _v125 = val1.pose
        _v126 = _v125.position
        _x = _v126
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v127 = _v125.orientation
        _x = _v127
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
        _v128 = val1.scale
        _x = _v128
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v129 = val1.color
        _x = _v129
        buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
        _x = val1.use_embedded_materials
        buff.write(_get_struct_B().pack(_x))
        _x = val1.url
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.mime_type
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.data
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
        else:
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.deletions is None:
        self.deletions = None
      if self.arrows is None:
        self.arrows = None
      if self.cubes is None:
        self.cubes = None
      if self.spheres is None:
        self.spheres = None
      if self.cones is None:
        self.cones = None
      if self.lines is None:
        self.lines = None
      if self.triangles is None:
        self.triangles = None
      if self.texts is None:
        self.texts = None
      if self.models is None:
        self.models = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.deletions = []
      for i in range(0, length):
        val1 = foxglove_msgs.msg.MarkerDeletion()
        _v130 = val1.timestamp
        _x = _v130
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        start = end
        end += 1
        (val1.type,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.id = str[start:end]
        self.deletions.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.arrows = []
      for i in range(0, length):
        val1 = foxglove_msgs.msg.ArrowMarker()
        _v131 = val1.pose
        _v132 = _v131.position
        _x = _v132
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v133 = _v131.orientation
        _x = _v133
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        _x = val1
        start = end
        end += 32
        (_x.length, _x.shaft_diameter, _x.head_diameter, _x.head_length,) = _get_struct_4d().unpack(str[start:end])
        _v134 = val1.color
        _x = _v134
        start = end
        end += 32
        (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
        self.arrows.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.cubes = []
      for i in range(0, length):
        val1 = foxglove_msgs.msg.CubeListMarker()
        _v135 = val1.timestamp
        _x = _v135
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.frame_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.frame_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.id = str[start:end]
        _v136 = val1.lifetime
        _x = _v136
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2i().unpack(str[start:end])
        start = end
        end += 1
        (val1.frame_locked,) = _get_struct_B().unpack(str[start:end])
        val1.frame_locked = bool(val1.frame_locked)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.metadata = []
        for i in range(0, length):
          val2 = foxglove_msgs.msg.KeyValuePair()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.key = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2.key = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.value = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2.value = str[start:end]
          val1.metadata.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.attributes = []
        for i in range(0, length):
          val2 = foxglove_msgs.msg.CubeAttributes()
          _v137 = val2.pose
          _v138 = _v137.position
          _x = _v138
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          _v139 = _v137.orientation
          _x = _v139
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
          _v140 = val2.size
          _x = _v140
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          _v141 = val2.color
          _x = _v141
          start = end
          end += 32
          (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
          val1.attributes.append(val2)
        self.cubes.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.spheres = []
      for i in range(0, length):
        val1 = foxglove_msgs.msg.SphereListMarker()
        _v142 = val1.timestamp
        _x = _v142
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.frame_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.frame_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.id = str[start:end]
        _v143 = val1.lifetime
        _x = _v143
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2i().unpack(str[start:end])
        start = end
        end += 1
        (val1.frame_locked,) = _get_struct_B().unpack(str[start:end])
        val1.frame_locked = bool(val1.frame_locked)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.metadata = []
        for i in range(0, length):
          val2 = foxglove_msgs.msg.KeyValuePair()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.key = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2.key = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.value = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2.value = str[start:end]
          val1.metadata.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.attributes = []
        for i in range(0, length):
          val2 = foxglove_msgs.msg.SphereAttributes()
          _v144 = val2.pose
          _v145 = _v144.position
          _x = _v145
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          _v146 = _v144.orientation
          _x = _v146
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
          _v147 = val2.size
          _x = _v147
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          _v148 = val2.color
          _x = _v148
          start = end
          end += 32
          (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
          val1.attributes.append(val2)
        self.spheres.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.cones = []
      for i in range(0, length):
        val1 = foxglove_msgs.msg.ConeListMarker()
        _v149 = val1.timestamp
        _x = _v149
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.frame_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.frame_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.id = str[start:end]
        _v150 = val1.lifetime
        _x = _v150
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2i().unpack(str[start:end])
        start = end
        end += 1
        (val1.frame_locked,) = _get_struct_B().unpack(str[start:end])
        val1.frame_locked = bool(val1.frame_locked)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.metadata = []
        for i in range(0, length):
          val2 = foxglove_msgs.msg.KeyValuePair()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.key = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2.key = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.value = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2.value = str[start:end]
          val1.metadata.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.attributes = []
        for i in range(0, length):
          val2 = foxglove_msgs.msg.ConeAttributes()
          _v151 = val2.pose
          _v152 = _v151.position
          _x = _v152
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          _v153 = _v151.orientation
          _x = _v153
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
          _v154 = val2.size
          _x = _v154
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          _x = val2
          start = end
          end += 16
          (_x.bottom_scale, _x.top_scale,) = _get_struct_2d().unpack(str[start:end])
          _v155 = val2.color
          _x = _v155
          start = end
          end += 32
          (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
          val1.attributes.append(val2)
        self.cones.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.lines = []
      for i in range(0, length):
        val1 = foxglove_msgs.msg.LineMarker()
        start = end
        end += 1
        (val1.type,) = _get_struct_B().unpack(str[start:end])
        _v156 = val1.pose
        _v157 = _v156.position
        _x = _v157
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v158 = _v156.orientation
        _x = _v158
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        _x = val1
        start = end
        end += 9
        (_x.thickness, _x.scale_invariant,) = _get_struct_dB().unpack(str[start:end])
        val1.scale_invariant = bool(val1.scale_invariant)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.points = []
        for i in range(0, length):
          val2 = geometry_msgs.msg.Point()
          _x = val2
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          val1.points.append(val2)
        _v159 = val1.color
        _x = _v159
        start = end
        end += 32
        (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.colors = []
        for i in range(0, length):
          val2 = foxglove_msgs.msg.Color()
          _x = val2
          start = end
          end += 32
          (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
          val1.colors.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sI'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.indices = numpy.frombuffer(str[start:end], dtype=numpy.uint32, count=length)
        self.lines.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.triangles = []
      for i in range(0, length):
        val1 = foxglove_msgs.msg.TriangleListMarker()
        _v160 = val1.pose
        _v161 = _v160.position
        _x = _v161
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v162 = _v160.orientation
        _x = _v162
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.points = []
        for i in range(0, length):
          val2 = geometry_msgs.msg.Point()
          _x = val2
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          val1.points.append(val2)
        _v163 = val1.color
        _x = _v163
        start = end
        end += 32
        (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.colors = []
        for i in range(0, length):
          val2 = foxglove_msgs.msg.Color()
          _x = val2
          start = end
          end += 32
          (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
          val1.colors.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sI'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.indices = numpy.frombuffer(str[start:end], dtype=numpy.uint32, count=length)
        self.triangles.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.texts = []
      for i in range(0, length):
        val1 = foxglove_msgs.msg.TextMarker()
        _v164 = val1.pose
        _v165 = _v164.position
        _x = _v165
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v166 = _v164.orientation
        _x = _v166
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        _x = val1
        start = end
        end += 10
        (_x.billboard, _x.font_size, _x.scale_invariant,) = _get_struct_BdB().unpack(str[start:end])
        val1.billboard = bool(val1.billboard)
        val1.scale_invariant = bool(val1.scale_invariant)
        _v167 = val1.color
        _x = _v167
        start = end
        end += 32
        (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.text = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.text = str[start:end]
        self.texts.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.models = []
      for i in range(0, length):
        val1 = foxglove_msgs.msg.ModelMarker()
        _v168 = val1.pose
        _v169 = _v168.position
        _x = _v169
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v170 = _v168.orientation
        _x = _v170
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        _v171 = val1.scale
        _x = _v171
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v172 = val1.color
        _x = _v172
        start = end
        end += 32
        (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
        start = end
        end += 1
        (val1.use_embedded_materials,) = _get_struct_B().unpack(str[start:end])
        val1.use_embedded_materials = bool(val1.use_embedded_materials)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.url = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.url = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.mime_type = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.mime_type = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.data = str[start:end]
        self.models.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2I = None
def _get_struct_2I():
    global _struct_2I
    if _struct_2I is None:
        _struct_2I = struct.Struct("<2I")
    return _struct_2I
_struct_2d = None
def _get_struct_2d():
    global _struct_2d
    if _struct_2d is None:
        _struct_2d = struct.Struct("<2d")
    return _struct_2d
_struct_2i = None
def _get_struct_2i():
    global _struct_2i
    if _struct_2i is None:
        _struct_2i = struct.Struct("<2i")
    return _struct_2i
_struct_3d = None
def _get_struct_3d():
    global _struct_3d
    if _struct_3d is None:
        _struct_3d = struct.Struct("<3d")
    return _struct_3d
_struct_4d = None
def _get_struct_4d():
    global _struct_4d
    if _struct_4d is None:
        _struct_4d = struct.Struct("<4d")
    return _struct_4d
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
_struct_BdB = None
def _get_struct_BdB():
    global _struct_BdB
    if _struct_BdB is None:
        _struct_BdB = struct.Struct("<BdB")
    return _struct_BdB
_struct_dB = None
def _get_struct_dB():
    global _struct_dB
    if _struct_dB is None:
        _struct_dB = struct.Struct("<dB")
    return _struct_dB
