# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from foxglove_msgs/SceneEntity.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import foxglove_msgs.msg
import genpy
import geometry_msgs.msg

class SceneEntity(genpy.Message):
  _md5sum = "0ef0f20344c30e92e1768ed896c46bd7"
  _type = "foxglove_msgs/SceneEntity"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# foxglove_msgs/SceneEntity
# A visual element in a 3D scene. An entity may be composed of multiple primitives which all share the same frame of reference.

# Generated by https://github.com/foxglove/schemas

# Timestamp of the entity
time timestamp

# Frame of reference
string frame_id

# Identifier for the entity. A entity will replace any prior entity on the same topic with the same `id`.
string id

# Length of time (relative to `timestamp`) after which the entity should be automatically removed. Zero value indicates the entity should remain visible until it is replaced or deleted.
duration lifetime

# Whether the entity should keep its location in the fixed frame (false) or follow the frame specified in `frame_id` as it moves relative to the fixed frame (true)
bool frame_locked

# Additional user-provided metadata associated with the entity. Keys must be unique.
foxglove_msgs/KeyValuePair[] metadata

# Arrow primitives
foxglove_msgs/ArrowPrimitive[] arrows

# Cube primitives
foxglove_msgs/CubePrimitive[] cubes

# Sphere primitives
foxglove_msgs/SpherePrimitive[] spheres

# Cylinder primitives
foxglove_msgs/CylinderPrimitive[] cylinders

# Line primitives
foxglove_msgs/LinePrimitive[] lines

# Triangle list primitives
foxglove_msgs/TriangleListPrimitive[] triangles

# Text primitives
foxglove_msgs/TextPrimitive[] texts

# Model primitives
foxglove_msgs/ModelPrimitive[] models

================================================================================
MSG: foxglove_msgs/KeyValuePair
# foxglove_msgs/KeyValuePair
# A key with its associated value

# Generated by https://github.com/foxglove/schemas

# Key
string key

# Value
string value

================================================================================
MSG: foxglove_msgs/ArrowPrimitive
# foxglove_msgs/ArrowPrimitive
# A primitive representing an arrow

# Generated by https://github.com/foxglove/schemas

# Position of the arrow's tail and orientation of the arrow. Identity orientation means the arrow points in the +x direction.
geometry_msgs/Pose pose

# Length of the arrow shaft
float64 shaft_length

# Diameter of the arrow shaft
float64 shaft_diameter

# Length of the arrow head
float64 head_length

# Diameter of the arrow head
float64 head_diameter

# Color of the arrow
foxglove_msgs/Color color

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of position and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: foxglove_msgs/Color
# foxglove_msgs/Color
# A color in RGBA format

# Generated by https://github.com/foxglove/schemas

# Red value between 0 and 1
float64 r

# Green value between 0 and 1
float64 g

# Blue value between 0 and 1
float64 b

# Alpha value between 0 and 1
float64 a

================================================================================
MSG: foxglove_msgs/CubePrimitive
# foxglove_msgs/CubePrimitive
# A primitive representing a cube or rectangular prism

# Generated by https://github.com/foxglove/schemas

# Position of the center of the cube and orientation of the cube
geometry_msgs/Pose pose

# Size of the cube along each axis
geometry_msgs/Vector3 size

# Color of the cube
foxglove_msgs/Color color

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 
# It is only meant to represent a direction. Therefore, it does not
# make sense to apply a translation to it (e.g., when applying a 
# generic rigid transformation to a Vector3, tf2 will only apply the
# rotation). If you want your data to be translatable too, use the
# geometry_msgs/Point message instead.

float64 x
float64 y
float64 z
================================================================================
MSG: foxglove_msgs/SpherePrimitive
# foxglove_msgs/SpherePrimitive
# A primitive representing a sphere or ellipsoid

# Generated by https://github.com/foxglove/schemas

# Position of the center of the sphere and orientation of the sphere
geometry_msgs/Pose pose

# Size (diameter) of the sphere along each axis
geometry_msgs/Vector3 size

# Color of the sphere
foxglove_msgs/Color color

================================================================================
MSG: foxglove_msgs/CylinderPrimitive
# foxglove_msgs/CylinderPrimitive
# A primitive representing a cylinder, elliptic cylinder, or truncated cone

# Generated by https://github.com/foxglove/schemas

# Position of the center of the cylinder and orientation of the cylinder. The flat face(s) are perpendicular to the z-axis.
geometry_msgs/Pose pose

# Size of the cylinder's bounding box
geometry_msgs/Vector3 size

# 0-1, ratio of the diameter of the cylinder's bottom face (min z) to the bottom of the bounding box
float64 bottom_scale

# 0-1, ratio of the diameter of the cylinder's top face (max z) to the top of the bounding box
float64 top_scale

# Color of the cylinder
foxglove_msgs/Color color

================================================================================
MSG: foxglove_msgs/LinePrimitive
# foxglove_msgs/LinePrimitive
# A primitive representing a series of points connected by lines

# Generated by https://github.com/foxglove/schemas

# 0-1, 1-2, ..., (n-1)-n
uint8 LINE_STRIP=0

# 0-1, 1-2, ..., (n-1)-n, n-0
uint8 LINE_LOOP=1

# 0-1, 2-3, 4-5, ...
uint8 LINE_LIST=2

# Drawing primitive to use for lines
uint8 type

# Origin of lines relative to reference frame
geometry_msgs/Pose pose

# Line thickness
float64 thickness

# Indicates whether `thickness` is a fixed size in screen pixels (true), or specified in world coordinates and scales with distance from the camera (false)
bool scale_invariant

# Points along the line
geometry_msgs/Point[] points

# Solid color to use for the whole line. One of `color` or `colors` must be provided.
foxglove_msgs/Color color

# Per-point colors (if specified, must have the same length as `points`). One of `color` or `colors` must be provided.
foxglove_msgs/Color[] colors

# Indices into the `points` and `colors` attribute arrays, which can be used to avoid duplicating attribute data.
# 
# If omitted or empty, indexing will not be used. This default behavior is equivalent to specifying [0, 1, ..., N-1] for the indices (where N is the number of `points` provided).
uint32[] indices

================================================================================
MSG: foxglove_msgs/TriangleListPrimitive
# foxglove_msgs/TriangleListPrimitive
# A primitive representing a set of triangles or a surface tiled by triangles

# Generated by https://github.com/foxglove/schemas

# Origin of triangles relative to reference frame
geometry_msgs/Pose pose

# Vertices to use for triangles, interpreted as a list of triples (0-1-2, 3-4-5, ...)
geometry_msgs/Point[] points

# Solid color to use for the whole shape. One of `color` or `colors` must be provided.
foxglove_msgs/Color color

# Per-vertex colors (if specified, must have the same length as `points`). One of `color` or `colors` must be provided.
foxglove_msgs/Color[] colors

# Indices into the `points` and `colors` attribute arrays, which can be used to avoid duplicating attribute data.
# 
# If omitted or empty, indexing will not be used. This default behavior is equivalent to specifying [0, 1, ..., N-1] for the indices (where N is the number of `points` provided).
uint32[] indices

================================================================================
MSG: foxglove_msgs/TextPrimitive
# foxglove_msgs/TextPrimitive
# A primitive representing a text label

# Generated by https://github.com/foxglove/schemas

# Position of the center of the text box and orientation of the text. Identity orientation means the text is oriented in the xy-plane and flows from -x to +x.
geometry_msgs/Pose pose

# Whether the text should respect `pose.orientation` (false) or always face the camera (true)
bool billboard

# Font size (height of one line of text)
float64 font_size

# Indicates whether `font_size` is a fixed size in screen pixels (true), or specified in world coordinates and scales with distance from the camera (false)
bool scale_invariant

# Color of the text
foxglove_msgs/Color color

# Text
string text

================================================================================
MSG: foxglove_msgs/ModelPrimitive
# foxglove_msgs/ModelPrimitive
# A primitive representing a 3D model file loaded from an external URL or embedded data

# Generated by https://github.com/foxglove/schemas

# Origin of model relative to reference frame
geometry_msgs/Pose pose

# Scale factor to apply to the model along each axis
geometry_msgs/Vector3 scale

# Solid color to use for the whole model if `override_color` is true.
foxglove_msgs/Color color

# Whether to use the color specified in `color` instead of any materials embedded in the original model.
bool override_color

# URL pointing to model file. One of `url` or `data` should be provided.
string url

# [Media type](https://developer.mozilla.org/en-US/docs/Web/HTTP/Basics_of_HTTP/MIME_types) of embedded model (e.g. `model/gltf-binary`). Required if `data` is provided instead of `url`. Overrides the inferred media type if `url` is provided.
string media_type

# Embedded model. One of `url` or `data` should be provided. If `data` is provided, `media_type` must be set to indicate the type of the data.
uint8[] data
"""
  __slots__ = ['timestamp','frame_id','id','lifetime','frame_locked','metadata','arrows','cubes','spheres','cylinders','lines','triangles','texts','models']
  _slot_types = ['time','string','string','duration','bool','foxglove_msgs/KeyValuePair[]','foxglove_msgs/ArrowPrimitive[]','foxglove_msgs/CubePrimitive[]','foxglove_msgs/SpherePrimitive[]','foxglove_msgs/CylinderPrimitive[]','foxglove_msgs/LinePrimitive[]','foxglove_msgs/TriangleListPrimitive[]','foxglove_msgs/TextPrimitive[]','foxglove_msgs/ModelPrimitive[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp,frame_id,id,lifetime,frame_locked,metadata,arrows,cubes,spheres,cylinders,lines,triangles,texts,models

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(SceneEntity, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.timestamp is None:
        self.timestamp = genpy.Time()
      if self.frame_id is None:
        self.frame_id = ''
      if self.id is None:
        self.id = ''
      if self.lifetime is None:
        self.lifetime = genpy.Duration()
      if self.frame_locked is None:
        self.frame_locked = False
      if self.metadata is None:
        self.metadata = []
      if self.arrows is None:
        self.arrows = []
      if self.cubes is None:
        self.cubes = []
      if self.spheres is None:
        self.spheres = []
      if self.cylinders is None:
        self.cylinders = []
      if self.lines is None:
        self.lines = []
      if self.triangles is None:
        self.triangles = []
      if self.texts is None:
        self.texts = []
      if self.models is None:
        self.models = []
    else:
      self.timestamp = genpy.Time()
      self.frame_id = ''
      self.id = ''
      self.lifetime = genpy.Duration()
      self.frame_locked = False
      self.metadata = []
      self.arrows = []
      self.cubes = []
      self.spheres = []
      self.cylinders = []
      self.lines = []
      self.triangles = []
      self.texts = []
      self.models = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2I().pack(_x.timestamp.secs, _x.timestamp.nsecs))
      _x = self.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2iB().pack(_x.lifetime.secs, _x.lifetime.nsecs, _x.frame_locked))
      length = len(self.metadata)
      buff.write(_struct_I.pack(length))
      for val1 in self.metadata:
        _x = val1.key
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.value
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.arrows)
      buff.write(_struct_I.pack(length))
      for val1 in self.arrows:
        _v1 = val1.pose
        _v2 = _v1.position
        _x = _v2
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v3 = _v1.orientation
        _x = _v3
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1
        buff.write(_get_struct_4d().pack(_x.shaft_length, _x.shaft_diameter, _x.head_length, _x.head_diameter))
        _v4 = val1.color
        _x = _v4
        buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
      length = len(self.cubes)
      buff.write(_struct_I.pack(length))
      for val1 in self.cubes:
        _v5 = val1.pose
        _v6 = _v5.position
        _x = _v6
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v7 = _v5.orientation
        _x = _v7
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
        _v8 = val1.size
        _x = _v8
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v9 = val1.color
        _x = _v9
        buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
      length = len(self.spheres)
      buff.write(_struct_I.pack(length))
      for val1 in self.spheres:
        _v10 = val1.pose
        _v11 = _v10.position
        _x = _v11
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v12 = _v10.orientation
        _x = _v12
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
        _v13 = val1.size
        _x = _v13
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v14 = val1.color
        _x = _v14
        buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
      length = len(self.cylinders)
      buff.write(_struct_I.pack(length))
      for val1 in self.cylinders:
        _v15 = val1.pose
        _v16 = _v15.position
        _x = _v16
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v17 = _v15.orientation
        _x = _v17
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
        _v18 = val1.size
        _x = _v18
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _x = val1
        buff.write(_get_struct_2d().pack(_x.bottom_scale, _x.top_scale))
        _v19 = val1.color
        _x = _v19
        buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
      length = len(self.lines)
      buff.write(_struct_I.pack(length))
      for val1 in self.lines:
        _x = val1.type
        buff.write(_get_struct_B().pack(_x))
        _v20 = val1.pose
        _v21 = _v20.position
        _x = _v21
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v22 = _v20.orientation
        _x = _v22
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1
        buff.write(_get_struct_dB().pack(_x.thickness, _x.scale_invariant))
        length = len(val1.points)
        buff.write(_struct_I.pack(length))
        for val2 in val1.points:
          _x = val2
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v23 = val1.color
        _x = _v23
        buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
        length = len(val1.colors)
        buff.write(_struct_I.pack(length))
        for val2 in val1.colors:
          _x = val2
          buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
        length = len(val1.indices)
        buff.write(_struct_I.pack(length))
        pattern = '<%sI'%length
        buff.write(struct.Struct(pattern).pack(*val1.indices))
      length = len(self.triangles)
      buff.write(_struct_I.pack(length))
      for val1 in self.triangles:
        _v24 = val1.pose
        _v25 = _v24.position
        _x = _v25
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v26 = _v24.orientation
        _x = _v26
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
        length = len(val1.points)
        buff.write(_struct_I.pack(length))
        for val2 in val1.points:
          _x = val2
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v27 = val1.color
        _x = _v27
        buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
        length = len(val1.colors)
        buff.write(_struct_I.pack(length))
        for val2 in val1.colors:
          _x = val2
          buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
        length = len(val1.indices)
        buff.write(_struct_I.pack(length))
        pattern = '<%sI'%length
        buff.write(struct.Struct(pattern).pack(*val1.indices))
      length = len(self.texts)
      buff.write(_struct_I.pack(length))
      for val1 in self.texts:
        _v28 = val1.pose
        _v29 = _v28.position
        _x = _v29
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v30 = _v28.orientation
        _x = _v30
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1
        buff.write(_get_struct_BdB().pack(_x.billboard, _x.font_size, _x.scale_invariant))
        _v31 = val1.color
        _x = _v31
        buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
        _x = val1.text
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.models)
      buff.write(_struct_I.pack(length))
      for val1 in self.models:
        _v32 = val1.pose
        _v33 = _v32.position
        _x = _v33
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v34 = _v32.orientation
        _x = _v34
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
        _v35 = val1.scale
        _x = _v35
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v36 = val1.color
        _x = _v36
        buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
        _x = val1.override_color
        buff.write(_get_struct_B().pack(_x))
        _x = val1.url
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.media_type
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.data
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
        else:
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.timestamp is None:
        self.timestamp = genpy.Time()
      if self.lifetime is None:
        self.lifetime = genpy.Duration()
      if self.metadata is None:
        self.metadata = None
      if self.arrows is None:
        self.arrows = None
      if self.cubes is None:
        self.cubes = None
      if self.spheres is None:
        self.spheres = None
      if self.cylinders is None:
        self.cylinders = None
      if self.lines is None:
        self.lines = None
      if self.triangles is None:
        self.triangles = None
      if self.texts is None:
        self.texts = None
      if self.models is None:
        self.models = None
      end = 0
      _x = self
      start = end
      end += 8
      (_x.timestamp.secs, _x.timestamp.nsecs,) = _get_struct_2I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.id = str[start:end]
      _x = self
      start = end
      end += 9
      (_x.lifetime.secs, _x.lifetime.nsecs, _x.frame_locked,) = _get_struct_2iB().unpack(str[start:end])
      self.frame_locked = bool(self.frame_locked)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.metadata = []
      for i in range(0, length):
        val1 = foxglove_msgs.msg.KeyValuePair()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.key = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.key = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.value = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.value = str[start:end]
        self.metadata.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.arrows = []
      for i in range(0, length):
        val1 = foxglove_msgs.msg.ArrowPrimitive()
        _v37 = val1.pose
        _v38 = _v37.position
        _x = _v38
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v39 = _v37.orientation
        _x = _v39
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        _x = val1
        start = end
        end += 32
        (_x.shaft_length, _x.shaft_diameter, _x.head_length, _x.head_diameter,) = _get_struct_4d().unpack(str[start:end])
        _v40 = val1.color
        _x = _v40
        start = end
        end += 32
        (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
        self.arrows.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.cubes = []
      for i in range(0, length):
        val1 = foxglove_msgs.msg.CubePrimitive()
        _v41 = val1.pose
        _v42 = _v41.position
        _x = _v42
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v43 = _v41.orientation
        _x = _v43
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        _v44 = val1.size
        _x = _v44
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v45 = val1.color
        _x = _v45
        start = end
        end += 32
        (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
        self.cubes.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.spheres = []
      for i in range(0, length):
        val1 = foxglove_msgs.msg.SpherePrimitive()
        _v46 = val1.pose
        _v47 = _v46.position
        _x = _v47
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v48 = _v46.orientation
        _x = _v48
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        _v49 = val1.size
        _x = _v49
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v50 = val1.color
        _x = _v50
        start = end
        end += 32
        (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
        self.spheres.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.cylinders = []
      for i in range(0, length):
        val1 = foxglove_msgs.msg.CylinderPrimitive()
        _v51 = val1.pose
        _v52 = _v51.position
        _x = _v52
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v53 = _v51.orientation
        _x = _v53
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        _v54 = val1.size
        _x = _v54
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _x = val1
        start = end
        end += 16
        (_x.bottom_scale, _x.top_scale,) = _get_struct_2d().unpack(str[start:end])
        _v55 = val1.color
        _x = _v55
        start = end
        end += 32
        (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
        self.cylinders.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.lines = []
      for i in range(0, length):
        val1 = foxglove_msgs.msg.LinePrimitive()
        start = end
        end += 1
        (val1.type,) = _get_struct_B().unpack(str[start:end])
        _v56 = val1.pose
        _v57 = _v56.position
        _x = _v57
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v58 = _v56.orientation
        _x = _v58
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        _x = val1
        start = end
        end += 9
        (_x.thickness, _x.scale_invariant,) = _get_struct_dB().unpack(str[start:end])
        val1.scale_invariant = bool(val1.scale_invariant)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.points = []
        for i in range(0, length):
          val2 = geometry_msgs.msg.Point()
          _x = val2
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          val1.points.append(val2)
        _v59 = val1.color
        _x = _v59
        start = end
        end += 32
        (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.colors = []
        for i in range(0, length):
          val2 = foxglove_msgs.msg.Color()
          _x = val2
          start = end
          end += 32
          (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
          val1.colors.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sI'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.indices = s.unpack(str[start:end])
        self.lines.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.triangles = []
      for i in range(0, length):
        val1 = foxglove_msgs.msg.TriangleListPrimitive()
        _v60 = val1.pose
        _v61 = _v60.position
        _x = _v61
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v62 = _v60.orientation
        _x = _v62
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.points = []
        for i in range(0, length):
          val2 = geometry_msgs.msg.Point()
          _x = val2
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          val1.points.append(val2)
        _v63 = val1.color
        _x = _v63
        start = end
        end += 32
        (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.colors = []
        for i in range(0, length):
          val2 = foxglove_msgs.msg.Color()
          _x = val2
          start = end
          end += 32
          (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
          val1.colors.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sI'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.indices = s.unpack(str[start:end])
        self.triangles.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.texts = []
      for i in range(0, length):
        val1 = foxglove_msgs.msg.TextPrimitive()
        _v64 = val1.pose
        _v65 = _v64.position
        _x = _v65
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v66 = _v64.orientation
        _x = _v66
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        _x = val1
        start = end
        end += 10
        (_x.billboard, _x.font_size, _x.scale_invariant,) = _get_struct_BdB().unpack(str[start:end])
        val1.billboard = bool(val1.billboard)
        val1.scale_invariant = bool(val1.scale_invariant)
        _v67 = val1.color
        _x = _v67
        start = end
        end += 32
        (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.text = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.text = str[start:end]
        self.texts.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.models = []
      for i in range(0, length):
        val1 = foxglove_msgs.msg.ModelPrimitive()
        _v68 = val1.pose
        _v69 = _v68.position
        _x = _v69
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v70 = _v68.orientation
        _x = _v70
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        _v71 = val1.scale
        _x = _v71
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v72 = val1.color
        _x = _v72
        start = end
        end += 32
        (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
        start = end
        end += 1
        (val1.override_color,) = _get_struct_B().unpack(str[start:end])
        val1.override_color = bool(val1.override_color)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.url = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.url = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.media_type = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.media_type = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.data = str[start:end]
        self.models.append(val1)
      self.timestamp.canon()
      self.lifetime.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2I().pack(_x.timestamp.secs, _x.timestamp.nsecs))
      _x = self.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2iB().pack(_x.lifetime.secs, _x.lifetime.nsecs, _x.frame_locked))
      length = len(self.metadata)
      buff.write(_struct_I.pack(length))
      for val1 in self.metadata:
        _x = val1.key
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.value
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.arrows)
      buff.write(_struct_I.pack(length))
      for val1 in self.arrows:
        _v73 = val1.pose
        _v74 = _v73.position
        _x = _v74
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v75 = _v73.orientation
        _x = _v75
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1
        buff.write(_get_struct_4d().pack(_x.shaft_length, _x.shaft_diameter, _x.head_length, _x.head_diameter))
        _v76 = val1.color
        _x = _v76
        buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
      length = len(self.cubes)
      buff.write(_struct_I.pack(length))
      for val1 in self.cubes:
        _v77 = val1.pose
        _v78 = _v77.position
        _x = _v78
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v79 = _v77.orientation
        _x = _v79
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
        _v80 = val1.size
        _x = _v80
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v81 = val1.color
        _x = _v81
        buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
      length = len(self.spheres)
      buff.write(_struct_I.pack(length))
      for val1 in self.spheres:
        _v82 = val1.pose
        _v83 = _v82.position
        _x = _v83
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v84 = _v82.orientation
        _x = _v84
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
        _v85 = val1.size
        _x = _v85
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v86 = val1.color
        _x = _v86
        buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
      length = len(self.cylinders)
      buff.write(_struct_I.pack(length))
      for val1 in self.cylinders:
        _v87 = val1.pose
        _v88 = _v87.position
        _x = _v88
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v89 = _v87.orientation
        _x = _v89
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
        _v90 = val1.size
        _x = _v90
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _x = val1
        buff.write(_get_struct_2d().pack(_x.bottom_scale, _x.top_scale))
        _v91 = val1.color
        _x = _v91
        buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
      length = len(self.lines)
      buff.write(_struct_I.pack(length))
      for val1 in self.lines:
        _x = val1.type
        buff.write(_get_struct_B().pack(_x))
        _v92 = val1.pose
        _v93 = _v92.position
        _x = _v93
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v94 = _v92.orientation
        _x = _v94
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1
        buff.write(_get_struct_dB().pack(_x.thickness, _x.scale_invariant))
        length = len(val1.points)
        buff.write(_struct_I.pack(length))
        for val2 in val1.points:
          _x = val2
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v95 = val1.color
        _x = _v95
        buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
        length = len(val1.colors)
        buff.write(_struct_I.pack(length))
        for val2 in val1.colors:
          _x = val2
          buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
        length = len(val1.indices)
        buff.write(_struct_I.pack(length))
        pattern = '<%sI'%length
        buff.write(val1.indices.tostring())
      length = len(self.triangles)
      buff.write(_struct_I.pack(length))
      for val1 in self.triangles:
        _v96 = val1.pose
        _v97 = _v96.position
        _x = _v97
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v98 = _v96.orientation
        _x = _v98
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
        length = len(val1.points)
        buff.write(_struct_I.pack(length))
        for val2 in val1.points:
          _x = val2
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v99 = val1.color
        _x = _v99
        buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
        length = len(val1.colors)
        buff.write(_struct_I.pack(length))
        for val2 in val1.colors:
          _x = val2
          buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
        length = len(val1.indices)
        buff.write(_struct_I.pack(length))
        pattern = '<%sI'%length
        buff.write(val1.indices.tostring())
      length = len(self.texts)
      buff.write(_struct_I.pack(length))
      for val1 in self.texts:
        _v100 = val1.pose
        _v101 = _v100.position
        _x = _v101
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v102 = _v100.orientation
        _x = _v102
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1
        buff.write(_get_struct_BdB().pack(_x.billboard, _x.font_size, _x.scale_invariant))
        _v103 = val1.color
        _x = _v103
        buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
        _x = val1.text
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.models)
      buff.write(_struct_I.pack(length))
      for val1 in self.models:
        _v104 = val1.pose
        _v105 = _v104.position
        _x = _v105
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v106 = _v104.orientation
        _x = _v106
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
        _v107 = val1.scale
        _x = _v107
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v108 = val1.color
        _x = _v108
        buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
        _x = val1.override_color
        buff.write(_get_struct_B().pack(_x))
        _x = val1.url
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.media_type
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.data
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
        else:
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.timestamp is None:
        self.timestamp = genpy.Time()
      if self.lifetime is None:
        self.lifetime = genpy.Duration()
      if self.metadata is None:
        self.metadata = None
      if self.arrows is None:
        self.arrows = None
      if self.cubes is None:
        self.cubes = None
      if self.spheres is None:
        self.spheres = None
      if self.cylinders is None:
        self.cylinders = None
      if self.lines is None:
        self.lines = None
      if self.triangles is None:
        self.triangles = None
      if self.texts is None:
        self.texts = None
      if self.models is None:
        self.models = None
      end = 0
      _x = self
      start = end
      end += 8
      (_x.timestamp.secs, _x.timestamp.nsecs,) = _get_struct_2I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.id = str[start:end]
      _x = self
      start = end
      end += 9
      (_x.lifetime.secs, _x.lifetime.nsecs, _x.frame_locked,) = _get_struct_2iB().unpack(str[start:end])
      self.frame_locked = bool(self.frame_locked)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.metadata = []
      for i in range(0, length):
        val1 = foxglove_msgs.msg.KeyValuePair()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.key = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.key = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.value = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.value = str[start:end]
        self.metadata.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.arrows = []
      for i in range(0, length):
        val1 = foxglove_msgs.msg.ArrowPrimitive()
        _v109 = val1.pose
        _v110 = _v109.position
        _x = _v110
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v111 = _v109.orientation
        _x = _v111
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        _x = val1
        start = end
        end += 32
        (_x.shaft_length, _x.shaft_diameter, _x.head_length, _x.head_diameter,) = _get_struct_4d().unpack(str[start:end])
        _v112 = val1.color
        _x = _v112
        start = end
        end += 32
        (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
        self.arrows.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.cubes = []
      for i in range(0, length):
        val1 = foxglove_msgs.msg.CubePrimitive()
        _v113 = val1.pose
        _v114 = _v113.position
        _x = _v114
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v115 = _v113.orientation
        _x = _v115
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        _v116 = val1.size
        _x = _v116
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v117 = val1.color
        _x = _v117
        start = end
        end += 32
        (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
        self.cubes.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.spheres = []
      for i in range(0, length):
        val1 = foxglove_msgs.msg.SpherePrimitive()
        _v118 = val1.pose
        _v119 = _v118.position
        _x = _v119
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v120 = _v118.orientation
        _x = _v120
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        _v121 = val1.size
        _x = _v121
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v122 = val1.color
        _x = _v122
        start = end
        end += 32
        (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
        self.spheres.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.cylinders = []
      for i in range(0, length):
        val1 = foxglove_msgs.msg.CylinderPrimitive()
        _v123 = val1.pose
        _v124 = _v123.position
        _x = _v124
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v125 = _v123.orientation
        _x = _v125
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        _v126 = val1.size
        _x = _v126
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _x = val1
        start = end
        end += 16
        (_x.bottom_scale, _x.top_scale,) = _get_struct_2d().unpack(str[start:end])
        _v127 = val1.color
        _x = _v127
        start = end
        end += 32
        (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
        self.cylinders.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.lines = []
      for i in range(0, length):
        val1 = foxglove_msgs.msg.LinePrimitive()
        start = end
        end += 1
        (val1.type,) = _get_struct_B().unpack(str[start:end])
        _v128 = val1.pose
        _v129 = _v128.position
        _x = _v129
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v130 = _v128.orientation
        _x = _v130
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        _x = val1
        start = end
        end += 9
        (_x.thickness, _x.scale_invariant,) = _get_struct_dB().unpack(str[start:end])
        val1.scale_invariant = bool(val1.scale_invariant)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.points = []
        for i in range(0, length):
          val2 = geometry_msgs.msg.Point()
          _x = val2
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          val1.points.append(val2)
        _v131 = val1.color
        _x = _v131
        start = end
        end += 32
        (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.colors = []
        for i in range(0, length):
          val2 = foxglove_msgs.msg.Color()
          _x = val2
          start = end
          end += 32
          (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
          val1.colors.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sI'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.indices = numpy.frombuffer(str[start:end], dtype=numpy.uint32, count=length)
        self.lines.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.triangles = []
      for i in range(0, length):
        val1 = foxglove_msgs.msg.TriangleListPrimitive()
        _v132 = val1.pose
        _v133 = _v132.position
        _x = _v133
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v134 = _v132.orientation
        _x = _v134
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.points = []
        for i in range(0, length):
          val2 = geometry_msgs.msg.Point()
          _x = val2
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          val1.points.append(val2)
        _v135 = val1.color
        _x = _v135
        start = end
        end += 32
        (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.colors = []
        for i in range(0, length):
          val2 = foxglove_msgs.msg.Color()
          _x = val2
          start = end
          end += 32
          (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
          val1.colors.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sI'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.indices = numpy.frombuffer(str[start:end], dtype=numpy.uint32, count=length)
        self.triangles.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.texts = []
      for i in range(0, length):
        val1 = foxglove_msgs.msg.TextPrimitive()
        _v136 = val1.pose
        _v137 = _v136.position
        _x = _v137
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v138 = _v136.orientation
        _x = _v138
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        _x = val1
        start = end
        end += 10
        (_x.billboard, _x.font_size, _x.scale_invariant,) = _get_struct_BdB().unpack(str[start:end])
        val1.billboard = bool(val1.billboard)
        val1.scale_invariant = bool(val1.scale_invariant)
        _v139 = val1.color
        _x = _v139
        start = end
        end += 32
        (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.text = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.text = str[start:end]
        self.texts.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.models = []
      for i in range(0, length):
        val1 = foxglove_msgs.msg.ModelPrimitive()
        _v140 = val1.pose
        _v141 = _v140.position
        _x = _v141
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v142 = _v140.orientation
        _x = _v142
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        _v143 = val1.scale
        _x = _v143
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v144 = val1.color
        _x = _v144
        start = end
        end += 32
        (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
        start = end
        end += 1
        (val1.override_color,) = _get_struct_B().unpack(str[start:end])
        val1.override_color = bool(val1.override_color)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.url = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.url = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.media_type = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.media_type = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.data = str[start:end]
        self.models.append(val1)
      self.timestamp.canon()
      self.lifetime.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2I = None
def _get_struct_2I():
    global _struct_2I
    if _struct_2I is None:
        _struct_2I = struct.Struct("<2I")
    return _struct_2I
_struct_2d = None
def _get_struct_2d():
    global _struct_2d
    if _struct_2d is None:
        _struct_2d = struct.Struct("<2d")
    return _struct_2d
_struct_2iB = None
def _get_struct_2iB():
    global _struct_2iB
    if _struct_2iB is None:
        _struct_2iB = struct.Struct("<2iB")
    return _struct_2iB
_struct_3d = None
def _get_struct_3d():
    global _struct_3d
    if _struct_3d is None:
        _struct_3d = struct.Struct("<3d")
    return _struct_3d
_struct_4d = None
def _get_struct_4d():
    global _struct_4d
    if _struct_4d is None:
        _struct_4d = struct.Struct("<4d")
    return _struct_4d
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
_struct_BdB = None
def _get_struct_BdB():
    global _struct_BdB
    if _struct_BdB is None:
        _struct_BdB = struct.Struct("<BdB")
    return _struct_BdB
_struct_dB = None
def _get_struct_dB():
    global _struct_dB
    if _struct_dB is None:
        _struct_dB = struct.Struct("<dB")
    return _struct_dB
