# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from foxglove_msgs/SceneEntityUpdate.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import foxglove_msgs.msg
import genpy
import geometry_msgs.msg

class SceneEntityUpdate(genpy.Message):
  _md5sum = "59bc58a3679e8fc3874b14b39276e03a"
  _type = "foxglove_msgs/SceneEntityUpdate"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# foxglove_msgs/SceneEntityUpdate
# An update to the entities displayed in a 3D scene

# Generated by https://github.com/foxglove/schemas

# Scene entities to delete
foxglove_msgs/SceneEntityDeletion[] deletions

# Scene entities to add or replace
foxglove_msgs/SceneEntity[] entities

================================================================================
MSG: foxglove_msgs/SceneEntityDeletion
# foxglove_msgs/SceneEntityDeletion
# Command to remove previously published entities

# Generated by https://github.com/foxglove/schemas

# Timestamp of the deletion. Only matching entities earlier than this timestamp will be deleted.
time timestamp

# Delete the existing entity on the same topic that has the provided `id`
uint8 MATCHING_ID=0

# Delete all existing entities on the same topic
uint8 ALL=1

# Type of deletion action to perform
uint8 type

# Identifier which must match if `type` is `MATCHING_ID`.
string id

================================================================================
MSG: foxglove_msgs/SceneEntity
# foxglove_msgs/SceneEntity
# A visual element in a 3D scene. An entity may be composed of multiple primitives which all share the same frame of reference.

# Generated by https://github.com/foxglove/schemas

# Timestamp of the entity
time timestamp

# Frame of reference
string frame_id

# Identifier for the entity. A entity will replace any prior entity on the same topic with the same `id`.
string id

# Length of time (relative to `timestamp`) after which the entity should be automatically removed. Zero value indicates the entity should remain visible until it is replaced or deleted.
duration lifetime

# Whether the entity should keep its location in the fixed frame (false) or follow the frame specified in `frame_id` as it moves relative to the fixed frame (true)
bool frame_locked

# Additional user-provided metadata associated with the entity. Keys must be unique.
foxglove_msgs/KeyValuePair[] metadata

# Arrow primitives
foxglove_msgs/ArrowPrimitive[] arrows

# Cube primitives
foxglove_msgs/CubePrimitive[] cubes

# Sphere primitives
foxglove_msgs/SpherePrimitive[] spheres

# Cylinder primitives
foxglove_msgs/CylinderPrimitive[] cylinders

# Line primitives
foxglove_msgs/LinePrimitive[] lines

# Triangle list primitives
foxglove_msgs/TriangleListPrimitive[] triangles

# Text primitives
foxglove_msgs/TextPrimitive[] texts

# Model primitives
foxglove_msgs/ModelPrimitive[] models

================================================================================
MSG: foxglove_msgs/KeyValuePair
# foxglove_msgs/KeyValuePair
# A key with its associated value

# Generated by https://github.com/foxglove/schemas

# Key
string key

# Value
string value

================================================================================
MSG: foxglove_msgs/ArrowPrimitive
# foxglove_msgs/ArrowPrimitive
# A primitive representing an arrow

# Generated by https://github.com/foxglove/schemas

# Position of the arrow's tail and orientation of the arrow. Identity orientation means the arrow points in the +x direction.
geometry_msgs/Pose pose

# Length of the arrow shaft
float64 shaft_length

# Diameter of the arrow shaft
float64 shaft_diameter

# Length of the arrow head
float64 head_length

# Diameter of the arrow head
float64 head_diameter

# Color of the arrow
foxglove_msgs/Color color

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of position and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: foxglove_msgs/Color
# foxglove_msgs/Color
# A color in RGBA format

# Generated by https://github.com/foxglove/schemas

# Red value between 0 and 1
float64 r

# Green value between 0 and 1
float64 g

# Blue value between 0 and 1
float64 b

# Alpha value between 0 and 1
float64 a

================================================================================
MSG: foxglove_msgs/CubePrimitive
# foxglove_msgs/CubePrimitive
# A primitive representing a cube or rectangular prism

# Generated by https://github.com/foxglove/schemas

# Position of the center of the cube and orientation of the cube
geometry_msgs/Pose pose

# Size of the cube along each axis
geometry_msgs/Vector3 size

# Color of the cube
foxglove_msgs/Color color

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 
# It is only meant to represent a direction. Therefore, it does not
# make sense to apply a translation to it (e.g., when applying a 
# generic rigid transformation to a Vector3, tf2 will only apply the
# rotation). If you want your data to be translatable too, use the
# geometry_msgs/Point message instead.

float64 x
float64 y
float64 z
================================================================================
MSG: foxglove_msgs/SpherePrimitive
# foxglove_msgs/SpherePrimitive
# A primitive representing a sphere or ellipsoid

# Generated by https://github.com/foxglove/schemas

# Position of the center of the sphere and orientation of the sphere
geometry_msgs/Pose pose

# Size (diameter) of the sphere along each axis
geometry_msgs/Vector3 size

# Color of the sphere
foxglove_msgs/Color color

================================================================================
MSG: foxglove_msgs/CylinderPrimitive
# foxglove_msgs/CylinderPrimitive
# A primitive representing a cylinder, elliptic cylinder, or truncated cone

# Generated by https://github.com/foxglove/schemas

# Position of the center of the cylinder and orientation of the cylinder. The flat face(s) are perpendicular to the z-axis.
geometry_msgs/Pose pose

# Size of the cylinder's bounding box
geometry_msgs/Vector3 size

# 0-1, ratio of the diameter of the cylinder's bottom face (min z) to the bottom of the bounding box
float64 bottom_scale

# 0-1, ratio of the diameter of the cylinder's top face (max z) to the top of the bounding box
float64 top_scale

# Color of the cylinder
foxglove_msgs/Color color

================================================================================
MSG: foxglove_msgs/LinePrimitive
# foxglove_msgs/LinePrimitive
# A primitive representing a series of points connected by lines

# Generated by https://github.com/foxglove/schemas

# 0-1, 1-2, ..., (n-1)-n
uint8 LINE_STRIP=0

# 0-1, 1-2, ..., (n-1)-n, n-0
uint8 LINE_LOOP=1

# 0-1, 2-3, 4-5, ...
uint8 LINE_LIST=2

# Drawing primitive to use for lines
uint8 type

# Origin of lines relative to reference frame
geometry_msgs/Pose pose

# Line thickness
float64 thickness

# Indicates whether `thickness` is a fixed size in screen pixels (true), or specified in world coordinates and scales with distance from the camera (false)
bool scale_invariant

# Points along the line
geometry_msgs/Point[] points

# Solid color to use for the whole line. One of `color` or `colors` must be provided.
foxglove_msgs/Color color

# Per-point colors (if specified, must have the same length as `points`). One of `color` or `colors` must be provided.
foxglove_msgs/Color[] colors

# Indices into the `points` and `colors` attribute arrays, which can be used to avoid duplicating attribute data.
# 
# If omitted or empty, indexing will not be used. This default behavior is equivalent to specifying [0, 1, ..., N-1] for the indices (where N is the number of `points` provided).
uint32[] indices

================================================================================
MSG: foxglove_msgs/TriangleListPrimitive
# foxglove_msgs/TriangleListPrimitive
# A primitive representing a set of triangles or a surface tiled by triangles

# Generated by https://github.com/foxglove/schemas

# Origin of triangles relative to reference frame
geometry_msgs/Pose pose

# Vertices to use for triangles, interpreted as a list of triples (0-1-2, 3-4-5, ...)
geometry_msgs/Point[] points

# Solid color to use for the whole shape. One of `color` or `colors` must be provided.
foxglove_msgs/Color color

# Per-vertex colors (if specified, must have the same length as `points`). One of `color` or `colors` must be provided.
foxglove_msgs/Color[] colors

# Indices into the `points` and `colors` attribute arrays, which can be used to avoid duplicating attribute data.
# 
# If omitted or empty, indexing will not be used. This default behavior is equivalent to specifying [0, 1, ..., N-1] for the indices (where N is the number of `points` provided).
uint32[] indices

================================================================================
MSG: foxglove_msgs/TextPrimitive
# foxglove_msgs/TextPrimitive
# A primitive representing a text label

# Generated by https://github.com/foxglove/schemas

# Position of the center of the text box and orientation of the text. Identity orientation means the text is oriented in the xy-plane and flows from -x to +x.
geometry_msgs/Pose pose

# Whether the text should respect `pose.orientation` (false) or always face the camera (true)
bool billboard

# Font size (height of one line of text)
float64 font_size

# Indicates whether `font_size` is a fixed size in screen pixels (true), or specified in world coordinates and scales with distance from the camera (false)
bool scale_invariant

# Color of the text
foxglove_msgs/Color color

# Text
string text

================================================================================
MSG: foxglove_msgs/ModelPrimitive
# foxglove_msgs/ModelPrimitive
# A primitive representing a 3D model file loaded from an external URL or embedded data

# Generated by https://github.com/foxglove/schemas

# Origin of model relative to reference frame
geometry_msgs/Pose pose

# Scale factor to apply to the model along each axis
geometry_msgs/Vector3 scale

# Solid color to use for the whole model if `override_color` is true.
foxglove_msgs/Color color

# Whether to use the color specified in `color` instead of any materials embedded in the original model.
bool override_color

# URL pointing to model file. One of `url` or `data` should be provided.
string url

# [Media type](https://developer.mozilla.org/en-US/docs/Web/HTTP/Basics_of_HTTP/MIME_types) of embedded model (e.g. `model/gltf-binary`). Required if `data` is provided instead of `url`. Overrides the inferred media type if `url` is provided.
string media_type

# Embedded model. One of `url` or `data` should be provided. If `data` is provided, `media_type` must be set to indicate the type of the data.
uint8[] data
"""
  __slots__ = ['deletions','entities']
  _slot_types = ['foxglove_msgs/SceneEntityDeletion[]','foxglove_msgs/SceneEntity[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       deletions,entities

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(SceneEntityUpdate, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.deletions is None:
        self.deletions = []
      if self.entities is None:
        self.entities = []
    else:
      self.deletions = []
      self.entities = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      length = len(self.deletions)
      buff.write(_struct_I.pack(length))
      for val1 in self.deletions:
        _v1 = val1.timestamp
        _x = _v1
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _x = val1.type
        buff.write(_get_struct_B().pack(_x))
        _x = val1.id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.entities)
      buff.write(_struct_I.pack(length))
      for val1 in self.entities:
        _v2 = val1.timestamp
        _x = _v2
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _x = val1.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v3 = val1.lifetime
        _x = _v3
        buff.write(_get_struct_2i().pack(_x.secs, _x.nsecs))
        _x = val1.frame_locked
        buff.write(_get_struct_B().pack(_x))
        length = len(val1.metadata)
        buff.write(_struct_I.pack(length))
        for val2 in val1.metadata:
          _x = val2.key
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = val2.value
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        length = len(val1.arrows)
        buff.write(_struct_I.pack(length))
        for val2 in val1.arrows:
          _v4 = val2.pose
          _v5 = _v4.position
          _x = _v5
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
          _v6 = _v4.orientation
          _x = _v6
          buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
          _x = val2
          buff.write(_get_struct_4d().pack(_x.shaft_length, _x.shaft_diameter, _x.head_length, _x.head_diameter))
          _v7 = val2.color
          _x = _v7
          buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
        length = len(val1.cubes)
        buff.write(_struct_I.pack(length))
        for val2 in val1.cubes:
          _v8 = val2.pose
          _v9 = _v8.position
          _x = _v9
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
          _v10 = _v8.orientation
          _x = _v10
          buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
          _v11 = val2.size
          _x = _v11
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
          _v12 = val2.color
          _x = _v12
          buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
        length = len(val1.spheres)
        buff.write(_struct_I.pack(length))
        for val2 in val1.spheres:
          _v13 = val2.pose
          _v14 = _v13.position
          _x = _v14
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
          _v15 = _v13.orientation
          _x = _v15
          buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
          _v16 = val2.size
          _x = _v16
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
          _v17 = val2.color
          _x = _v17
          buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
        length = len(val1.cylinders)
        buff.write(_struct_I.pack(length))
        for val2 in val1.cylinders:
          _v18 = val2.pose
          _v19 = _v18.position
          _x = _v19
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
          _v20 = _v18.orientation
          _x = _v20
          buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
          _v21 = val2.size
          _x = _v21
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
          _x = val2
          buff.write(_get_struct_2d().pack(_x.bottom_scale, _x.top_scale))
          _v22 = val2.color
          _x = _v22
          buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
        length = len(val1.lines)
        buff.write(_struct_I.pack(length))
        for val2 in val1.lines:
          _x = val2.type
          buff.write(_get_struct_B().pack(_x))
          _v23 = val2.pose
          _v24 = _v23.position
          _x = _v24
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
          _v25 = _v23.orientation
          _x = _v25
          buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
          _x = val2
          buff.write(_get_struct_dB().pack(_x.thickness, _x.scale_invariant))
          length = len(val2.points)
          buff.write(_struct_I.pack(length))
          for val3 in val2.points:
            _x = val3
            buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
          _v26 = val2.color
          _x = _v26
          buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
          length = len(val2.colors)
          buff.write(_struct_I.pack(length))
          for val3 in val2.colors:
            _x = val3
            buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
          length = len(val2.indices)
          buff.write(_struct_I.pack(length))
          pattern = '<%sI'%length
          buff.write(struct.Struct(pattern).pack(*val2.indices))
        length = len(val1.triangles)
        buff.write(_struct_I.pack(length))
        for val2 in val1.triangles:
          _v27 = val2.pose
          _v28 = _v27.position
          _x = _v28
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
          _v29 = _v27.orientation
          _x = _v29
          buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
          length = len(val2.points)
          buff.write(_struct_I.pack(length))
          for val3 in val2.points:
            _x = val3
            buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
          _v30 = val2.color
          _x = _v30
          buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
          length = len(val2.colors)
          buff.write(_struct_I.pack(length))
          for val3 in val2.colors:
            _x = val3
            buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
          length = len(val2.indices)
          buff.write(_struct_I.pack(length))
          pattern = '<%sI'%length
          buff.write(struct.Struct(pattern).pack(*val2.indices))
        length = len(val1.texts)
        buff.write(_struct_I.pack(length))
        for val2 in val1.texts:
          _v31 = val2.pose
          _v32 = _v31.position
          _x = _v32
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
          _v33 = _v31.orientation
          _x = _v33
          buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
          _x = val2
          buff.write(_get_struct_BdB().pack(_x.billboard, _x.font_size, _x.scale_invariant))
          _v34 = val2.color
          _x = _v34
          buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
          _x = val2.text
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        length = len(val1.models)
        buff.write(_struct_I.pack(length))
        for val2 in val1.models:
          _v35 = val2.pose
          _v36 = _v35.position
          _x = _v36
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
          _v37 = _v35.orientation
          _x = _v37
          buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
          _v38 = val2.scale
          _x = _v38
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
          _v39 = val2.color
          _x = _v39
          buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
          _x = val2.override_color
          buff.write(_get_struct_B().pack(_x))
          _x = val2.url
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = val2.media_type
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = val2.data
          length = len(_x)
          # - if encoded as a list instead, serialize as bytes instead of string
          if type(_x) in [list, tuple]:
            buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
          else:
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.deletions is None:
        self.deletions = None
      if self.entities is None:
        self.entities = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.deletions = []
      for i in range(0, length):
        val1 = foxglove_msgs.msg.SceneEntityDeletion()
        _v40 = val1.timestamp
        _x = _v40
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        start = end
        end += 1
        (val1.type,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.id = str[start:end]
        self.deletions.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.entities = []
      for i in range(0, length):
        val1 = foxglove_msgs.msg.SceneEntity()
        _v41 = val1.timestamp
        _x = _v41
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.frame_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.frame_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.id = str[start:end]
        _v42 = val1.lifetime
        _x = _v42
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2i().unpack(str[start:end])
        start = end
        end += 1
        (val1.frame_locked,) = _get_struct_B().unpack(str[start:end])
        val1.frame_locked = bool(val1.frame_locked)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.metadata = []
        for i in range(0, length):
          val2 = foxglove_msgs.msg.KeyValuePair()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.key = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2.key = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.value = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2.value = str[start:end]
          val1.metadata.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.arrows = []
        for i in range(0, length):
          val2 = foxglove_msgs.msg.ArrowPrimitive()
          _v43 = val2.pose
          _v44 = _v43.position
          _x = _v44
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          _v45 = _v43.orientation
          _x = _v45
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
          _x = val2
          start = end
          end += 32
          (_x.shaft_length, _x.shaft_diameter, _x.head_length, _x.head_diameter,) = _get_struct_4d().unpack(str[start:end])
          _v46 = val2.color
          _x = _v46
          start = end
          end += 32
          (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
          val1.arrows.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.cubes = []
        for i in range(0, length):
          val2 = foxglove_msgs.msg.CubePrimitive()
          _v47 = val2.pose
          _v48 = _v47.position
          _x = _v48
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          _v49 = _v47.orientation
          _x = _v49
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
          _v50 = val2.size
          _x = _v50
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          _v51 = val2.color
          _x = _v51
          start = end
          end += 32
          (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
          val1.cubes.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.spheres = []
        for i in range(0, length):
          val2 = foxglove_msgs.msg.SpherePrimitive()
          _v52 = val2.pose
          _v53 = _v52.position
          _x = _v53
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          _v54 = _v52.orientation
          _x = _v54
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
          _v55 = val2.size
          _x = _v55
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          _v56 = val2.color
          _x = _v56
          start = end
          end += 32
          (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
          val1.spheres.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.cylinders = []
        for i in range(0, length):
          val2 = foxglove_msgs.msg.CylinderPrimitive()
          _v57 = val2.pose
          _v58 = _v57.position
          _x = _v58
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          _v59 = _v57.orientation
          _x = _v59
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
          _v60 = val2.size
          _x = _v60
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          _x = val2
          start = end
          end += 16
          (_x.bottom_scale, _x.top_scale,) = _get_struct_2d().unpack(str[start:end])
          _v61 = val2.color
          _x = _v61
          start = end
          end += 32
          (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
          val1.cylinders.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.lines = []
        for i in range(0, length):
          val2 = foxglove_msgs.msg.LinePrimitive()
          start = end
          end += 1
          (val2.type,) = _get_struct_B().unpack(str[start:end])
          _v62 = val2.pose
          _v63 = _v62.position
          _x = _v63
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          _v64 = _v62.orientation
          _x = _v64
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
          _x = val2
          start = end
          end += 9
          (_x.thickness, _x.scale_invariant,) = _get_struct_dB().unpack(str[start:end])
          val2.scale_invariant = bool(val2.scale_invariant)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val2.points = []
          for i in range(0, length):
            val3 = geometry_msgs.msg.Point()
            _x = val3
            start = end
            end += 24
            (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
            val2.points.append(val3)
          _v65 = val2.color
          _x = _v65
          start = end
          end += 32
          (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val2.colors = []
          for i in range(0, length):
            val3 = foxglove_msgs.msg.Color()
            _x = val3
            start = end
            end += 32
            (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
            val2.colors.append(val3)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sI'%length
          start = end
          s = struct.Struct(pattern)
          end += s.size
          val2.indices = s.unpack(str[start:end])
          val1.lines.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.triangles = []
        for i in range(0, length):
          val2 = foxglove_msgs.msg.TriangleListPrimitive()
          _v66 = val2.pose
          _v67 = _v66.position
          _x = _v67
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          _v68 = _v66.orientation
          _x = _v68
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val2.points = []
          for i in range(0, length):
            val3 = geometry_msgs.msg.Point()
            _x = val3
            start = end
            end += 24
            (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
            val2.points.append(val3)
          _v69 = val2.color
          _x = _v69
          start = end
          end += 32
          (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val2.colors = []
          for i in range(0, length):
            val3 = foxglove_msgs.msg.Color()
            _x = val3
            start = end
            end += 32
            (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
            val2.colors.append(val3)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sI'%length
          start = end
          s = struct.Struct(pattern)
          end += s.size
          val2.indices = s.unpack(str[start:end])
          val1.triangles.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.texts = []
        for i in range(0, length):
          val2 = foxglove_msgs.msg.TextPrimitive()
          _v70 = val2.pose
          _v71 = _v70.position
          _x = _v71
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          _v72 = _v70.orientation
          _x = _v72
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
          _x = val2
          start = end
          end += 10
          (_x.billboard, _x.font_size, _x.scale_invariant,) = _get_struct_BdB().unpack(str[start:end])
          val2.billboard = bool(val2.billboard)
          val2.scale_invariant = bool(val2.scale_invariant)
          _v73 = val2.color
          _x = _v73
          start = end
          end += 32
          (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.text = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2.text = str[start:end]
          val1.texts.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.models = []
        for i in range(0, length):
          val2 = foxglove_msgs.msg.ModelPrimitive()
          _v74 = val2.pose
          _v75 = _v74.position
          _x = _v75
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          _v76 = _v74.orientation
          _x = _v76
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
          _v77 = val2.scale
          _x = _v77
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          _v78 = val2.color
          _x = _v78
          start = end
          end += 32
          (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
          start = end
          end += 1
          (val2.override_color,) = _get_struct_B().unpack(str[start:end])
          val2.override_color = bool(val2.override_color)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.url = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2.url = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.media_type = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2.media_type = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val2.data = str[start:end]
          val1.models.append(val2)
        self.entities.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      length = len(self.deletions)
      buff.write(_struct_I.pack(length))
      for val1 in self.deletions:
        _v79 = val1.timestamp
        _x = _v79
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _x = val1.type
        buff.write(_get_struct_B().pack(_x))
        _x = val1.id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.entities)
      buff.write(_struct_I.pack(length))
      for val1 in self.entities:
        _v80 = val1.timestamp
        _x = _v80
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _x = val1.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v81 = val1.lifetime
        _x = _v81
        buff.write(_get_struct_2i().pack(_x.secs, _x.nsecs))
        _x = val1.frame_locked
        buff.write(_get_struct_B().pack(_x))
        length = len(val1.metadata)
        buff.write(_struct_I.pack(length))
        for val2 in val1.metadata:
          _x = val2.key
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = val2.value
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        length = len(val1.arrows)
        buff.write(_struct_I.pack(length))
        for val2 in val1.arrows:
          _v82 = val2.pose
          _v83 = _v82.position
          _x = _v83
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
          _v84 = _v82.orientation
          _x = _v84
          buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
          _x = val2
          buff.write(_get_struct_4d().pack(_x.shaft_length, _x.shaft_diameter, _x.head_length, _x.head_diameter))
          _v85 = val2.color
          _x = _v85
          buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
        length = len(val1.cubes)
        buff.write(_struct_I.pack(length))
        for val2 in val1.cubes:
          _v86 = val2.pose
          _v87 = _v86.position
          _x = _v87
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
          _v88 = _v86.orientation
          _x = _v88
          buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
          _v89 = val2.size
          _x = _v89
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
          _v90 = val2.color
          _x = _v90
          buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
        length = len(val1.spheres)
        buff.write(_struct_I.pack(length))
        for val2 in val1.spheres:
          _v91 = val2.pose
          _v92 = _v91.position
          _x = _v92
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
          _v93 = _v91.orientation
          _x = _v93
          buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
          _v94 = val2.size
          _x = _v94
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
          _v95 = val2.color
          _x = _v95
          buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
        length = len(val1.cylinders)
        buff.write(_struct_I.pack(length))
        for val2 in val1.cylinders:
          _v96 = val2.pose
          _v97 = _v96.position
          _x = _v97
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
          _v98 = _v96.orientation
          _x = _v98
          buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
          _v99 = val2.size
          _x = _v99
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
          _x = val2
          buff.write(_get_struct_2d().pack(_x.bottom_scale, _x.top_scale))
          _v100 = val2.color
          _x = _v100
          buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
        length = len(val1.lines)
        buff.write(_struct_I.pack(length))
        for val2 in val1.lines:
          _x = val2.type
          buff.write(_get_struct_B().pack(_x))
          _v101 = val2.pose
          _v102 = _v101.position
          _x = _v102
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
          _v103 = _v101.orientation
          _x = _v103
          buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
          _x = val2
          buff.write(_get_struct_dB().pack(_x.thickness, _x.scale_invariant))
          length = len(val2.points)
          buff.write(_struct_I.pack(length))
          for val3 in val2.points:
            _x = val3
            buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
          _v104 = val2.color
          _x = _v104
          buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
          length = len(val2.colors)
          buff.write(_struct_I.pack(length))
          for val3 in val2.colors:
            _x = val3
            buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
          length = len(val2.indices)
          buff.write(_struct_I.pack(length))
          pattern = '<%sI'%length
          buff.write(val2.indices.tostring())
        length = len(val1.triangles)
        buff.write(_struct_I.pack(length))
        for val2 in val1.triangles:
          _v105 = val2.pose
          _v106 = _v105.position
          _x = _v106
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
          _v107 = _v105.orientation
          _x = _v107
          buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
          length = len(val2.points)
          buff.write(_struct_I.pack(length))
          for val3 in val2.points:
            _x = val3
            buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
          _v108 = val2.color
          _x = _v108
          buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
          length = len(val2.colors)
          buff.write(_struct_I.pack(length))
          for val3 in val2.colors:
            _x = val3
            buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
          length = len(val2.indices)
          buff.write(_struct_I.pack(length))
          pattern = '<%sI'%length
          buff.write(val2.indices.tostring())
        length = len(val1.texts)
        buff.write(_struct_I.pack(length))
        for val2 in val1.texts:
          _v109 = val2.pose
          _v110 = _v109.position
          _x = _v110
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
          _v111 = _v109.orientation
          _x = _v111
          buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
          _x = val2
          buff.write(_get_struct_BdB().pack(_x.billboard, _x.font_size, _x.scale_invariant))
          _v112 = val2.color
          _x = _v112
          buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
          _x = val2.text
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        length = len(val1.models)
        buff.write(_struct_I.pack(length))
        for val2 in val1.models:
          _v113 = val2.pose
          _v114 = _v113.position
          _x = _v114
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
          _v115 = _v113.orientation
          _x = _v115
          buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
          _v116 = val2.scale
          _x = _v116
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
          _v117 = val2.color
          _x = _v117
          buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
          _x = val2.override_color
          buff.write(_get_struct_B().pack(_x))
          _x = val2.url
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = val2.media_type
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = val2.data
          length = len(_x)
          # - if encoded as a list instead, serialize as bytes instead of string
          if type(_x) in [list, tuple]:
            buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
          else:
            buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.deletions is None:
        self.deletions = None
      if self.entities is None:
        self.entities = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.deletions = []
      for i in range(0, length):
        val1 = foxglove_msgs.msg.SceneEntityDeletion()
        _v118 = val1.timestamp
        _x = _v118
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        start = end
        end += 1
        (val1.type,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.id = str[start:end]
        self.deletions.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.entities = []
      for i in range(0, length):
        val1 = foxglove_msgs.msg.SceneEntity()
        _v119 = val1.timestamp
        _x = _v119
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.frame_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.frame_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.id = str[start:end]
        _v120 = val1.lifetime
        _x = _v120
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2i().unpack(str[start:end])
        start = end
        end += 1
        (val1.frame_locked,) = _get_struct_B().unpack(str[start:end])
        val1.frame_locked = bool(val1.frame_locked)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.metadata = []
        for i in range(0, length):
          val2 = foxglove_msgs.msg.KeyValuePair()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.key = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2.key = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.value = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2.value = str[start:end]
          val1.metadata.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.arrows = []
        for i in range(0, length):
          val2 = foxglove_msgs.msg.ArrowPrimitive()
          _v121 = val2.pose
          _v122 = _v121.position
          _x = _v122
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          _v123 = _v121.orientation
          _x = _v123
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
          _x = val2
          start = end
          end += 32
          (_x.shaft_length, _x.shaft_diameter, _x.head_length, _x.head_diameter,) = _get_struct_4d().unpack(str[start:end])
          _v124 = val2.color
          _x = _v124
          start = end
          end += 32
          (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
          val1.arrows.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.cubes = []
        for i in range(0, length):
          val2 = foxglove_msgs.msg.CubePrimitive()
          _v125 = val2.pose
          _v126 = _v125.position
          _x = _v126
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          _v127 = _v125.orientation
          _x = _v127
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
          _v128 = val2.size
          _x = _v128
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          _v129 = val2.color
          _x = _v129
          start = end
          end += 32
          (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
          val1.cubes.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.spheres = []
        for i in range(0, length):
          val2 = foxglove_msgs.msg.SpherePrimitive()
          _v130 = val2.pose
          _v131 = _v130.position
          _x = _v131
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          _v132 = _v130.orientation
          _x = _v132
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
          _v133 = val2.size
          _x = _v133
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          _v134 = val2.color
          _x = _v134
          start = end
          end += 32
          (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
          val1.spheres.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.cylinders = []
        for i in range(0, length):
          val2 = foxglove_msgs.msg.CylinderPrimitive()
          _v135 = val2.pose
          _v136 = _v135.position
          _x = _v136
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          _v137 = _v135.orientation
          _x = _v137
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
          _v138 = val2.size
          _x = _v138
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          _x = val2
          start = end
          end += 16
          (_x.bottom_scale, _x.top_scale,) = _get_struct_2d().unpack(str[start:end])
          _v139 = val2.color
          _x = _v139
          start = end
          end += 32
          (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
          val1.cylinders.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.lines = []
        for i in range(0, length):
          val2 = foxglove_msgs.msg.LinePrimitive()
          start = end
          end += 1
          (val2.type,) = _get_struct_B().unpack(str[start:end])
          _v140 = val2.pose
          _v141 = _v140.position
          _x = _v141
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          _v142 = _v140.orientation
          _x = _v142
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
          _x = val2
          start = end
          end += 9
          (_x.thickness, _x.scale_invariant,) = _get_struct_dB().unpack(str[start:end])
          val2.scale_invariant = bool(val2.scale_invariant)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val2.points = []
          for i in range(0, length):
            val3 = geometry_msgs.msg.Point()
            _x = val3
            start = end
            end += 24
            (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
            val2.points.append(val3)
          _v143 = val2.color
          _x = _v143
          start = end
          end += 32
          (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val2.colors = []
          for i in range(0, length):
            val3 = foxglove_msgs.msg.Color()
            _x = val3
            start = end
            end += 32
            (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
            val2.colors.append(val3)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sI'%length
          start = end
          s = struct.Struct(pattern)
          end += s.size
          val2.indices = numpy.frombuffer(str[start:end], dtype=numpy.uint32, count=length)
          val1.lines.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.triangles = []
        for i in range(0, length):
          val2 = foxglove_msgs.msg.TriangleListPrimitive()
          _v144 = val2.pose
          _v145 = _v144.position
          _x = _v145
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          _v146 = _v144.orientation
          _x = _v146
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val2.points = []
          for i in range(0, length):
            val3 = geometry_msgs.msg.Point()
            _x = val3
            start = end
            end += 24
            (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
            val2.points.append(val3)
          _v147 = val2.color
          _x = _v147
          start = end
          end += 32
          (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val2.colors = []
          for i in range(0, length):
            val3 = foxglove_msgs.msg.Color()
            _x = val3
            start = end
            end += 32
            (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
            val2.colors.append(val3)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sI'%length
          start = end
          s = struct.Struct(pattern)
          end += s.size
          val2.indices = numpy.frombuffer(str[start:end], dtype=numpy.uint32, count=length)
          val1.triangles.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.texts = []
        for i in range(0, length):
          val2 = foxglove_msgs.msg.TextPrimitive()
          _v148 = val2.pose
          _v149 = _v148.position
          _x = _v149
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          _v150 = _v148.orientation
          _x = _v150
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
          _x = val2
          start = end
          end += 10
          (_x.billboard, _x.font_size, _x.scale_invariant,) = _get_struct_BdB().unpack(str[start:end])
          val2.billboard = bool(val2.billboard)
          val2.scale_invariant = bool(val2.scale_invariant)
          _v151 = val2.color
          _x = _v151
          start = end
          end += 32
          (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.text = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2.text = str[start:end]
          val1.texts.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.models = []
        for i in range(0, length):
          val2 = foxglove_msgs.msg.ModelPrimitive()
          _v152 = val2.pose
          _v153 = _v152.position
          _x = _v153
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          _v154 = _v152.orientation
          _x = _v154
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
          _v155 = val2.scale
          _x = _v155
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          _v156 = val2.color
          _x = _v156
          start = end
          end += 32
          (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
          start = end
          end += 1
          (val2.override_color,) = _get_struct_B().unpack(str[start:end])
          val2.override_color = bool(val2.override_color)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.url = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2.url = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.media_type = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2.media_type = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val2.data = str[start:end]
          val1.models.append(val2)
        self.entities.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2I = None
def _get_struct_2I():
    global _struct_2I
    if _struct_2I is None:
        _struct_2I = struct.Struct("<2I")
    return _struct_2I
_struct_2d = None
def _get_struct_2d():
    global _struct_2d
    if _struct_2d is None:
        _struct_2d = struct.Struct("<2d")
    return _struct_2d
_struct_2i = None
def _get_struct_2i():
    global _struct_2i
    if _struct_2i is None:
        _struct_2i = struct.Struct("<2i")
    return _struct_2i
_struct_3d = None
def _get_struct_3d():
    global _struct_3d
    if _struct_3d is None:
        _struct_3d = struct.Struct("<3d")
    return _struct_3d
_struct_4d = None
def _get_struct_4d():
    global _struct_4d
    if _struct_4d is None:
        _struct_4d = struct.Struct("<4d")
    return _struct_4d
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
_struct_BdB = None
def _get_struct_BdB():
    global _struct_BdB
    if _struct_BdB is None:
        _struct_BdB = struct.Struct("<BdB")
    return _struct_BdB
_struct_dB = None
def _get_struct_dB():
    global _struct_dB
    if _struct_dB is None:
        _struct_dB = struct.Struct("<dB")
    return _struct_dB
