# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from foxglove_msgs/TextPrimitive.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import foxglove_msgs.msg
import geometry_msgs.msg

class TextPrimitive(genpy.Message):
  _md5sum = "bec1b8536471438a5b2697ab2d6c5ca1"
  _type = "foxglove_msgs/TextPrimitive"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# foxglove_msgs/TextPrimitive
# A primitive representing a text label

# Generated by https://github.com/foxglove/schemas

# Position of the center of the text box and orientation of the text. Identity orientation means the text is oriented in the xy-plane and flows from -x to +x.
geometry_msgs/Pose pose

# Whether the text should respect `pose.orientation` (false) or always face the camera (true)
bool billboard

# Font size (height of one line of text)
float64 font_size

# Indicates whether `font_size` is a fixed size in screen pixels (true), or specified in world coordinates and scales with distance from the camera (false)
bool scale_invariant

# Color of the text
foxglove_msgs/Color color

# Text
string text

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of position and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: foxglove_msgs/Color
# foxglove_msgs/Color
# A color in RGBA format

# Generated by https://github.com/foxglove/schemas

# Red value between 0 and 1
float64 r

# Green value between 0 and 1
float64 g

# Blue value between 0 and 1
float64 b

# Alpha value between 0 and 1
float64 a
"""
  __slots__ = ['pose','billboard','font_size','scale_invariant','color','text']
  _slot_types = ['geometry_msgs/Pose','bool','float64','bool','foxglove_msgs/Color','string']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       pose,billboard,font_size,scale_invariant,color,text

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(TextPrimitive, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.pose is None:
        self.pose = geometry_msgs.msg.Pose()
      if self.billboard is None:
        self.billboard = False
      if self.font_size is None:
        self.font_size = 0.
      if self.scale_invariant is None:
        self.scale_invariant = False
      if self.color is None:
        self.color = foxglove_msgs.msg.Color()
      if self.text is None:
        self.text = ''
    else:
      self.pose = geometry_msgs.msg.Pose()
      self.billboard = False
      self.font_size = 0.
      self.scale_invariant = False
      self.color = foxglove_msgs.msg.Color()
      self.text = ''

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_7dBdB4d().pack(_x.pose.position.x, _x.pose.position.y, _x.pose.position.z, _x.pose.orientation.x, _x.pose.orientation.y, _x.pose.orientation.z, _x.pose.orientation.w, _x.billboard, _x.font_size, _x.scale_invariant, _x.color.r, _x.color.g, _x.color.b, _x.color.a))
      _x = self.text
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.pose is None:
        self.pose = geometry_msgs.msg.Pose()
      if self.color is None:
        self.color = foxglove_msgs.msg.Color()
      end = 0
      _x = self
      start = end
      end += 98
      (_x.pose.position.x, _x.pose.position.y, _x.pose.position.z, _x.pose.orientation.x, _x.pose.orientation.y, _x.pose.orientation.z, _x.pose.orientation.w, _x.billboard, _x.font_size, _x.scale_invariant, _x.color.r, _x.color.g, _x.color.b, _x.color.a,) = _get_struct_7dBdB4d().unpack(str[start:end])
      self.billboard = bool(self.billboard)
      self.scale_invariant = bool(self.scale_invariant)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.text = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.text = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_7dBdB4d().pack(_x.pose.position.x, _x.pose.position.y, _x.pose.position.z, _x.pose.orientation.x, _x.pose.orientation.y, _x.pose.orientation.z, _x.pose.orientation.w, _x.billboard, _x.font_size, _x.scale_invariant, _x.color.r, _x.color.g, _x.color.b, _x.color.a))
      _x = self.text
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.pose is None:
        self.pose = geometry_msgs.msg.Pose()
      if self.color is None:
        self.color = foxglove_msgs.msg.Color()
      end = 0
      _x = self
      start = end
      end += 98
      (_x.pose.position.x, _x.pose.position.y, _x.pose.position.z, _x.pose.orientation.x, _x.pose.orientation.y, _x.pose.orientation.z, _x.pose.orientation.w, _x.billboard, _x.font_size, _x.scale_invariant, _x.color.r, _x.color.g, _x.color.b, _x.color.a,) = _get_struct_7dBdB4d().unpack(str[start:end])
      self.billboard = bool(self.billboard)
      self.scale_invariant = bool(self.scale_invariant)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.text = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.text = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_7dBdB4d = None
def _get_struct_7dBdB4d():
    global _struct_7dBdB4d
    if _struct_7dBdB4d is None:
        _struct_7dBdB4d = struct.Struct("<7dBdB4d")
    return _struct_7dBdB4d
