# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from foxglove_msgs/TrianglesMarker.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import foxglove_msgs.msg
import genpy
import geometry_msgs.msg

class TrianglesMarker(genpy.Message):
  _md5sum = "f365629c151dfe98b2231f3864f8af4b"
  _type = "foxglove_msgs/TrianglesMarker"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# foxglove_msgs/TrianglesMarker
# A marker representing a set of triangles or a surface tiled by triangles

# Generated by https://github.com/foxglove/schemas

# Timestamp of the marker
time timestamp

# Frame of reference
string frame_id

# Identifier for the marker. A marker will replace any prior marker on the same topic with the same `id`.
string id

# Length of time (relative to `timestamp`) after which the marker should be automatically removed. Zero value indicates the marker should remain visible until it is replaced or deleted.
duration lifetime

# Whether the marker should keep its location in the fixed frame (false) or follow the frame specified in `frame_id` as it moves relative to the fixed frame (true)
bool frame_locked

# Additional user-provided metadata associated with the marker. Keys must be unique.
foxglove_msgs/KeyValuePair[] metadata

# Origin of triangles relative to reference frame
geometry_msgs/Pose pose

# Vertices to use for triangles, interpreted as a list of triples (0-1-2, 3-4-5, ...)
geometry_msgs/Point[] points

# Solid color to use for the whole shape. One of `color` or `colors` must be provided.
foxglove_msgs/Color color

# Per-vertex colors (if specified, must have the same length as `points`). One of `color` or `colors` should be provided.
foxglove_msgs/Color[] colors

# Indices into the `points` and `colors` attribute arrays, which can be used to avoid duplicating attribute data.
# 
# If omitted or empty, indexing will not be used. This default behavior is equivalent to specifying [0, 1, ..., N-1] for the indices (where N is the number of `points` provided).
uint32[] indices

================================================================================
MSG: foxglove_msgs/KeyValuePair
# foxglove_msgs/KeyValuePair
# A key with its associated value

# Generated by https://github.com/foxglove/schemas

# Key
string key

# Value
string value

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of position and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: foxglove_msgs/Color
# foxglove_msgs/Color
# A color in RGBA format

# Generated by https://github.com/foxglove/schemas

# Red value between 0 and 1
float64 r

# Green value between 0 and 1
float64 g

# Blue value between 0 and 1
float64 b

# Alpha value between 0 and 1
float64 a
"""
  __slots__ = ['timestamp','frame_id','id','lifetime','frame_locked','metadata','pose','points','color','colors','indices']
  _slot_types = ['time','string','string','duration','bool','foxglove_msgs/KeyValuePair[]','geometry_msgs/Pose','geometry_msgs/Point[]','foxglove_msgs/Color','foxglove_msgs/Color[]','uint32[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp,frame_id,id,lifetime,frame_locked,metadata,pose,points,color,colors,indices

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(TrianglesMarker, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.timestamp is None:
        self.timestamp = genpy.Time()
      if self.frame_id is None:
        self.frame_id = ''
      if self.id is None:
        self.id = ''
      if self.lifetime is None:
        self.lifetime = genpy.Duration()
      if self.frame_locked is None:
        self.frame_locked = False
      if self.metadata is None:
        self.metadata = []
      if self.pose is None:
        self.pose = geometry_msgs.msg.Pose()
      if self.points is None:
        self.points = []
      if self.color is None:
        self.color = foxglove_msgs.msg.Color()
      if self.colors is None:
        self.colors = []
      if self.indices is None:
        self.indices = []
    else:
      self.timestamp = genpy.Time()
      self.frame_id = ''
      self.id = ''
      self.lifetime = genpy.Duration()
      self.frame_locked = False
      self.metadata = []
      self.pose = geometry_msgs.msg.Pose()
      self.points = []
      self.color = foxglove_msgs.msg.Color()
      self.colors = []
      self.indices = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2I().pack(_x.timestamp.secs, _x.timestamp.nsecs))
      _x = self.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2iB().pack(_x.lifetime.secs, _x.lifetime.nsecs, _x.frame_locked))
      length = len(self.metadata)
      buff.write(_struct_I.pack(length))
      for val1 in self.metadata:
        _x = val1.key
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.value
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_7d().pack(_x.pose.position.x, _x.pose.position.y, _x.pose.position.z, _x.pose.orientation.x, _x.pose.orientation.y, _x.pose.orientation.z, _x.pose.orientation.w))
      length = len(self.points)
      buff.write(_struct_I.pack(length))
      for val1 in self.points:
        _x = val1
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
      _x = self
      buff.write(_get_struct_4d().pack(_x.color.r, _x.color.g, _x.color.b, _x.color.a))
      length = len(self.colors)
      buff.write(_struct_I.pack(length))
      for val1 in self.colors:
        _x = val1
        buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
      length = len(self.indices)
      buff.write(_struct_I.pack(length))
      pattern = '<%sI'%length
      buff.write(struct.Struct(pattern).pack(*self.indices))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.timestamp is None:
        self.timestamp = genpy.Time()
      if self.lifetime is None:
        self.lifetime = genpy.Duration()
      if self.metadata is None:
        self.metadata = None
      if self.pose is None:
        self.pose = geometry_msgs.msg.Pose()
      if self.points is None:
        self.points = None
      if self.color is None:
        self.color = foxglove_msgs.msg.Color()
      if self.colors is None:
        self.colors = None
      end = 0
      _x = self
      start = end
      end += 8
      (_x.timestamp.secs, _x.timestamp.nsecs,) = _get_struct_2I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.id = str[start:end]
      _x = self
      start = end
      end += 9
      (_x.lifetime.secs, _x.lifetime.nsecs, _x.frame_locked,) = _get_struct_2iB().unpack(str[start:end])
      self.frame_locked = bool(self.frame_locked)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.metadata = []
      for i in range(0, length):
        val1 = foxglove_msgs.msg.KeyValuePair()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.key = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.key = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.value = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.value = str[start:end]
        self.metadata.append(val1)
      _x = self
      start = end
      end += 56
      (_x.pose.position.x, _x.pose.position.y, _x.pose.position.z, _x.pose.orientation.x, _x.pose.orientation.y, _x.pose.orientation.z, _x.pose.orientation.w,) = _get_struct_7d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.points = []
      for i in range(0, length):
        val1 = geometry_msgs.msg.Point()
        _x = val1
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        self.points.append(val1)
      _x = self
      start = end
      end += 32
      (_x.color.r, _x.color.g, _x.color.b, _x.color.a,) = _get_struct_4d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.colors = []
      for i in range(0, length):
        val1 = foxglove_msgs.msg.Color()
        _x = val1
        start = end
        end += 32
        (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
        self.colors.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sI'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.indices = s.unpack(str[start:end])
      self.timestamp.canon()
      self.lifetime.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2I().pack(_x.timestamp.secs, _x.timestamp.nsecs))
      _x = self.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2iB().pack(_x.lifetime.secs, _x.lifetime.nsecs, _x.frame_locked))
      length = len(self.metadata)
      buff.write(_struct_I.pack(length))
      for val1 in self.metadata:
        _x = val1.key
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.value
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_7d().pack(_x.pose.position.x, _x.pose.position.y, _x.pose.position.z, _x.pose.orientation.x, _x.pose.orientation.y, _x.pose.orientation.z, _x.pose.orientation.w))
      length = len(self.points)
      buff.write(_struct_I.pack(length))
      for val1 in self.points:
        _x = val1
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
      _x = self
      buff.write(_get_struct_4d().pack(_x.color.r, _x.color.g, _x.color.b, _x.color.a))
      length = len(self.colors)
      buff.write(_struct_I.pack(length))
      for val1 in self.colors:
        _x = val1
        buff.write(_get_struct_4d().pack(_x.r, _x.g, _x.b, _x.a))
      length = len(self.indices)
      buff.write(_struct_I.pack(length))
      pattern = '<%sI'%length
      buff.write(self.indices.tostring())
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.timestamp is None:
        self.timestamp = genpy.Time()
      if self.lifetime is None:
        self.lifetime = genpy.Duration()
      if self.metadata is None:
        self.metadata = None
      if self.pose is None:
        self.pose = geometry_msgs.msg.Pose()
      if self.points is None:
        self.points = None
      if self.color is None:
        self.color = foxglove_msgs.msg.Color()
      if self.colors is None:
        self.colors = None
      end = 0
      _x = self
      start = end
      end += 8
      (_x.timestamp.secs, _x.timestamp.nsecs,) = _get_struct_2I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.id = str[start:end]
      _x = self
      start = end
      end += 9
      (_x.lifetime.secs, _x.lifetime.nsecs, _x.frame_locked,) = _get_struct_2iB().unpack(str[start:end])
      self.frame_locked = bool(self.frame_locked)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.metadata = []
      for i in range(0, length):
        val1 = foxglove_msgs.msg.KeyValuePair()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.key = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.key = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.value = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.value = str[start:end]
        self.metadata.append(val1)
      _x = self
      start = end
      end += 56
      (_x.pose.position.x, _x.pose.position.y, _x.pose.position.z, _x.pose.orientation.x, _x.pose.orientation.y, _x.pose.orientation.z, _x.pose.orientation.w,) = _get_struct_7d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.points = []
      for i in range(0, length):
        val1 = geometry_msgs.msg.Point()
        _x = val1
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        self.points.append(val1)
      _x = self
      start = end
      end += 32
      (_x.color.r, _x.color.g, _x.color.b, _x.color.a,) = _get_struct_4d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.colors = []
      for i in range(0, length):
        val1 = foxglove_msgs.msg.Color()
        _x = val1
        start = end
        end += 32
        (_x.r, _x.g, _x.b, _x.a,) = _get_struct_4d().unpack(str[start:end])
        self.colors.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sI'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.indices = numpy.frombuffer(str[start:end], dtype=numpy.uint32, count=length)
      self.timestamp.canon()
      self.lifetime.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2I = None
def _get_struct_2I():
    global _struct_2I
    if _struct_2I is None:
        _struct_2I = struct.Struct("<2I")
    return _struct_2I
_struct_2iB = None
def _get_struct_2iB():
    global _struct_2iB
    if _struct_2iB is None:
        _struct_2iB = struct.Struct("<2iB")
    return _struct_2iB
_struct_3d = None
def _get_struct_3d():
    global _struct_3d
    if _struct_3d is None:
        _struct_3d = struct.Struct("<3d")
    return _struct_3d
_struct_4d = None
def _get_struct_4d():
    global _struct_4d
    if _struct_4d is None:
        _struct_4d = struct.Struct("<4d")
    return _struct_4d
_struct_7d = None
def _get_struct_7d():
    global _struct_7d
    if _struct_7d is None:
        _struct_7d = struct.Struct("<7d")
    return _struct_7d
