// Auto-generated. Do not edit!

// (in-package foxglove_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let Color = require('./Color.js');
let geometry_msgs = _finder('geometry_msgs');

//-----------------------------------------------------------

class ArrowPrimitive {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.pose = null;
      this.shaft_length = null;
      this.shaft_diameter = null;
      this.head_length = null;
      this.head_diameter = null;
      this.color = null;
    }
    else {
      if (initObj.hasOwnProperty('pose')) {
        this.pose = initObj.pose
      }
      else {
        this.pose = new geometry_msgs.msg.Pose();
      }
      if (initObj.hasOwnProperty('shaft_length')) {
        this.shaft_length = initObj.shaft_length
      }
      else {
        this.shaft_length = 0.0;
      }
      if (initObj.hasOwnProperty('shaft_diameter')) {
        this.shaft_diameter = initObj.shaft_diameter
      }
      else {
        this.shaft_diameter = 0.0;
      }
      if (initObj.hasOwnProperty('head_length')) {
        this.head_length = initObj.head_length
      }
      else {
        this.head_length = 0.0;
      }
      if (initObj.hasOwnProperty('head_diameter')) {
        this.head_diameter = initObj.head_diameter
      }
      else {
        this.head_diameter = 0.0;
      }
      if (initObj.hasOwnProperty('color')) {
        this.color = initObj.color
      }
      else {
        this.color = new Color();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type ArrowPrimitive
    // Serialize message field [pose]
    bufferOffset = geometry_msgs.msg.Pose.serialize(obj.pose, buffer, bufferOffset);
    // Serialize message field [shaft_length]
    bufferOffset = _serializer.float64(obj.shaft_length, buffer, bufferOffset);
    // Serialize message field [shaft_diameter]
    bufferOffset = _serializer.float64(obj.shaft_diameter, buffer, bufferOffset);
    // Serialize message field [head_length]
    bufferOffset = _serializer.float64(obj.head_length, buffer, bufferOffset);
    // Serialize message field [head_diameter]
    bufferOffset = _serializer.float64(obj.head_diameter, buffer, bufferOffset);
    // Serialize message field [color]
    bufferOffset = Color.serialize(obj.color, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type ArrowPrimitive
    let len;
    let data = new ArrowPrimitive(null);
    // Deserialize message field [pose]
    data.pose = geometry_msgs.msg.Pose.deserialize(buffer, bufferOffset);
    // Deserialize message field [shaft_length]
    data.shaft_length = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [shaft_diameter]
    data.shaft_diameter = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [head_length]
    data.head_length = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [head_diameter]
    data.head_diameter = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [color]
    data.color = Color.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 120;
  }

  static datatype() {
    // Returns string type for a message object
    return 'foxglove_msgs/ArrowPrimitive';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '77e318e0b3af1677ad44f4bc5480659a';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # foxglove_msgs/ArrowPrimitive
    # A primitive representing an arrow
    
    # Generated by https://github.com/foxglove/schemas
    
    # Position of the arrow's tail and orientation of the arrow. Identity orientation means the arrow points in the +x direction.
    geometry_msgs/Pose pose
    
    # Length of the arrow shaft
    float64 shaft_length
    
    # Diameter of the arrow shaft
    float64 shaft_diameter
    
    # Length of the arrow head
    float64 head_length
    
    # Diameter of the arrow head
    float64 head_diameter
    
    # Color of the arrow
    foxglove_msgs/Color color
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    ================================================================================
    MSG: foxglove_msgs/Color
    # foxglove_msgs/Color
    # A color in RGBA format
    
    # Generated by https://github.com/foxglove/schemas
    
    # Red value between 0 and 1
    float64 r
    
    # Green value between 0 and 1
    float64 g
    
    # Blue value between 0 and 1
    float64 b
    
    # Alpha value between 0 and 1
    float64 a
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new ArrowPrimitive(null);
    if (msg.pose !== undefined) {
      resolved.pose = geometry_msgs.msg.Pose.Resolve(msg.pose)
    }
    else {
      resolved.pose = new geometry_msgs.msg.Pose()
    }

    if (msg.shaft_length !== undefined) {
      resolved.shaft_length = msg.shaft_length;
    }
    else {
      resolved.shaft_length = 0.0
    }

    if (msg.shaft_diameter !== undefined) {
      resolved.shaft_diameter = msg.shaft_diameter;
    }
    else {
      resolved.shaft_diameter = 0.0
    }

    if (msg.head_length !== undefined) {
      resolved.head_length = msg.head_length;
    }
    else {
      resolved.head_length = 0.0
    }

    if (msg.head_diameter !== undefined) {
      resolved.head_diameter = msg.head_diameter;
    }
    else {
      resolved.head_diameter = 0.0
    }

    if (msg.color !== undefined) {
      resolved.color = Color.Resolve(msg.color)
    }
    else {
      resolved.color = new Color()
    }

    return resolved;
    }
};

module.exports = ArrowPrimitive;
