// Auto-generated. Do not edit!

// (in-package foxglove_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let Point2 = require('./Point2.js');
let Color = require('./Color.js');

//-----------------------------------------------------------

class CircleAnnotation {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.timestamp = null;
      this.position = null;
      this.diameter = null;
      this.thickness = null;
      this.fill_color = null;
      this.outline_color = null;
    }
    else {
      if (initObj.hasOwnProperty('timestamp')) {
        this.timestamp = initObj.timestamp
      }
      else {
        this.timestamp = {secs: 0, nsecs: 0};
      }
      if (initObj.hasOwnProperty('position')) {
        this.position = initObj.position
      }
      else {
        this.position = new Point2();
      }
      if (initObj.hasOwnProperty('diameter')) {
        this.diameter = initObj.diameter
      }
      else {
        this.diameter = 0.0;
      }
      if (initObj.hasOwnProperty('thickness')) {
        this.thickness = initObj.thickness
      }
      else {
        this.thickness = 0.0;
      }
      if (initObj.hasOwnProperty('fill_color')) {
        this.fill_color = initObj.fill_color
      }
      else {
        this.fill_color = new Color();
      }
      if (initObj.hasOwnProperty('outline_color')) {
        this.outline_color = initObj.outline_color
      }
      else {
        this.outline_color = new Color();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type CircleAnnotation
    // Serialize message field [timestamp]
    bufferOffset = _serializer.time(obj.timestamp, buffer, bufferOffset);
    // Serialize message field [position]
    bufferOffset = Point2.serialize(obj.position, buffer, bufferOffset);
    // Serialize message field [diameter]
    bufferOffset = _serializer.float64(obj.diameter, buffer, bufferOffset);
    // Serialize message field [thickness]
    bufferOffset = _serializer.float64(obj.thickness, buffer, bufferOffset);
    // Serialize message field [fill_color]
    bufferOffset = Color.serialize(obj.fill_color, buffer, bufferOffset);
    // Serialize message field [outline_color]
    bufferOffset = Color.serialize(obj.outline_color, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type CircleAnnotation
    let len;
    let data = new CircleAnnotation(null);
    // Deserialize message field [timestamp]
    data.timestamp = _deserializer.time(buffer, bufferOffset);
    // Deserialize message field [position]
    data.position = Point2.deserialize(buffer, bufferOffset);
    // Deserialize message field [diameter]
    data.diameter = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [thickness]
    data.thickness = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [fill_color]
    data.fill_color = Color.deserialize(buffer, bufferOffset);
    // Deserialize message field [outline_color]
    data.outline_color = Color.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 104;
  }

  static datatype() {
    // Returns string type for a message object
    return 'foxglove_msgs/CircleAnnotation';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '625708f347af9680a6db92626081cc28';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # foxglove_msgs/CircleAnnotation
    # A circle annotation on a 2D image
    
    # Generated by https://github.com/foxglove/schemas
    
    # Timestamp of circle
    time timestamp
    
    # Center of the circle in 2D image coordinates
    foxglove_msgs/Point2 position
    
    # Circle diameter
    float64 diameter
    
    # Line thickness
    float64 thickness
    
    # Fill color
    foxglove_msgs/Color fill_color
    
    # Outline color
    foxglove_msgs/Color outline_color
    
    ================================================================================
    MSG: foxglove_msgs/Point2
    # foxglove_msgs/Point2
    # A point representing a position in 2D space
    
    # Generated by https://github.com/foxglove/schemas
    
    # x coordinate position
    float64 x
    
    # y coordinate position
    float64 y
    
    ================================================================================
    MSG: foxglove_msgs/Color
    # foxglove_msgs/Color
    # A color in RGBA format
    
    # Generated by https://github.com/foxglove/schemas
    
    # Red value between 0 and 1
    float64 r
    
    # Green value between 0 and 1
    float64 g
    
    # Blue value between 0 and 1
    float64 b
    
    # Alpha value between 0 and 1
    float64 a
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new CircleAnnotation(null);
    if (msg.timestamp !== undefined) {
      resolved.timestamp = msg.timestamp;
    }
    else {
      resolved.timestamp = {secs: 0, nsecs: 0}
    }

    if (msg.position !== undefined) {
      resolved.position = Point2.Resolve(msg.position)
    }
    else {
      resolved.position = new Point2()
    }

    if (msg.diameter !== undefined) {
      resolved.diameter = msg.diameter;
    }
    else {
      resolved.diameter = 0.0
    }

    if (msg.thickness !== undefined) {
      resolved.thickness = msg.thickness;
    }
    else {
      resolved.thickness = 0.0
    }

    if (msg.fill_color !== undefined) {
      resolved.fill_color = Color.Resolve(msg.fill_color)
    }
    else {
      resolved.fill_color = new Color()
    }

    if (msg.outline_color !== undefined) {
      resolved.outline_color = Color.Resolve(msg.outline_color)
    }
    else {
      resolved.outline_color = new Color()
    }

    return resolved;
    }
};

module.exports = CircleAnnotation;
