// Auto-generated. Do not edit!

// (in-package foxglove_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let Color = require('./Color.js');
let geometry_msgs = _finder('geometry_msgs');

//-----------------------------------------------------------

class ConeMarker {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.pose = null;
      this.size = null;
      this.bottom_scale = null;
      this.top_scale = null;
      this.color = null;
    }
    else {
      if (initObj.hasOwnProperty('pose')) {
        this.pose = initObj.pose
      }
      else {
        this.pose = new geometry_msgs.msg.Pose();
      }
      if (initObj.hasOwnProperty('size')) {
        this.size = initObj.size
      }
      else {
        this.size = new geometry_msgs.msg.Vector3();
      }
      if (initObj.hasOwnProperty('bottom_scale')) {
        this.bottom_scale = initObj.bottom_scale
      }
      else {
        this.bottom_scale = 0.0;
      }
      if (initObj.hasOwnProperty('top_scale')) {
        this.top_scale = initObj.top_scale
      }
      else {
        this.top_scale = 0.0;
      }
      if (initObj.hasOwnProperty('color')) {
        this.color = initObj.color
      }
      else {
        this.color = new Color();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type ConeMarker
    // Serialize message field [pose]
    bufferOffset = geometry_msgs.msg.Pose.serialize(obj.pose, buffer, bufferOffset);
    // Serialize message field [size]
    bufferOffset = geometry_msgs.msg.Vector3.serialize(obj.size, buffer, bufferOffset);
    // Serialize message field [bottom_scale]
    bufferOffset = _serializer.float64(obj.bottom_scale, buffer, bufferOffset);
    // Serialize message field [top_scale]
    bufferOffset = _serializer.float64(obj.top_scale, buffer, bufferOffset);
    // Serialize message field [color]
    bufferOffset = Color.serialize(obj.color, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type ConeMarker
    let len;
    let data = new ConeMarker(null);
    // Deserialize message field [pose]
    data.pose = geometry_msgs.msg.Pose.deserialize(buffer, bufferOffset);
    // Deserialize message field [size]
    data.size = geometry_msgs.msg.Vector3.deserialize(buffer, bufferOffset);
    // Deserialize message field [bottom_scale]
    data.bottom_scale = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [top_scale]
    data.top_scale = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [color]
    data.color = Color.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 128;
  }

  static datatype() {
    // Returns string type for a message object
    return 'foxglove_msgs/ConeMarker';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '95a94410f04d20228465a960c3c3f66f';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # foxglove_msgs/ConeMarker
    # A marker representing a possibly truncated, possibly elliptic cone or cylinder
    
    # Generated by https://github.com/foxglove/schemas
    
    # Position of the center of the cone and orientation of the cone. The flat face(s) are perpendicular to the z-axis.
    geometry_msgs/Pose pose
    
    # Size of the cone's bounding box
    geometry_msgs/Vector3 size
    
    # 0-1, size of the cone's bottom face (min z) relative to the bottom of the bounding box
    float64 bottom_scale
    
    # 0-1, size of the cone's top face (max z) relative to the top of the bounding box
    float64 top_scale
    
    # Color of the cone
    foxglove_msgs/Color color
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    ================================================================================
    MSG: geometry_msgs/Vector3
    # This represents a vector in free space. 
    # It is only meant to represent a direction. Therefore, it does not
    # make sense to apply a translation to it (e.g., when applying a 
    # generic rigid transformation to a Vector3, tf2 will only apply the
    # rotation). If you want your data to be translatable too, use the
    # geometry_msgs/Point message instead.
    
    float64 x
    float64 y
    float64 z
    ================================================================================
    MSG: foxglove_msgs/Color
    # foxglove_msgs/Color
    # A color in RGBA format
    
    # Generated by https://github.com/foxglove/schemas
    
    # Red value between 0 and 1
    float64 r
    
    # Green value between 0 and 1
    float64 g
    
    # Blue value between 0 and 1
    float64 b
    
    # Alpha value between 0 and 1
    float64 a
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new ConeMarker(null);
    if (msg.pose !== undefined) {
      resolved.pose = geometry_msgs.msg.Pose.Resolve(msg.pose)
    }
    else {
      resolved.pose = new geometry_msgs.msg.Pose()
    }

    if (msg.size !== undefined) {
      resolved.size = geometry_msgs.msg.Vector3.Resolve(msg.size)
    }
    else {
      resolved.size = new geometry_msgs.msg.Vector3()
    }

    if (msg.bottom_scale !== undefined) {
      resolved.bottom_scale = msg.bottom_scale;
    }
    else {
      resolved.bottom_scale = 0.0
    }

    if (msg.top_scale !== undefined) {
      resolved.top_scale = msg.top_scale;
    }
    else {
      resolved.top_scale = 0.0
    }

    if (msg.color !== undefined) {
      resolved.color = Color.Resolve(msg.color)
    }
    else {
      resolved.color = new Color()
    }

    return resolved;
    }
};

module.exports = ConeMarker;
