// Auto-generated. Do not edit!

// (in-package foxglove_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let CircleAnnotation = require('./CircleAnnotation.js');
let PointsAnnotation = require('./PointsAnnotation.js');

//-----------------------------------------------------------

class ImageAnnotations {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.circles = null;
      this.points = null;
    }
    else {
      if (initObj.hasOwnProperty('circles')) {
        this.circles = initObj.circles
      }
      else {
        this.circles = [];
      }
      if (initObj.hasOwnProperty('points')) {
        this.points = initObj.points
      }
      else {
        this.points = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type ImageAnnotations
    // Serialize message field [circles]
    // Serialize the length for message field [circles]
    bufferOffset = _serializer.uint32(obj.circles.length, buffer, bufferOffset);
    obj.circles.forEach((val) => {
      bufferOffset = CircleAnnotation.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [points]
    // Serialize the length for message field [points]
    bufferOffset = _serializer.uint32(obj.points.length, buffer, bufferOffset);
    obj.points.forEach((val) => {
      bufferOffset = PointsAnnotation.serialize(val, buffer, bufferOffset);
    });
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type ImageAnnotations
    let len;
    let data = new ImageAnnotations(null);
    // Deserialize message field [circles]
    // Deserialize array length for message field [circles]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.circles = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.circles[i] = CircleAnnotation.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [points]
    // Deserialize array length for message field [points]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.points = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.points[i] = PointsAnnotation.deserialize(buffer, bufferOffset)
    }
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += 104 * object.circles.length;
    object.points.forEach((val) => {
      length += PointsAnnotation.getMessageSize(val);
    });
    return length + 8;
  }

  static datatype() {
    // Returns string type for a message object
    return 'foxglove_msgs/ImageAnnotations';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '4de01d0a76174e79779c4925ae2d57fb';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # foxglove_msgs/ImageAnnotations
    # Array of annotations for a 2D image
    
    # Generated by https://github.com/foxglove/schemas
    
    # Circle annotations
    foxglove_msgs/CircleAnnotation[] circles
    
    # Points annotations
    foxglove_msgs/PointsAnnotation[] points
    
    ================================================================================
    MSG: foxglove_msgs/CircleAnnotation
    # foxglove_msgs/CircleAnnotation
    # A circle annotation on a 2D image
    
    # Generated by https://github.com/foxglove/schemas
    
    # Timestamp of circle
    time timestamp
    
    # Center of the circle in 2D image coordinates
    foxglove_msgs/Point2 position
    
    # Circle diameter
    float64 diameter
    
    # Line thickness
    float64 thickness
    
    # Fill color
    foxglove_msgs/Color fill_color
    
    # Outline color
    foxglove_msgs/Color outline_color
    
    ================================================================================
    MSG: foxglove_msgs/Point2
    # foxglove_msgs/Point2
    # A point representing a position in 2D space
    
    # Generated by https://github.com/foxglove/schemas
    
    # x coordinate position
    float64 x
    
    # y coordinate position
    float64 y
    
    ================================================================================
    MSG: foxglove_msgs/Color
    # foxglove_msgs/Color
    # A color in RGBA format
    
    # Generated by https://github.com/foxglove/schemas
    
    # Red value between 0 and 1
    float64 r
    
    # Green value between 0 and 1
    float64 g
    
    # Blue value between 0 and 1
    float64 b
    
    # Alpha value between 0 and 1
    float64 a
    
    ================================================================================
    MSG: foxglove_msgs/PointsAnnotation
    # foxglove_msgs/PointsAnnotation
    # An array of points on a 2D image
    
    # Generated by https://github.com/foxglove/schemas
    
    # Timestamp of annotation
    time timestamp
    
    uint8 UNKNOWN=0
    uint8 POINTS=1
    uint8 LINE_LOOP=2
    uint8 LINE_STRIP=3
    uint8 LINE_LIST=4
    
    # Type of points annotation to draw
    uint8 type
    
    # Points in 2D image coordinates
    foxglove_msgs/Point2[] points
    
    # Outline color
    foxglove_msgs/Color outline_color
    
    # Per-point colors, if `type` is `POINTS`, or per-segment stroke colors, if `type` is `LINE_LIST`.
    foxglove_msgs/Color[] outline_colors
    
    # Fill color
    foxglove_msgs/Color fill_color
    
    # Stroke thickness
    float64 thickness
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new ImageAnnotations(null);
    if (msg.circles !== undefined) {
      resolved.circles = new Array(msg.circles.length);
      for (let i = 0; i < resolved.circles.length; ++i) {
        resolved.circles[i] = CircleAnnotation.Resolve(msg.circles[i]);
      }
    }
    else {
      resolved.circles = []
    }

    if (msg.points !== undefined) {
      resolved.points = new Array(msg.points.length);
      for (let i = 0; i < resolved.points.length; ++i) {
        resolved.points[i] = PointsAnnotation.Resolve(msg.points[i]);
      }
    }
    else {
      resolved.points = []
    }

    return resolved;
    }
};

module.exports = ImageAnnotations;
