// Auto-generated. Do not edit!

// (in-package foxglove_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let Color = require('./Color.js');
let geometry_msgs = _finder('geometry_msgs');

//-----------------------------------------------------------

class ModelPrimitive {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.pose = null;
      this.scale = null;
      this.color = null;
      this.override_color = null;
      this.url = null;
      this.media_type = null;
      this.data = null;
    }
    else {
      if (initObj.hasOwnProperty('pose')) {
        this.pose = initObj.pose
      }
      else {
        this.pose = new geometry_msgs.msg.Pose();
      }
      if (initObj.hasOwnProperty('scale')) {
        this.scale = initObj.scale
      }
      else {
        this.scale = new geometry_msgs.msg.Vector3();
      }
      if (initObj.hasOwnProperty('color')) {
        this.color = initObj.color
      }
      else {
        this.color = new Color();
      }
      if (initObj.hasOwnProperty('override_color')) {
        this.override_color = initObj.override_color
      }
      else {
        this.override_color = false;
      }
      if (initObj.hasOwnProperty('url')) {
        this.url = initObj.url
      }
      else {
        this.url = '';
      }
      if (initObj.hasOwnProperty('media_type')) {
        this.media_type = initObj.media_type
      }
      else {
        this.media_type = '';
      }
      if (initObj.hasOwnProperty('data')) {
        this.data = initObj.data
      }
      else {
        this.data = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type ModelPrimitive
    // Serialize message field [pose]
    bufferOffset = geometry_msgs.msg.Pose.serialize(obj.pose, buffer, bufferOffset);
    // Serialize message field [scale]
    bufferOffset = geometry_msgs.msg.Vector3.serialize(obj.scale, buffer, bufferOffset);
    // Serialize message field [color]
    bufferOffset = Color.serialize(obj.color, buffer, bufferOffset);
    // Serialize message field [override_color]
    bufferOffset = _serializer.bool(obj.override_color, buffer, bufferOffset);
    // Serialize message field [url]
    bufferOffset = _serializer.string(obj.url, buffer, bufferOffset);
    // Serialize message field [media_type]
    bufferOffset = _serializer.string(obj.media_type, buffer, bufferOffset);
    // Serialize message field [data]
    bufferOffset = _arraySerializer.uint8(obj.data, buffer, bufferOffset, null);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type ModelPrimitive
    let len;
    let data = new ModelPrimitive(null);
    // Deserialize message field [pose]
    data.pose = geometry_msgs.msg.Pose.deserialize(buffer, bufferOffset);
    // Deserialize message field [scale]
    data.scale = geometry_msgs.msg.Vector3.deserialize(buffer, bufferOffset);
    // Deserialize message field [color]
    data.color = Color.deserialize(buffer, bufferOffset);
    // Deserialize message field [override_color]
    data.override_color = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [url]
    data.url = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [media_type]
    data.media_type = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [data]
    data.data = _arrayDeserializer.uint8(buffer, bufferOffset, null)
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += object.url.length;
    length += object.media_type.length;
    length += object.data.length;
    return length + 125;
  }

  static datatype() {
    // Returns string type for a message object
    return 'foxglove_msgs/ModelPrimitive';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'da16edf657feee05cf9ccf39dec781a1';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # foxglove_msgs/ModelPrimitive
    # A primitive representing a 3D model file loaded from an external URL or embedded data
    
    # Generated by https://github.com/foxglove/schemas
    
    # Origin of model relative to reference frame
    geometry_msgs/Pose pose
    
    # Scale factor to apply to the model along each axis
    geometry_msgs/Vector3 scale
    
    # Solid color to use for the whole model if `override_color` is true.
    foxglove_msgs/Color color
    
    # Whether to use the color specified in `color` instead of any materials embedded in the original model.
    bool override_color
    
    # URL pointing to model file. One of `url` or `data` should be provided.
    string url
    
    # [Media type](https://developer.mozilla.org/en-US/docs/Web/HTTP/Basics_of_HTTP/MIME_types) of embedded model (e.g. `model/gltf-binary`). Required if `data` is provided instead of `url`. Overrides the inferred media type if `url` is provided.
    string media_type
    
    # Embedded model. One of `url` or `data` should be provided. If `data` is provided, `media_type` must be set to indicate the type of the data.
    uint8[] data
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    ================================================================================
    MSG: geometry_msgs/Vector3
    # This represents a vector in free space. 
    # It is only meant to represent a direction. Therefore, it does not
    # make sense to apply a translation to it (e.g., when applying a 
    # generic rigid transformation to a Vector3, tf2 will only apply the
    # rotation). If you want your data to be translatable too, use the
    # geometry_msgs/Point message instead.
    
    float64 x
    float64 y
    float64 z
    ================================================================================
    MSG: foxglove_msgs/Color
    # foxglove_msgs/Color
    # A color in RGBA format
    
    # Generated by https://github.com/foxglove/schemas
    
    # Red value between 0 and 1
    float64 r
    
    # Green value between 0 and 1
    float64 g
    
    # Blue value between 0 and 1
    float64 b
    
    # Alpha value between 0 and 1
    float64 a
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new ModelPrimitive(null);
    if (msg.pose !== undefined) {
      resolved.pose = geometry_msgs.msg.Pose.Resolve(msg.pose)
    }
    else {
      resolved.pose = new geometry_msgs.msg.Pose()
    }

    if (msg.scale !== undefined) {
      resolved.scale = geometry_msgs.msg.Vector3.Resolve(msg.scale)
    }
    else {
      resolved.scale = new geometry_msgs.msg.Vector3()
    }

    if (msg.color !== undefined) {
      resolved.color = Color.Resolve(msg.color)
    }
    else {
      resolved.color = new Color()
    }

    if (msg.override_color !== undefined) {
      resolved.override_color = msg.override_color;
    }
    else {
      resolved.override_color = false
    }

    if (msg.url !== undefined) {
      resolved.url = msg.url;
    }
    else {
      resolved.url = ''
    }

    if (msg.media_type !== undefined) {
      resolved.media_type = msg.media_type;
    }
    else {
      resolved.media_type = ''
    }

    if (msg.data !== undefined) {
      resolved.data = msg.data;
    }
    else {
      resolved.data = []
    }

    return resolved;
    }
};

module.exports = ModelPrimitive;
