// Auto-generated. Do not edit!

// (in-package foxglove_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let SceneEntityDeletion = require('./SceneEntityDeletion.js');
let SceneEntity = require('./SceneEntity.js');

//-----------------------------------------------------------

class SceneEntityUpdate {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.deletions = null;
      this.entities = null;
    }
    else {
      if (initObj.hasOwnProperty('deletions')) {
        this.deletions = initObj.deletions
      }
      else {
        this.deletions = [];
      }
      if (initObj.hasOwnProperty('entities')) {
        this.entities = initObj.entities
      }
      else {
        this.entities = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type SceneEntityUpdate
    // Serialize message field [deletions]
    // Serialize the length for message field [deletions]
    bufferOffset = _serializer.uint32(obj.deletions.length, buffer, bufferOffset);
    obj.deletions.forEach((val) => {
      bufferOffset = SceneEntityDeletion.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [entities]
    // Serialize the length for message field [entities]
    bufferOffset = _serializer.uint32(obj.entities.length, buffer, bufferOffset);
    obj.entities.forEach((val) => {
      bufferOffset = SceneEntity.serialize(val, buffer, bufferOffset);
    });
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type SceneEntityUpdate
    let len;
    let data = new SceneEntityUpdate(null);
    // Deserialize message field [deletions]
    // Deserialize array length for message field [deletions]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.deletions = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.deletions[i] = SceneEntityDeletion.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [entities]
    // Deserialize array length for message field [entities]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.entities = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.entities[i] = SceneEntity.deserialize(buffer, bufferOffset)
    }
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    object.deletions.forEach((val) => {
      length += SceneEntityDeletion.getMessageSize(val);
    });
    object.entities.forEach((val) => {
      length += SceneEntity.getMessageSize(val);
    });
    return length + 8;
  }

  static datatype() {
    // Returns string type for a message object
    return 'foxglove_msgs/SceneEntityUpdate';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '59bc58a3679e8fc3874b14b39276e03a';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # foxglove_msgs/SceneEntityUpdate
    # An update to the entities displayed in a 3D scene
    
    # Generated by https://github.com/foxglove/schemas
    
    # Scene entities to delete
    foxglove_msgs/SceneEntityDeletion[] deletions
    
    # Scene entities to add or replace
    foxglove_msgs/SceneEntity[] entities
    
    ================================================================================
    MSG: foxglove_msgs/SceneEntityDeletion
    # foxglove_msgs/SceneEntityDeletion
    # Command to remove previously published entities
    
    # Generated by https://github.com/foxglove/schemas
    
    # Timestamp of the deletion. Only matching entities earlier than this timestamp will be deleted.
    time timestamp
    
    # Delete the existing entity on the same topic that has the provided `id`
    uint8 MATCHING_ID=0
    
    # Delete all existing entities on the same topic
    uint8 ALL=1
    
    # Type of deletion action to perform
    uint8 type
    
    # Identifier which must match if `type` is `MATCHING_ID`.
    string id
    
    ================================================================================
    MSG: foxglove_msgs/SceneEntity
    # foxglove_msgs/SceneEntity
    # A visual element in a 3D scene. An entity may be composed of multiple primitives which all share the same frame of reference.
    
    # Generated by https://github.com/foxglove/schemas
    
    # Timestamp of the entity
    time timestamp
    
    # Frame of reference
    string frame_id
    
    # Identifier for the entity. A entity will replace any prior entity on the same topic with the same `id`.
    string id
    
    # Length of time (relative to `timestamp`) after which the entity should be automatically removed. Zero value indicates the entity should remain visible until it is replaced or deleted.
    duration lifetime
    
    # Whether the entity should keep its location in the fixed frame (false) or follow the frame specified in `frame_id` as it moves relative to the fixed frame (true)
    bool frame_locked
    
    # Additional user-provided metadata associated with the entity. Keys must be unique.
    foxglove_msgs/KeyValuePair[] metadata
    
    # Arrow primitives
    foxglove_msgs/ArrowPrimitive[] arrows
    
    # Cube primitives
    foxglove_msgs/CubePrimitive[] cubes
    
    # Sphere primitives
    foxglove_msgs/SpherePrimitive[] spheres
    
    # Cylinder primitives
    foxglove_msgs/CylinderPrimitive[] cylinders
    
    # Line primitives
    foxglove_msgs/LinePrimitive[] lines
    
    # Triangle list primitives
    foxglove_msgs/TriangleListPrimitive[] triangles
    
    # Text primitives
    foxglove_msgs/TextPrimitive[] texts
    
    # Model primitives
    foxglove_msgs/ModelPrimitive[] models
    
    ================================================================================
    MSG: foxglove_msgs/KeyValuePair
    # foxglove_msgs/KeyValuePair
    # A key with its associated value
    
    # Generated by https://github.com/foxglove/schemas
    
    # Key
    string key
    
    # Value
    string value
    
    ================================================================================
    MSG: foxglove_msgs/ArrowPrimitive
    # foxglove_msgs/ArrowPrimitive
    # A primitive representing an arrow
    
    # Generated by https://github.com/foxglove/schemas
    
    # Position of the arrow's tail and orientation of the arrow. Identity orientation means the arrow points in the +x direction.
    geometry_msgs/Pose pose
    
    # Length of the arrow shaft
    float64 shaft_length
    
    # Diameter of the arrow shaft
    float64 shaft_diameter
    
    # Length of the arrow head
    float64 head_length
    
    # Diameter of the arrow head
    float64 head_diameter
    
    # Color of the arrow
    foxglove_msgs/Color color
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    ================================================================================
    MSG: foxglove_msgs/Color
    # foxglove_msgs/Color
    # A color in RGBA format
    
    # Generated by https://github.com/foxglove/schemas
    
    # Red value between 0 and 1
    float64 r
    
    # Green value between 0 and 1
    float64 g
    
    # Blue value between 0 and 1
    float64 b
    
    # Alpha value between 0 and 1
    float64 a
    
    ================================================================================
    MSG: foxglove_msgs/CubePrimitive
    # foxglove_msgs/CubePrimitive
    # A primitive representing a cube or rectangular prism
    
    # Generated by https://github.com/foxglove/schemas
    
    # Position of the center of the cube and orientation of the cube
    geometry_msgs/Pose pose
    
    # Size of the cube along each axis
    geometry_msgs/Vector3 size
    
    # Color of the cube
    foxglove_msgs/Color color
    
    ================================================================================
    MSG: geometry_msgs/Vector3
    # This represents a vector in free space. 
    # It is only meant to represent a direction. Therefore, it does not
    # make sense to apply a translation to it (e.g., when applying a 
    # generic rigid transformation to a Vector3, tf2 will only apply the
    # rotation). If you want your data to be translatable too, use the
    # geometry_msgs/Point message instead.
    
    float64 x
    float64 y
    float64 z
    ================================================================================
    MSG: foxglove_msgs/SpherePrimitive
    # foxglove_msgs/SpherePrimitive
    # A primitive representing a sphere or ellipsoid
    
    # Generated by https://github.com/foxglove/schemas
    
    # Position of the center of the sphere and orientation of the sphere
    geometry_msgs/Pose pose
    
    # Size (diameter) of the sphere along each axis
    geometry_msgs/Vector3 size
    
    # Color of the sphere
    foxglove_msgs/Color color
    
    ================================================================================
    MSG: foxglove_msgs/CylinderPrimitive
    # foxglove_msgs/CylinderPrimitive
    # A primitive representing a cylinder, elliptic cylinder, or truncated cone
    
    # Generated by https://github.com/foxglove/schemas
    
    # Position of the center of the cylinder and orientation of the cylinder. The flat face(s) are perpendicular to the z-axis.
    geometry_msgs/Pose pose
    
    # Size of the cylinder's bounding box
    geometry_msgs/Vector3 size
    
    # 0-1, ratio of the diameter of the cylinder's bottom face (min z) to the bottom of the bounding box
    float64 bottom_scale
    
    # 0-1, ratio of the diameter of the cylinder's top face (max z) to the top of the bounding box
    float64 top_scale
    
    # Color of the cylinder
    foxglove_msgs/Color color
    
    ================================================================================
    MSG: foxglove_msgs/LinePrimitive
    # foxglove_msgs/LinePrimitive
    # A primitive representing a series of points connected by lines
    
    # Generated by https://github.com/foxglove/schemas
    
    # 0-1, 1-2, ..., (n-1)-n
    uint8 LINE_STRIP=0
    
    # 0-1, 1-2, ..., (n-1)-n, n-0
    uint8 LINE_LOOP=1
    
    # 0-1, 2-3, 4-5, ...
    uint8 LINE_LIST=2
    
    # Drawing primitive to use for lines
    uint8 type
    
    # Origin of lines relative to reference frame
    geometry_msgs/Pose pose
    
    # Line thickness
    float64 thickness
    
    # Indicates whether `thickness` is a fixed size in screen pixels (true), or specified in world coordinates and scales with distance from the camera (false)
    bool scale_invariant
    
    # Points along the line
    geometry_msgs/Point[] points
    
    # Solid color to use for the whole line. One of `color` or `colors` must be provided.
    foxglove_msgs/Color color
    
    # Per-point colors (if specified, must have the same length as `points`). One of `color` or `colors` must be provided.
    foxglove_msgs/Color[] colors
    
    # Indices into the `points` and `colors` attribute arrays, which can be used to avoid duplicating attribute data.
    # 
    # If omitted or empty, indexing will not be used. This default behavior is equivalent to specifying [0, 1, ..., N-1] for the indices (where N is the number of `points` provided).
    uint32[] indices
    
    ================================================================================
    MSG: foxglove_msgs/TriangleListPrimitive
    # foxglove_msgs/TriangleListPrimitive
    # A primitive representing a set of triangles or a surface tiled by triangles
    
    # Generated by https://github.com/foxglove/schemas
    
    # Origin of triangles relative to reference frame
    geometry_msgs/Pose pose
    
    # Vertices to use for triangles, interpreted as a list of triples (0-1-2, 3-4-5, ...)
    geometry_msgs/Point[] points
    
    # Solid color to use for the whole shape. One of `color` or `colors` must be provided.
    foxglove_msgs/Color color
    
    # Per-vertex colors (if specified, must have the same length as `points`). One of `color` or `colors` must be provided.
    foxglove_msgs/Color[] colors
    
    # Indices into the `points` and `colors` attribute arrays, which can be used to avoid duplicating attribute data.
    # 
    # If omitted or empty, indexing will not be used. This default behavior is equivalent to specifying [0, 1, ..., N-1] for the indices (where N is the number of `points` provided).
    uint32[] indices
    
    ================================================================================
    MSG: foxglove_msgs/TextPrimitive
    # foxglove_msgs/TextPrimitive
    # A primitive representing a text label
    
    # Generated by https://github.com/foxglove/schemas
    
    # Position of the center of the text box and orientation of the text. Identity orientation means the text is oriented in the xy-plane and flows from -x to +x.
    geometry_msgs/Pose pose
    
    # Whether the text should respect `pose.orientation` (false) or always face the camera (true)
    bool billboard
    
    # Font size (height of one line of text)
    float64 font_size
    
    # Indicates whether `font_size` is a fixed size in screen pixels (true), or specified in world coordinates and scales with distance from the camera (false)
    bool scale_invariant
    
    # Color of the text
    foxglove_msgs/Color color
    
    # Text
    string text
    
    ================================================================================
    MSG: foxglove_msgs/ModelPrimitive
    # foxglove_msgs/ModelPrimitive
    # A primitive representing a 3D model file loaded from an external URL or embedded data
    
    # Generated by https://github.com/foxglove/schemas
    
    # Origin of model relative to reference frame
    geometry_msgs/Pose pose
    
    # Scale factor to apply to the model along each axis
    geometry_msgs/Vector3 scale
    
    # Solid color to use for the whole model if `override_color` is true.
    foxglove_msgs/Color color
    
    # Whether to use the color specified in `color` instead of any materials embedded in the original model.
    bool override_color
    
    # URL pointing to model file. One of `url` or `data` should be provided.
    string url
    
    # [Media type](https://developer.mozilla.org/en-US/docs/Web/HTTP/Basics_of_HTTP/MIME_types) of embedded model (e.g. `model/gltf-binary`). Required if `data` is provided instead of `url`. Overrides the inferred media type if `url` is provided.
    string media_type
    
    # Embedded model. One of `url` or `data` should be provided. If `data` is provided, `media_type` must be set to indicate the type of the data.
    uint8[] data
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new SceneEntityUpdate(null);
    if (msg.deletions !== undefined) {
      resolved.deletions = new Array(msg.deletions.length);
      for (let i = 0; i < resolved.deletions.length; ++i) {
        resolved.deletions[i] = SceneEntityDeletion.Resolve(msg.deletions[i]);
      }
    }
    else {
      resolved.deletions = []
    }

    if (msg.entities !== undefined) {
      resolved.entities = new Array(msg.entities.length);
      for (let i = 0; i < resolved.entities.length; ++i) {
        resolved.entities[i] = SceneEntity.Resolve(msg.entities[i]);
      }
    }
    else {
      resolved.entities = []
    }

    return resolved;
    }
};

module.exports = SceneEntityUpdate;
