// Auto-generated. Do not edit!

// (in-package foxglove_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let Color = require('./Color.js');
let geometry_msgs = _finder('geometry_msgs');

//-----------------------------------------------------------

class TextMarker {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.pose = null;
      this.billboard = null;
      this.font_size = null;
      this.scale_invariant = null;
      this.color = null;
      this.text = null;
    }
    else {
      if (initObj.hasOwnProperty('pose')) {
        this.pose = initObj.pose
      }
      else {
        this.pose = new geometry_msgs.msg.Pose();
      }
      if (initObj.hasOwnProperty('billboard')) {
        this.billboard = initObj.billboard
      }
      else {
        this.billboard = false;
      }
      if (initObj.hasOwnProperty('font_size')) {
        this.font_size = initObj.font_size
      }
      else {
        this.font_size = 0.0;
      }
      if (initObj.hasOwnProperty('scale_invariant')) {
        this.scale_invariant = initObj.scale_invariant
      }
      else {
        this.scale_invariant = false;
      }
      if (initObj.hasOwnProperty('color')) {
        this.color = initObj.color
      }
      else {
        this.color = new Color();
      }
      if (initObj.hasOwnProperty('text')) {
        this.text = initObj.text
      }
      else {
        this.text = '';
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type TextMarker
    // Serialize message field [pose]
    bufferOffset = geometry_msgs.msg.Pose.serialize(obj.pose, buffer, bufferOffset);
    // Serialize message field [billboard]
    bufferOffset = _serializer.bool(obj.billboard, buffer, bufferOffset);
    // Serialize message field [font_size]
    bufferOffset = _serializer.float64(obj.font_size, buffer, bufferOffset);
    // Serialize message field [scale_invariant]
    bufferOffset = _serializer.bool(obj.scale_invariant, buffer, bufferOffset);
    // Serialize message field [color]
    bufferOffset = Color.serialize(obj.color, buffer, bufferOffset);
    // Serialize message field [text]
    bufferOffset = _serializer.string(obj.text, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type TextMarker
    let len;
    let data = new TextMarker(null);
    // Deserialize message field [pose]
    data.pose = geometry_msgs.msg.Pose.deserialize(buffer, bufferOffset);
    // Deserialize message field [billboard]
    data.billboard = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [font_size]
    data.font_size = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [scale_invariant]
    data.scale_invariant = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [color]
    data.color = Color.deserialize(buffer, bufferOffset);
    // Deserialize message field [text]
    data.text = _deserializer.string(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += object.text.length;
    return length + 102;
  }

  static datatype() {
    // Returns string type for a message object
    return 'foxglove_msgs/TextMarker';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'bec1b8536471438a5b2697ab2d6c5ca1';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # foxglove_msgs/TextMarker
    # A marker representing a text label
    
    # Generated by https://github.com/foxglove/schemas
    
    # Position of the center of the text box and orientation of the text. Identity orientation means the text is oriented in the xy-plane and flows from -x to +x.
    geometry_msgs/Pose pose
    
    # Whether the text should respect `pose.orientation` (false) or always face the camera (true)
    bool billboard
    
    # Font size (height of one line of text)
    float64 font_size
    
    # Indicates whether `font_size` is a fixed size in screen pixels (true), or specified in world coordinates and scales with distance from the camera (false)
    bool scale_invariant
    
    # Color of the text
    foxglove_msgs/Color color
    
    # Text
    string text
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    ================================================================================
    MSG: foxglove_msgs/Color
    # foxglove_msgs/Color
    # A color in RGBA format
    
    # Generated by https://github.com/foxglove/schemas
    
    # Red value between 0 and 1
    float64 r
    
    # Green value between 0 and 1
    float64 g
    
    # Blue value between 0 and 1
    float64 b
    
    # Alpha value between 0 and 1
    float64 a
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new TextMarker(null);
    if (msg.pose !== undefined) {
      resolved.pose = geometry_msgs.msg.Pose.Resolve(msg.pose)
    }
    else {
      resolved.pose = new geometry_msgs.msg.Pose()
    }

    if (msg.billboard !== undefined) {
      resolved.billboard = msg.billboard;
    }
    else {
      resolved.billboard = false
    }

    if (msg.font_size !== undefined) {
      resolved.font_size = msg.font_size;
    }
    else {
      resolved.font_size = 0.0
    }

    if (msg.scale_invariant !== undefined) {
      resolved.scale_invariant = msg.scale_invariant;
    }
    else {
      resolved.scale_invariant = false
    }

    if (msg.color !== undefined) {
      resolved.color = Color.Resolve(msg.color)
    }
    else {
      resolved.color = new Color()
    }

    if (msg.text !== undefined) {
      resolved.text = msg.text;
    }
    else {
      resolved.text = ''
    }

    return resolved;
    }
};

module.exports = TextMarker;
